/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { List$1 } from "igniteui-react-core";
import { Number_$type, typeCast, runOn, markType, markDep, getEnumerator, Point_$type, fromEnum } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { SafeEnumerable } from "./SafeEnumerable";
import { TrendCalculators } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { Flattener } from "igniteui-react-core";
/**
 * @hidden
 */
export let BollingerBandsOverlay = /*@__PURE__*/ (() => {
    class BollingerBandsOverlay extends FinancialOverlay {
        bb() {
            return new BollingerBandsOverlay();
        }
        constructor() {
            super();
            this.zn = 0;
            this.zo = 0;
            this.zl = new List$1(Number_$type, 0);
            this.zm = new List$1(Number_$type, 0);
            this.ab = BollingerBandsOverlay.$;
            this.vp = new CategoryFrame(4);
            this.vr = new CategoryFrame(4);
            this.vn = new CategoryFrame(4);
        }
        p5(a, b, c, d) {
            if (this.w4().contains(b)) {
                this.zf = false;
            }
            super.p5(a, b, c, d);
            switch (b) {
                case BollingerBandsOverlay.$$p[1]:
                    this.zf = false;
                    this.qm(false);
                    break;
                case BollingerBandsOverlay.$$p[0]:
                    this.qm(false);
                    break;
            }
        }
        zg() {
            this.zl.clear();
            this.zm.clear();
            let a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.w3), this.zq));
            let b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.w3), this.zq));
            this.zo = 1.7976931348623157E+308;
            this.zn = -1.7976931348623157E+308;
            let c = true;
            let d = true;
            let e = this.zp;
            while (c || d) {
                if (a.moveNext()) {
                    this.zl.add(a.current);
                }
                else {
                    c = false;
                }
                if (b.moveNext()) {
                    this.zm.add(b.current);
                }
                else {
                    d = false;
                }
                if (c && d) {
                    this.zo = Math.min(this.zo, a.current - b.current * e);
                    this.zn = Math.max(this.zn, a.current + b.current * e);
                }
            }
            return true;
        }
        aq(a) {
            if (this.zl == null || this.zm == null || a == null || this.dd == null || a != this.v4) {
                return null;
            }
            let b = new AxisRange(this.zo, this.zn);
            return b;
        }
        yr(a, b) {
            super.yr(a, b);
            let c = b.by;
            let d = b.bx;
            let e = this.getEffectiveViewport1(b);
            let f = this.vl;
            let g = this.v4;
            let h = new ScalerParams(0, c, d, f.ch, e);
            let i = new ScalerParams(0, c, d, g.ch, e);
            a.f.clear();
            a.n.clear();
            a.q.clear();
            let j = typeCast(ISortingAxis_$type, this.vl);
            if (j != null && j.i$b.count != this.dd.count) {
                return;
            }
            let k = 0;
            k = this.xc(c, d, e);
            if (!this.zf) {
                this.zf = this.zg();
                if (this.v4 != null) {
                    this.v4.c2(true);
                }
            }
            i.b = this.id();
            let l = this.vl.em(2, h) - this.vl.em(1, h);
            for (let m = b.b0.c; m <= b.b0.d; ++m) {
                let n;
                if (j == null) {
                    n = b.b0.getBucket(m);
                }
                else {
                    let o = j.i$b._inner[m];
                    let p = j.i$d(o);
                    let q = this.zl._inner[m];
                    let r = this.zm._inner[m];
                    let s = q;
                    let t = r;
                    let u = p;
                    let v = 1;
                    while (m < b.b0.d) {
                        o = j.i$b._inner[m + 1];
                        u = j.i$d(o);
                        if (u - p > l) {
                            break;
                        }
                        m++;
                        s += this.zl._inner[m];
                        t += this.zm._inner[m];
                        v++;
                    }
                    s /= v;
                    t /= v;
                    let w = s - t * this.zp;
                    let x = s;
                    let y = s + t * this.zp;
                    let z = NaN;
                    if (!isNaN_(p)) {
                        z = this.vl.ej(p, h);
                    }
                    n = [z, w, x, y];
                }
                let aa = Math.max(1, l);
                if (!isNaN_(n[0]) && m * aa >= this.zh) {
                    if (this.vl != null && typeCast(ISortingAxis_$type, this.vl) !== null) {
                        n[0] = n[0] + k;
                    }
                    else {
                        n[0] = f.ej(n[0], h) + k;
                    }
                    n[1] = g.ej(n[1], i);
                    n[2] = g.ej(n[2], i);
                    n[3] = g.ej(n[3], i);
                    a.f.add(n);
                }
            }
        }
        n7(a, b) {
            super.n7(a, b);
            let c = b;
            if (c != null) {
                c.b7();
            }
        }
        il(a, b, c) {
            if (this.zl == null) {
                return super.il(a, b, c);
            }
            let d = this.getEffectiveViewport1(this.cl);
            let e = this.xc(this.cl.by, this.cl.bx, d);
            let f = new ScalerParams(0, this.cl.by, this.cl.bx, this.vl.ch, d);
            f.c = this.c1.vw;
            return this.io(this.zl, a, this.vl, f, e, runOn(this, this.xb), b, c);
        }
        jq(a, b) {
            if (this.zl == null) {
                return super.jq(a, b);
            }
            return this.jr(a, b, this.vl, runOn(this, this.xb), this.zl);
        }
        jo(a, b) {
            if (this.zl == null) {
                return super.jo(a, b);
            }
            return this.jp(a, b, this.vl, runOn(this, this.xb), this.zl);
        }
        gw(a, b, c) {
            let d = super.gw(a, b, c);
            if (!this.wu(this.w4())) {
                d = false;
            }
            return d;
        }
        yt(a, b) {
            super.yt(a, b);
            let c = typeCast(BollingerBandsOverlayView.$, b);
            let d = this.getEffectiveViewport1(b);
            if (b.b3(a)) {
                c.b7();
                let e = a.f.count;
                let f = (g) => a.f._inner[g][0];
                let g = (h) => a.f._inner[e - 1 - h][0];
                let h = (i) => a.f._inner[i][1];
                let i = (j) => a.f._inner[j][2];
                let j = (k) => a.f._inner[e - 1 - k][3];
                c.b8(e, f, g, h, i, j);
                b.b5(a);
            }
            this.vu.a2(this, this.wt(), runOn(this, this.vd), this.xi(b), this.xk(b));
            let k = false;
            let l = this.vu.b;
            let m = a.f;
            let n = this.dd.count;
            if (l != null) {
                k = true;
            }
            if (k) {
                let o = new ScalerParams(0, b.by, b.bx, this.vl.ch, d);
                this.yq(m, -1, n, this.vl, o, b.q, -1);
            }
            let p = c.cf;
            let q = c.cg;
            let r = c.ch;
            let s = c.ca;
            this.vu.ad(q, true, false, true, true);
            this.vu.an = null;
            this.vu.am = null;
            this.vu.ad(p, true, false, false, true);
            this.vu.ad(r, true, false, false, true);
            this.vu.ad(s, false, true, false, false);
            s._opacity = this.vu.j * this.hq;
        }
        ci() {
            return new BollingerBandsOverlayView(this);
        }
        px(a) {
            super.px(a);
            this.zk = typeCast(BollingerBandsOverlayView.$, a);
        }
        xl() {
            return 3;
        }
        id() {
            return Series.ig(this.zl, null);
        }
    }
    BollingerBandsOverlay.$t = /*@__PURE__*/ markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
    BollingerBandsOverlay.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:zp:zt', [1, 2], 'Period:zq:zu', [1, 14]]);
    return BollingerBandsOverlay;
})();
/**
 * @hidden
 */
export let BollingerBandsBucketCalculator = /*@__PURE__*/ (() => {
    class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = a * this.b;
            let c = Math.min(b + this.b - 1, this.a.b2.dd.count - 1);
            if (b <= c) {
                let d = this.f.b6.zp;
                let e = 0;
                let f = 0;
                let g = 0;
                for (let h = b; h <= c; ++h) {
                    if (!isNaN_(this.f.b6.zl._inner[h]) && !isNaN_(this.f.b6.zm._inner[h])) {
                        e += this.f.b6.zl._inner[h];
                        f += this.f.b6.zm._inner[h];
                        ++g;
                    }
                }
                if (g > 0) {
                    e = e / g;
                    f = f / g;
                    return [0.5 * (b + c), e - f * d, e, e + f * d];
                }
            }
            return [NaN, NaN, NaN, NaN];
        }
    }
    BollingerBandsBucketCalculator.$t = /*@__PURE__*/ markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
    return BollingerBandsBucketCalculator;
})();
/**
 * @hidden
 */
export let BollingerBandsOverlayView = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.b6 = null;
            this.cb = new Polygon();
            this.ci = new Polyline();
            this.cj = new Polyline();
            this.ck = new Polyline();
            this.b9 = new Polygon();
            this.cc = new Polyline();
            this.cd = new Polyline();
            this.ce = new Polyline();
            this.b6 = a;
        }
        au() {
            super.au();
            if (!this.q) {
            }
        }
        b1() {
            return new BollingerBandsBucketCalculator(this);
        }
        b8(a, b, c, d, e, f) {
            for (let g of fromEnum(Flattener.d(a, b, d, this.e.hu))) {
                this.cb.an.add({ $type: Point_$type, x: b(g), y: d(g) });
                this.ci.an.add({ $type: Point_$type, x: b(g), y: d(g) });
            }
            for (let h of fromEnum(Flattener.d(a, b, e, this.e.hu))) {
                this.cj.an.add({ $type: Point_$type, x: b(h), y: e(h) });
            }
            for (let i of fromEnum(Flattener.d(a, c, f, this.e.hu))) {
                this.cb.an.add({ $type: Point_$type, x: c(i), y: f(i) });
                this.ck.an.add({ $type: Point_$type, x: c(i), y: f(i) });
            }
            this.as();
        }
        b7() {
            this.cb.an.clear();
            this.ci.an.clear();
            this.cj.an.clear();
            this.ck.an.clear();
            this.as();
        }
        get ca() {
            return this.cb;
        }
        get cf() {
            return this.ci;
        }
        get cg() {
            return this.cj;
        }
        get ch() {
            return this.ck;
        }
        be() {
            super.be();
            this.b9.an = this.cb.an;
            this.cc.an = this.ci.an;
            this.cd.an = this.cj.an;
            this.ce.an = this.ck.an;
            let a = this.br();
            this.b9._fill = a;
            this.b9._opacity = 1;
            this.cc._stroke = a;
            this.cc.ad = this.e.hv + 3;
            this.cd._stroke = a;
            this.cd.ad = this.e.hv + 3;
            this.ce._stroke = a;
            this.ce.ad = this.e.hv + 3;
        }
        a8(a, b) {
            super.a8(a, b);
            if (a.d) {
                if (b) {
                    a.u(this.b9);
                    a.v(this.cc);
                    a.v(this.cd);
                    a.v(this.ce);
                }
                else {
                    a.u(this.cb);
                    a.v(this.ci);
                    a.v(this.cj);
                    a.v(this.ck);
                }
            }
        }
        an(a) {
            super.an(a);
            this.e.a4.exportPolygonData(a, this.cb, "FillShape", ["Fill"]);
            this.e.a4.exportPolylineData(a, this.ci, "BottomLine", ["Lower", "Main"]);
            this.e.a4.exportPolylineData(a, this.cj, "CentralLine", ["Central"]);
            this.e.a4.exportPolylineData(a, this.ck, "TopLine", ["Upper"]);
        }
    }
    BollingerBandsOverlayView.$t = /*@__PURE__*/ markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
    return BollingerBandsOverlayView;
})();
