/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, markType, Array_$type, Number_$type, Point_$type, enumGetBox, runOn, delegateCombine, fromEnum, markDep } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { ScalerParams } from "./ScalerParams";
import { Series } from "./Series";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-react-core";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { IProvidesViewport_$type } from "./IProvidesViewport";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { PreparationParams } from "./PreparationParams";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { DefaultCategoryTrendlineHost } from "./DefaultCategoryTrendlineHost";
import { DefaultSingleValueProvider } from "./DefaultSingleValueProvider";
import { SingleValuesHolder } from "./SingleValuesHolder";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager_$type } from "./ICategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { Pool$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DoubleCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { round10N } from "igniteui-react-core";
/**
 * @hidden
 */
export let CategoryBucketCalculator = /*@__PURE__*/ (() => {
    class CategoryBucketCalculator extends Base {
        constructor(a) {
            super();
            this.c = null;
            this.e = 0;
            this.f = 0;
            this.d = 0;
            if (a == null) {
                throw new ArgumentNullException(0, "view");
            }
            this.c = a;
            this.e = -1;
            this.d = 0;
        }
        getBucket(a) {
            return null;
        }
        getBucketWithoutUnknowns(a) {
            return this.getBucket(a);
        }
        getErrorBucket(a, b) {
            return NaN;
        }
        g(a) {
            let b = this.c.by;
            let c = this.c.bx;
            let d = this.c.cw;
            let e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
            let f = d.dd;
            if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
                this.d = 0;
                return;
            }
            let g = d.getEffectiveViewport1(this.c);
            let h = d.u1(this.c);
            let i = typeCast(ISortingAxis_$type, e);
            if (i == null || i.i$b == null) {
                let j = new ScalerParams(0, b, c, e.ch, g);
                let k = Math.floor(e.em(h.left, j));
                let l = Math.ceil(e.em(h.right, j));
                if (e.ch) {
                    l = Math.ceil(e.em(h.left, j));
                    k = Math.floor(e.em(h.right, j));
                }
                l = Math.min(l, e.lg - 1);
                let m = Math.floor((l - k + 1) * a / h.width);
                this.d = truncate(Math.max(1, m));
                this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
                this.f = truncate(Math.ceil(l / this.d));
            }
            else {
                this.e = i.i$e(b, c, g, h);
                this.f = i.i$g(b, c, g, h);
                this.d = 1;
            }
        }
        getBucketInfo(a, b, c, d) {
            a = this.e;
            b = this.f;
            c = this.d;
            d = this.c.cw.hu;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d
            };
        }
        cacheValues() {
        }
        unCacheValues() {
        }
    }
    CategoryBucketCalculator.$t = /*@__PURE__*/ markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
    return CategoryBucketCalculator;
})();
/**
 * @hidden
 */
export let CategoryFramePreparerBase = /*@__PURE__*/ (() => {
    class CategoryFramePreparerBase extends FramePreparer {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            let i = d[3];
                            let j = d[4];
                            super(1, g, h, i);
                            this.g = null;
                            this.h = null;
                            this.m = false;
                            this.o = new List$1(Array_$type, 0);
                            this.p = new List$1(Number_$type, 0);
                            this.n = new List$1(Number_$type, 0);
                            this.h = f;
                            this.g = j;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        super(1, d, e, f);
                        this.g = null;
                        this.h = null;
                        this.m = false;
                        this.o = new List$1(Array_$type, 0);
                        this.p = new List$1(Number_$type, 0);
                        this.n = new List$1(Number_$type, 0);
                        this.h = c;
                        this.g = g;
                    }
                    break;
            }
        }
        i(a) {
            let b = new PreparationParams();
            b.f = this.h.useHighMarkerFidelity;
            b.b = this.h.scaler;
            b.c = this.h.yScaler;
            b.d = typeCast(ISortingAxis_$type, b.b);
            b.a = typeCast(CategoryFrame.$, a);
            if (b.a == null || b.b == null || b.c == null) {
                return null;
            }
            let c;
            let d;
            let e;
            let f;
            let g = this.g.getBucketInfo(c, d, e, f);
            c = g.p0;
            d = g.p1;
            e = g.p2;
            f = g.p3;
            b.k = c;
            b.l = d;
            b.j = e;
            b.i = f;
            if (b.l < b.k) {
                return null;
            }
            let h;
            let i;
            let j;
            let k = this.a.getViewInfo(i, h);
            i = k.p0;
            h = k.p1;
            j = this.a.getEffectiveViewport();
            let l = this.a.getMainContentViewport();
            b.p = h;
            b.o = i;
            b.n = j;
            b.m = l;
            if (Rect.l_op_Equality(b.p, Rect.empty) || Rect.l_op_Equality(b.o, Rect.empty)) {
                return null;
            }
            if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.ew) && this.g != null) {
                b.e = true;
            }
            return b;
        }
        r(a, b, c, d) {
            return a.getSeriesOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
        }
        s(a) {
            return this.r(a.b, a.p, a.o, a.n);
        }
        d(a, b) {
            let c = this.i(a);
            if (c == null || this.g == null) {
                return;
            }
            c.a.f.clear();
            c.a.k.clear();
            c.a.n.clear();
            c.a.q.clear();
            c.a.i.clear();
            c.a.h.clear();
            c.a.g.clear();
            if (c.a.m != null) {
                c.a.m.clear();
            }
            let d = this.c.shouldDisplayMarkers;
            let e = false;
            let f = this.s(c);
            let g = this.j(c);
            if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
                return;
            }
            if (c.d != null && c.d.i$a) {
                c.d.i$h();
            }
            this.g.cacheValues();
            if (this.m && c.d != null && c.d.i$b.count > 0) {
                let h = c.d.i$b._inner[c.k];
                this.z(g, h, true, c.e);
                while ((isNaN_(g.c) || isNaN_(g.d)) && c.k > 0) {
                    c.k = c.k - 1;
                    h = c.d.i$b._inner[c.k];
                    this.z(g, h, true, c.e);
                }
                let i = c.d.i$b._inner[c.l];
                this.z(g, i, true, c.e);
                while ((isNaN_(g.c) || isNaN_(g.d)) && c.l < g.e - 1) {
                    c.l = c.l + 1;
                    i = c.d.i$b._inner[c.l];
                    this.z(g, i, true, c.e);
                }
            }
            if (this.m && c.d == null) {
                let j = c.k;
                let k = this.g.getBucket(j);
                while ((isNaN_(k[1]) || isNaN_(k[2])) && c.k > 0) {
                    c.k = c.k - 1;
                    j = c.k;
                    k = this.g.getBucket(j);
                }
                let l = c.l;
                k = this.g.getBucket(l);
                while ((isNaN_(k[1]) || isNaN_(k[2])) && c.l < (intDivide(g.e, c.j))) {
                    c.l = c.l + 1;
                    l = c.l;
                    k = this.g.getBucket(l);
                }
            }
            this.w(c, g, f);
            let m = this.t(c, g, f, d, e);
            this.c.updateMarkerCount(m);
            this.v(typeCast(CategoryFrame.$, a), b);
            this.g.unCacheValues();
            return;
        }
        v(a, b) {
        }
        get q() {
            return this.o;
        }
        t(a, b, c, d, e) {
            let f = 0;
            let g = false;
            let h = null;
            let i = false;
            let j = a.d != null;
            let k = a.p;
            let l = a.o;
            let m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.lj;
            let n = a.f;
            let o = this.h.mayContainUnknowns;
            let p = this.o;
            let q = this.n;
            let r = this.p;
            p.clear();
            q.clear();
            r.clear();
            let s = this.g;
            let t = this.h.provideCollisionDetector();
            let u = 0;
            let v = a.n;
            let w = new ScalerParams(0, k, l, a.b.j$b, v);
            let x = ((() => {
                let $ret = new ScalerParams(0, k, l, a.c.j$b, v);
                $ret.b = typeCast(Series.$, this.h) !== null ? this.h.id() : NaN;
                return $ret;
            })());
            if (j) {
                u = a.b.j$d(2, w) - a.b.j$d(1, w);
                i = this.k();
            }
            let y = a.k;
            let z = a.l;
            let aa = a.a.f;
            let ab = typeCast(IDateTimeAxis_$type, a.b);
            if (ab != null) {
                ab.StartTimeCursor();
            }
            for (let ac = y; ac <= z; ++ac) {
                let ad;
                if (!j) {
                    if (!o) {
                        ad = s.getBucketWithoutUnknowns(ac);
                    }
                    else {
                        ad = s.getBucket(ac);
                    }
                }
                else {
                    ad = ((() => { let ae = this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
                }
                let ae = !m || (m && ad[1] > 0);
                let af = ad[0];
                if (!j || !isNaN_(ad[0])) {
                    aa.add(ad);
                    if (j) {
                        if (a.a.m == null) {
                            a.a.m = new List$1(Number_$type, 0);
                        }
                        a.a.m.add(ac * a.j);
                    }
                    if (g && i) {
                        if (h != null) {
                            aa.add(h);
                            if (j) {
                                if (a.a.m == null) {
                                    a.a.m = new List$1(Number_$type, 0);
                                }
                                a.a.m.add(ac * a.j);
                            }
                        }
                    }
                    if (d && ae) {
                        let ag = ac * a.j;
                        let ah = ag;
                        if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                            ag = a.d.i$b._inner[ag];
                        }
                        let ai = new Array(ad.length);
                        ai[0] = ad[0];
                        ai[1] = ad[1];
                        ai[2] = ad[2];
                        if (n && ag < b.e) {
                            ai = new Array(ad.length);
                            ai[0] = af;
                            this.z(b, ag, true, a.e);
                            ai[1] = b.c;
                            ai[2] = b.d;
                        }
                        p.add(ai);
                        q.add(a.a.f.count - 1);
                        r.add(ag);
                    }
                }
            }
            if (ab != null) {
                ab.ResetTimeCursor();
            }
            this.y(a, c, j, w, x, e, d);
            if (d) {
                let aj = p.count;
                let ak;
                for (let al = 0; al < aj; al++) {
                    ak = p._inner[al];
                    if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                        ++f;
                    }
                }
            }
            return f;
        }
        k() {
            if (typeCast(Series.$, this.h) !== null) {
                return this.h.eg;
            }
            return false;
        }
        f(a, b, c, d, e, f, g) {
            let h;
            f = null;
            e = false;
            let i = typeCast(CategorySeries.$, this.h);
            let j = a.o;
            let k = a.p;
            let l = a.n;
            let m = new ScalerParams(0, k, j, a.b.j$b, l);
            let n = new ScalerParams(0, k, j, a.c.j$b, l);
            let o = a.e;
            if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
                return {
                    ret: [NaN, NaN, NaN],
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            if (i != null && i.dd != null && i.dd.count < a.d.i$b.count) {
                return {
                    ret: [NaN, NaN, NaN],
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            let p = a.d.i$b._inner[b];
            let q = a.d.i$d(p);
            let r = q;
            this.z(c, p, false, o);
            while (b < a.l) {
                p = a.d.i$b._inner[b + 1];
                r = a.d.i$d(p);
                this.z(c, p, true, o);
                if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                    if (e) {
                        let s = a.d.i$b._inner[b];
                        this.z(c, s, true, o);
                        f = [a.b.j$c(q, m), c.c, c.d];
                    }
                    break;
                }
                if (!e && this.k()) {
                    let t = a.d.i$b._inner[b];
                    this.z(c, t, true, o);
                    let u = [a.b.j$c(q, m), c.c, c.d];
                    if (!isNaN_(u[0])) {
                        if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                            if (a.d != null) {
                                u[0] = u[0] + g;
                            }
                            a.a.f.add(u);
                            if (a.d != null) {
                                if (a.a.m == null) {
                                    a.a.m = new List$1(Number_$type, 0);
                                }
                                a.a.m.add(b);
                            }
                            e = true;
                        }
                        else {
                            break;
                        }
                    }
                }
                b++;
                this.u(c, p, o);
            }
            let v = NaN;
            if (!isNaN_(q)) {
                v = a.b.j$c(q, m);
            }
            h = this.e(v, c);
            return {
                ret: h,
                p1: b,
                p4: e,
                p5: f
            };
        }
        y(a, b, c, d, e, f, g) {
            let h = a.j;
            let i = a.a.f.count;
            let j = a.a.f;
            let k = this.o;
            let l = k.count;
            if (f) {
                let m = a.c.j$c(a.c.l7, e);
                a.c.j$f(a.a.k, 0, a.a.k.count, e);
                let n = a.a.k;
                let o = n.count;
                for (let p = 0; p < n.count; p++) {
                    n._inner[p] = Math.abs(n._inner[p] - m);
                }
            }
        }
        w(a, b, c) {
        }
    }
    CategoryFramePreparerBase.$t = /*@__PURE__*/ markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
    return CategoryFramePreparerBase;
})();
/**
 * @hidden
 */
export let CategoryFramePreparer = /*@__PURE__*/ (() => {
    class CategoryFramePreparer extends CategoryFramePreparerBase {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            let i = d[3];
                            let j = d[4];
                            super(1, f, g, h, i, j);
                            this.aa = new DefaultCategoryTrendlineHost();
                            this.ab = new DefaultSingleValueProvider();
                            this.ac = null;
                            this.ad = null;
                            this.ac = this.aa;
                            if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                                this.ac = typeCast(IHasCategoryTrendline_$type, f);
                            }
                            this.ad = this.ab;
                            if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                                this.ad = typeCast(IHasSingleValueCategory_$type, f);
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        super(1, c, d, e, f, g);
                        this.aa = new DefaultCategoryTrendlineHost();
                        this.ab = new DefaultSingleValueProvider();
                        this.ac = null;
                        this.ad = null;
                        this.ac = this.aa;
                        if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                            this.ac = typeCast(IHasCategoryTrendline_$type, c);
                        }
                        this.ad = this.ab;
                        if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                            this.ad = typeCast(IHasSingleValueCategory_$type, c);
                        }
                    }
                    break;
            }
        }
        l(a, b, c, d, e, f) {
            let g = b[0];
            let h = b[1];
            let i = new Rect(0, g - 5, h - 5, 11, 11);
            if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
                a.n.add({ $type: Point_$type, x: g, y: h });
                this.c.updateMarkerTemplate(e, d, f);
                return true;
            }
            return false;
        }
        j(a) {
            let b = new SingleValuesHolder();
            let c = this.ad.valueColumn;
            b.f = c;
            return b;
        }
        x(a, b, c, d, e, f) {
            if (d) {
                b[0] = b[0] + c;
            }
            else {
                b[0] = a.b.j$c(b[0], e) + c;
            }
            b[1] = a.c.j$c(b[1], f);
            if (a.j > 1 || d) {
                b[2] = a.c.j$c(b[2], f);
            }
            else {
                b[2] = b[1];
            }
        }
        y(a, b, c, d, e, f, g) {
            super.y(a, b, c, d, e, f, g);
            let h = a.j;
            let i = a.a.f.count;
            let j = a.a.f;
            let k = this.q;
            let l = k.count;
            let m = new List$1(Number_$type, 0);
            if (!c) {
                m.add(0);
            }
            let n = new List$1(Number_$type, 0);
            n.add(1);
            if (c || h > 1) {
                n.add(2);
            }
            a.b.j$e(j, m, 0, i, d);
            a.c.j$e(j, n, 0, i, e);
            for (let o = 0; o < i; o++) {
                j._inner[o][0] = j._inner[o][0] + b;
            }
            if (h == 1 && !c) {
                for (let p = 0; p < i; p++) {
                    j._inner[p][2] = j._inner[p][1];
                }
            }
            if (g) {
                a.b.j$e(k, m, 0, l, d);
                a.c.j$e(k, n, 0, l, e);
                for (let q = 0; q < l; q++) {
                    k._inner[q][0] = k._inner[q][0] + b;
                }
                if (h == 1 && !c) {
                    for (let r = 0; r < l; r++) {
                        k._inner[r][2] = k._inner[r][1];
                    }
                }
            }
        }
        w(a, b, c) {
            if (this.ac.trendLineType == 0 || this.ac.trendlinePreparer == null || this.ac.trendLinePeriod < 1) {
                return;
            }
            this.ac.trendlinePreparer.prepareLine(this.ac, a, b, c);
        }
        z(a, b, c, d) {
            let e = a;
            let f = e.f;
            let g = f.item(b);
            let h = g;
            if (d) {
                let i = this.g.getBucket(b);
                g = i[1];
                h = i[1];
            }
            if (c) {
                e.c = g;
                e.d = h;
            }
            else {
                e.a = g;
                e.b = h;
            }
        }
        u(a, b, c) {
            let d = a;
            let e = d.f;
            if (b < e.count) {
                let f;
                if (c) {
                    let g = this.g.getBucket(b);
                    f = g[1];
                }
                else {
                    f = e.item(b);
                }
                d.a = Math.min(d.a, f);
                d.b = Math.max(d.b, f);
            }
        }
        e(a, b) {
            let c = b;
            return [a, c.a, c.b];
        }
    }
    CategoryFramePreparer.$t = /*@__PURE__*/ markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
    return CategoryFramePreparer;
})();
/**
 * @hidden
 */
export let CategorySeries = /*@__PURE__*/ (() => {
    class CategorySeries extends MarkerSeries {
        ci() {
            let a = new CategorySeriesView(this);
            return a;
        }
        get xg() {
            if (this.xf == null) {
                this.xf = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, () => this.dg.n);
            }
            return this.xf;
        }
        dz(a, b, c, d) {
            if (!this.hasMarkers) {
                return false;
            }
            let e = this.getEffectiveViewport1(this.cl);
            let f = this.w1();
            let g = new ScalerParams(1, this.c1.vh, this.u9, f.ch);
            g.c = e;
            let h = this.xh();
            let i = new ScalerParams(1, this.c1.vh, this.u9, h.ch);
            i.c = e;
            let j = this.c1.vh;
            let k = this.u9;
            let l = this.currentMode2Index;
            let m = 0;
            if (f.ce && f.cc) {
                m = f.getSeriesOffset(j, k, e, l, f.categoryMode);
            }
            a.clear();
            this.vl.ci((n) => {
                if (n._visibility == 0) {
                    let o = new SeriesPointOfInterest();
                    let p = n.n;
                    let q = n.o;
                    if (p < this.u9.left || p > this.u9.right || q < this.u9.top || q > this.u9.bottom) {
                        return;
                    }
                    if (this.isVertical) {
                        if (f.cb && !f.ce && f.categoryMode != 0) {
                            o.c = n.ak;
                        }
                        else {
                            o.c = f.em(q, g);
                        }
                        o.b = h.em(p, i);
                    }
                    else {
                        if (f.cb && !f.ce && f.categoryMode != 0) {
                            o.b = n.ak;
                        }
                        else {
                            o.b = f.em(p, g);
                        }
                        o.c = h.em(q, i);
                    }
                    o.a = n.content;
                    if (b) {
                        if (this.isVertical) {
                            if (c) {
                                o.d = this.x7(o.b, d);
                            }
                            else {
                                let r = this.it(n);
                                if (!isNaN_(r)) {
                                    o.d = this.x7(r, d);
                                }
                                else {
                                    o.d = this.x7(o.b, d);
                                }
                            }
                        }
                        else {
                            if (c) {
                                o.d = this.x7(o.c, d);
                            }
                            else {
                                let s = this.it(n);
                                if (!isNaN_(s)) {
                                    o.d = this.x7(s, d);
                                }
                                else {
                                    o.d = this.x7(o.c, d);
                                }
                            }
                        }
                    }
                    else {
                        o.d = f.gd(n.ak);
                    }
                    a.add(o);
                }
            });
            return true;
        }
        x7(a, b) {
            if (b >= 0) {
                return round10N(a, b).toString();
            }
            else {
                return a.toString();
            }
        }
        px(a) {
            super.px(a);
            this.xb = a;
        }
        preferredCategoryMode(a) {
            return 0;
        }
        get categoryAxis() {
            return this.w1();
        }
        w1() {
            return this.fetchXAxis();
        }
        xh() {
            return this.fetchYAxis();
        }
        get_d6() {
            return true;
        }
        get_fq() {
            return this.xh() != null && this.xh().ch;
        }
        get_ej() {
            return true;
        }
        constructor() {
            super();
            this.w7 = null;
            this.xf = null;
            this.xo = false;
            this.xn = false;
            this.assigningCategoryStyle = null;
            this.assigningCategoryMarkerStyle = null;
            this.xl = null;
            this.xm = null;
            this.w4 = new CategoryFrame(3);
            this.w6 = new CategoryFrame(3);
            this.w2 = new CategoryFrame(3);
            this.w5 = new CategoryFrame(3);
            this.xa = null;
            this.xe = null;
            this.xa = new CategorySeriesRenderManager();
            this.xe = new CategoryTransitionSourceFramePreparer();
            this.xo = false;
            this.xn = false;
            this.ab = CategorySeries.$;
        }
        ac() {
            super.ac();
            this.xb.cu.g(this.hu);
        }
        xu() {
            return (this.assigningCategoryStyle != null && this.xo) || (this.bo != 1) || (this.cf != 1) || (this.ce != 1);
        }
        xv() {
            return (this.assigningCategoryMarkerStyle != null && this.xn) || (this.bo != 1) || (this.cf != 1) || (this.ce != 1);
        }
        yk(a) {
            if (this.assigningCategoryStyle != null && this.xo) {
                this.assigningCategoryStyle(this, a);
            }
        }
        yj(a) {
            if (this.assigningCategoryMarkerStyle != null && this.xn) {
                this.assigningCategoryMarkerStyle(this, a);
            }
        }
        wv(a, b) {
            return null;
        }
        n7(a, b) {
            super.n7(a, b);
            if (a) {
                this.ye(b);
            }
        }
        bi() {
            let a = super.bi();
            return a;
        }
        o6() {
            super.o6();
            let a = this.fetchXAxis();
            if (a != null) {
                a.h8(false);
            }
            let b = this.fetchYAxis();
            if (b != null) {
                b.h8(false);
            }
        }
        rk(a, b) {
            super.rk(a, b);
            this.xb.cu.g(this.hu);
            this.qm(false);
        }
        rj(a, b) {
            if (this.gk && this.i6 < 0.05 && (this.c1 == null || !this.c1.fh())) {
                this.gl = true;
                this.go = false;
                this.f4 = false;
            }
            super.rj(a, b);
            this.xb.cu.g(this.hu);
            this.qm(false);
        }
        p5(a, b, c, d) {
            super.p5(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    let e = this.fetchYAxis();
                    let f = this.fetchXAxis();
                    if (c != null && d == null) {
                        this.od(f);
                        this.od(e);
                    }
                    if (c == null && d != null) {
                        this.qc(f);
                        this.qc(e);
                    }
                    this.xb.cu.g(this.hu);
                    this.qm(false);
                    break;
                case "SyncLink":
                    if (this.ct != null && this.c1 != null) {
                        this.xb.cu.g(this.hu);
                    }
                    this.qm(false);
                    break;
                case "TransitionProgress":
                    this.w6.c(this.i6, this.w4, this.w2);
                    if (this.dt(this.cl)) {
                        return;
                    }
                    if (this.i6 == 1) {
                        this.w2.w();
                        this.yl(this.w2, this.xb);
                        if (this.gk) {
                            this.gk = false;
                            this.n8();
                            this.c2.r = truncate(this.iq());
                            this.c2.b = this.c3;
                        }
                        if (this.gn) {
                            this.gn = false;
                            this.n8();
                            this.c2.r = truncate(this.iq());
                            this.c2.b = this.c3;
                            this.pw();
                        }
                        this.pk();
                    }
                    else {
                        this.yl(this.w6, this.xb);
                    }
                    if (this.c1 != null) {
                        this.c1.p6(this);
                    }
                    break;
                case "ErrorBarSettings":
                    this.ph();
                    break;
                case CategorySeries.$$p[4]:
                    this.qm(false);
                    break;
                case CategorySeries.$$p[1]:
                    this.xo = this.xq();
                    this.qm(false);
                    break;
                case CategorySeries.$$p[0]:
                    this.xn = this.xp();
                    this.qm(false);
                    break;
            }
        }
        xq() {
            return this.xs;
        }
        xp() {
            return this.xr;
        }
        x1(a) {
            return this.h8(a, this.fetchXAxis());
        }
        get_fd() {
            return typeCast(ISortingAxis_$type, this.w1()) !== null;
        }
        as() {
            return this.w1();
        }
        jl(a) {
            return this.xg.b$d(this, a);
        }
        j2(a) {
            return this.xg.b$f(this, a);
        }
        jj(a) {
            let b = truncate(Math.round(this.h6(a)));
            return b;
        }
        h6(a) {
            return this.xg.b$c(this, a);
        }
        c7(a, b, c) {
            if (this.fk(this.bo) && !c) {
                let d = this.xk(a, b, this.xm);
                this.xm = d;
                return d;
            }
            else {
                let e = this.xi(a, b, this.xm);
                e.d = true;
                this.xm = e;
                return e;
            }
        }
        get_ez() {
            return true;
        }
        n5() {
            super.n5();
            this.xl = null;
            this.xm = null;
        }
        c6(a, b, c) {
            if (this.d1 && this.fk(this.bo) && !c) {
                let d = this.xj(a, b, this.xl);
                this.xl = d;
                return d;
            }
            else {
                let e = this.xi(a, b, this.xl);
                this.xl = e;
                return e;
            }
        }
        x0() {
            return this.xb.cx.a;
        }
        xk(a, b, c) {
            if (!this.vr()) {
                return null;
            }
            let d = this.w3();
            let e = this.x0();
            return this.xg.b$b(this, e, this.x4(this.cl), this.x3(this.cl), d.f, a, b, c);
        }
        xj(a, b, c) {
            let d = this.x4(this.cl);
            let e = this.x5(this.cl);
            let f = this.x3(this.cl);
            let g = this.w3();
            return this.xg.b$a(this, g.f, g.m, d, e, f, a, b, c);
        }
        xi(a, b, c) {
            let d = new HighlightingInfo();
            d.i = this;
            d.g = 0;
            d.f = this.dd != null ? this.dd.count - 1 : 0;
            d.c = true;
            if (c != null && c.g == d.g && c.f == d.f) {
                return c;
            }
            return d;
        }
        w3() {
            let a = this.w2;
            if (this.dr()) {
                if (this.c2.g) {
                    this.c2.t();
                }
                a = this.w6;
            }
            return a;
        }
        yg(a, b, c, d, e, f, g) {
            let h = this.bo != 1;
            let i = this.cf != 1;
            let j = this.ce != 1;
            this.xa.a3(this.xa.d, d.cn, a, b, c, d, e, f, true, g);
            this.xa.aa(this.hs);
            let k = this.xa.ax;
            let l = null;
            let m = this.dd;
            let n = null;
            let o = null;
            let p = null;
            let q = null;
            let r = null;
            if (h && this.c1 != null) {
                l = this.c1.dj.getHighlightingInfo(this, m, k.z, k.y, true);
                if (this.c1.dj.isCrossContextHighlight(this)) {
                    n = this.c1.dj.getHighlightingInfo(this, m, k.z, k.y, true);
                }
                k.c = l;
            }
            if (i && this.c1 != null) {
                o = this.c1.dk.getHighlightingInfo(this, m, k.z, k.y, true);
                if (o == null && this.be != null) {
                    o = this.c1.dk.getHighlightingInfo(this.be, this.be.dd, k.z, k.y, true);
                }
                if (this.c1.dk.isCrossContextHighlight(this)) {
                    q = this.c1.dk.getHighlightingInfo(this, m, k.z, k.y, true);
                }
                k.d = o;
            }
            if (j && this.c1 != null) {
                p = this.c1.di.getHighlightingInfo(this, m, k.z, k.y, true);
                if (this.c1.di.isCrossContextHighlight(this)) {
                    r = this.c1.di.getHighlightingInfo(this, m, k.z, k.y, true);
                }
                k.b = p;
            }
            k.h = f;
            this.yj(k);
            this.xa.y(this, l, o, p, f, h, i, j, k.v, this.c1.dj.totalHighWaterMark, k.x, this.c1.dk.totalHighWaterMark, k.t, this.c1.di.totalHighWaterMark);
        }
        yh(a, b, c, d, e, f, g) {
            let h = this.bo != 1;
            let i = this.cf != 1;
            let j = this.ce != 1;
            this.xa.a3(this.xa.b, d.cn, a, b, c, d, e, f, false, g);
            this.xa.ab(this.hs);
            let k = this.xa.ay;
            let l = null;
            let m = null;
            let n = null;
            let o = this.dd;
            if (h && this.c1 != null) {
                l = this.c1.dj.getHighlightingInfo(this, o, k.z, k.y, false);
                k.c = l;
            }
            if (i && this.c1 != null) {
                m = this.c1.dk.getHighlightingInfo(this, o, k.z, k.y, false);
                if (m == null && this.be != null) {
                    m = this.c1.dk.getHighlightingInfo(this.be, this.be.dd, k.z, k.y, false);
                }
                k.d = m;
            }
            if (j && this.c1 != null) {
                n = this.c1.di.getHighlightingInfo(this, o, k.z, k.y, false);
                if (n == null && this.be != null) {
                    n = this.c1.di.getHighlightingInfo(this.be, this.be.dd, k.z, k.y, false);
                }
                k.b = n;
            }
            k.h = f;
            this.yk(k);
            this.xa.z(this, l, m, n, f, h, i, j, b < 0);
        }
        gw(a, b, c) {
            let d = super.gw(a, b, c);
            d = d && this.xz(this.fetchXAxis());
            d = d && this.xz(this.fetchYAxis());
            let e = c;
            if (!c.o() || b.isEmpty || a.isEmpty || this.dd == null) {
                d = false;
            }
            if (!d) {
                e.cu.d = 0;
            }
            return d;
        }
        xz(a) {
            if (a == null || a.bi == null) {
                return false;
            }
            let b = typeCast(CategoryAxisBase.$, a);
            if (b != null) {
                if (b.itemsSource == null) {
                    return false;
                }
                if (b.lf < 1) {
                    return false;
                }
            }
            else {
                let c = typeCast(NumericAxisBase.$, a);
                if (c != null) {
                    return c.lx != c.lw;
                }
            }
            return true;
        }
        f7() {
            return this.xt;
        }
        f8() {
            return true;
        }
        xc() {
            return 12;
        }
        n8() {
            super.n8();
            this.w4.w();
            this.w2.w();
            this.w6.w();
        }
        qn(a) {
            super.qn(a);
            this.xb.cu.g(this.hu);
            if (this.dt(this.cl)) {
                this.w2.z();
                this.w6.z();
                this.w4.z();
                return;
            }
            if (this.gb) {
                if (this.dr()) {
                    if (this.c2.g) {
                        this.c2.t();
                    }
                    this.yl(this.w6, this.xb);
                }
                else {
                    this.yl(this.w2, this.xb);
                }
                return;
            }
            if (this.fz(a)) {
                let b = this.w4;
                if (this.dr()) {
                    if (this.c2.g) {
                        this.c2.t();
                    }
                    this.w4 = this.w6;
                    this.w6 = b;
                }
                else {
                    this.w4 = this.w2;
                    this.w2 = b;
                }
                let c = false;
                this.yi(this.w2, this.xb);
                if (this.gm) {
                    this.c2.w();
                    this.c2.r = truncate(this.ir());
                    this.c2.b = this.c4 != null ? this.c4 : this.c3;
                    if (this.gn) {
                        let d = this.w6;
                        this.w6 = this.w4;
                        this.w4 = d;
                        c = true;
                    }
                    this.xe.s(this, this.w4, this.w2, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.xd, this.xc(), this.cv, this.cu(), runOn(this, this.x2), this.xb.bx);
                    if (this.gn) {
                        let e = this.w6;
                        this.w6 = this.w4;
                        this.w4 = e;
                    }
                    this.gn = false;
                }
                if (this.gp) {
                    this.c2.w();
                    this.c2.r = truncate(this.is());
                    this.c2.b = this.c5 != null ? this.c5 : this.c3;
                    if (this.gk) {
                        let f = this.w6;
                        this.w6 = this.w4;
                        this.w4 = f;
                        c = true;
                    }
                    this.xe.s(this, this.w4, this.w2, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.xd, this.xc(), this.cv, this.cu(), runOn(this, this.x2), this.xb.bx);
                    let g = this.w2;
                    this.w2 = this.w4;
                    this.w4 = g;
                    if (this.gk) {
                        let h = this.w6;
                        this.w6 = this.w4;
                        this.w4 = h;
                    }
                    this.gk = false;
                }
                this.dx = false;
                if (!c) {
                    this.n3();
                }
                this.q0();
                if (this.gm) {
                    this.gl = false;
                    this.gk = true;
                }
                if (this.gp) {
                    this.go = false;
                    this.gn = true;
                }
            }
            else {
                this.yi(this.w2, this.xb);
                this.yl(this.w2, this.xb);
            }
        }
        cu() {
            return 3;
        }
        cx() {
            let a = this.cu();
            switch (a) {
                case 0: return 0;
                case 1: return 1;
                case 4: return 4;
                case 2: return 2;
                case 3: return 3;
            }
            return 3;
        }
        x2() {
            if (this.isVertical) {
                return this.u9.left;
            }
            return this.u9.bottom;
        }
        xw() {
            return false;
        }
        hb() {
            let a = super.hb();
            if (this.xw()) {
                let b = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "DashArray";
                    $ret.p = true;
                    $ret.x = ((() => {
                        let $ret = new DoubleCollection();
                        $ret.add(5);
                        $ret.add(5);
                        return $ret;
                    })());
                    $ret.q = true;
                    return $ret;
                })());
                a.add(b);
            }
            if (!this.xw()) {
                let c = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Brush";
                    $ret.p = true;
                    $ret.y = "ActualBrush";
                    $ret.q = true;
                    return $ret;
                })());
                c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.qu));
                a.add(c);
            }
            if (!this.xw()) {
                let d = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Outline";
                    $ret.p = true;
                    $ret.y = "ActualOutline";
                    $ret.q = true;
                    return $ret;
                })());
                d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.qu));
                a.add(d);
            }
            let e = ((() => {
                let $ret = new SeriesLayerPropertyOverlay();
                $ret.p = true;
                $ret.ad = "IsTransitionInEnabled";
                $ret.x = true;
                $ret.q = true;
                return $ret;
            })());
            a.add(e);
            let f = ((() => {
                let $ret = new SeriesLayerPropertyOverlay();
                $ret.p = true;
                $ret.ad = "TransitionInMode";
                $ret.x = enumGetBox(CategoryTransitionInMode_$type, 20);
                $ret.q = true;
                return $ret;
            })());
            a.add(f);
            return a;
        }
        j7() {
            if (this.dr()) {
                return this.be.w6;
            }
            else {
                return this.be.w2;
            }
        }
        x6() {
            if (this.be != null) {
                let a = this.be;
                return a.x6();
            }
            let b = 0;
            let c = this.fetchXAxis();
            for (let d of fromEnum(this.c1.series)) {
                if (d == this) {
                    return b;
                }
                let e = typeCast(CategorySeries.$, d);
                if (e != null) {
                    let f = typeCast(CategoryAxisBase.$, e.fetchXAxis());
                    if (f == c && e.preferredCategoryMode(f) == 2) {
                        b++;
                    }
                }
            }
            return -1;
        }
        get GetErrorBarsXAxis() {
            return this.fetchXAxis();
        }
        get GetErrorBarsYAxis() {
            return this.fetchYAxis();
        }
        yf(a, b) {
            this.xa.a1(this, this.xv(), runOn(this, this.wv), this.x3(a), this.x4(a));
            let c = this.xa.d;
            let d = c != null;
            let e = this.w1();
            if (e == null) {
                return;
            }
            let f = this.getEffectiveViewport1(a);
            let g = new ScalerParams(0, a.by, a.bx, e.ch, f);
            let h = this.dd == null ? 0 : this.dd.count;
            let i = a;
            let j = b.f;
            let k = i.cu.e;
            let l = i.cu.f;
            let m = i.cu.d;
            let n = k * m;
            for (let o = 0; o < a.cx.count; o++) {
                let p = a.cx.item(o);
                let q = p.content;
                if (d) {
                    let r = p.al;
                    this.yg(j, r, h, e, g, a.q, p.ak);
                }
                this.xa.ac(p, q);
            }
        }
        yl(a, b) {
            this.pt();
            this.u0 = a.ab;
            b.aw();
        }
        yi(a, b) {
            a.v();
        }
        x3(a) {
            return a.cu.d;
        }
        x4(a) {
            return a.cu.e;
        }
        x5(a) {
            return a.cu.f;
        }
        ye(a) {
            let b = a;
            b.cx.count = 0;
        }
        qo(a, b) {
            super.qo(a, b);
            if (!this.gj) {
                this.cl.a4(b);
                return;
            }
            let c = typeCast(CategorySeriesView.$, this.ck);
            c.cu.g(this.hu);
            this.cl.a4(b);
            if (this.dt(this.ck)) {
                return;
            }
            this.ym();
            this.gj = false;
        }
        ym() {
            let a = typeCast(CategorySeriesView.$, this.ck);
            if (!this.gc) {
                this.yi(this.w5, a);
            }
            this.gc = false;
            this.yl(this.w5, a);
        }
        w8(a) {
            let b = typeCast(CategorySeriesView.$, a);
            if (b != null && b.q) {
                if (b.p) {
                    return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cu);
                }
                else {
                    return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.c1.c8.o, this, b.cu);
                }
            }
            else {
                return this.w7;
            }
        }
        ao(a) {
            if (this.fetchXAxis() == a) {
                return this.fetchYAxis();
            }
            if (this.fetchYAxis() == a) {
                return this.fetchXAxis();
            }
            return null;
        }
        ag() {
            return [this.fetchXAxis(), this.fetchYAxis()];
        }
        static ww(a, b, c, d, e) {
            let f = null;
            if (b > -1 && !d.isEmpty && !c.isEmpty) {
                let g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
                let h = c.bottom + 10;
                let i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
                let j = c.top - 10;
                f = new Clipper(1, g, h, i, j, e);
            }
            return f;
        }
    }
    CategorySeries.$t = /*@__PURE__*/ markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
    CategorySeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:xr:yn', [0, false], 'IsCustomCategoryStyleAllowed:xs:yo', [0, false], 'IsTransitionInEnabled:xt:yp', [0, false], 'TransitionInMode:xd:yq', [CategoryTransitionInMode_$type, /*@__PURE__*/ enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:xy:yr', [0, false]]);
    return CategorySeries;
})();
/**
 * @hidden
 */
export let CategorySeriesView = /*@__PURE__*/ (() => {
    class CategorySeriesView extends MarkerSeriesView {
        cy(a) {
            if (this.cz != a.u) {
                return true;
            }
            return false;
        }
        c1(a) {
            this.cz = a.u;
        }
        constructor(a) {
            super(a);
            this.cw = null;
            this.cz = 0;
            this.cu = null;
            this.cx = null;
            this.cz = -1;
            this.cw = a;
            this.cu = this.cv();
            this.cx = ((() => {
                let $ret = new Pool$1(Marker.$);
                $ret.create = runOn(this, this.b3);
                $ret.activate = runOn(this, this.cm);
                $ret.disactivate = runOn(this, this.co);
                $ret.destroy = runOn(this, this.cn);
                return $ret;
            })());
        }
        updateMarkerTemplate(a, b, c) {
            if (!this.b4.vt) {
                let d = this.cx.item(a);
                let e = d.content;
                e.item = this.e.dd.item(b);
                d.ak = b;
                d.al = c;
            }
        }
        cv() {
            return new CategoryBucketCalculator(this);
        }
        get shouldDisplayMarkers() {
            return this.cw.vr();
        }
        updateMarkerCount(a) {
            this.cx.count = a;
        }
        ci(a) {
            this.cx.c(a);
        }
        c0() {
        }
    }
    CategorySeriesView.$t = /*@__PURE__*/ markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
    return CategorySeriesView;
})();
