/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { CategoryFrame } from "./CategoryFrame";
import { Number_$type, typeCast, enumGetBox, EnumUtil, runOn, markType, markDep } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { CategorySeries } from "./CategorySeries";
import { NotImplementedException } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { GeometryGroup } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { LineGeometry } from "igniteui-react-core";
import { Defaults } from "./Defaults";
import { Extensions } from "igniteui-react-core";
import { IndicatorRenderer } from "./IndicatorRenderer";
/**
 * @hidden
 */
export let FinancialIndicator = /*@__PURE__*/ (() => {
    class FinancialIndicator extends FinancialSeries {
        get_es() {
            return true;
        }
        ci() {
            return new FinancialIndicatorView(this);
        }
        px(a) {
            super.px(a);
            this.zg = a;
        }
        constructor() {
            super();
            this._indicatorColumn = null;
            this.zf = null;
            this.vp = new CategoryFrame(3);
            this.vr = new CategoryFrame(3);
            this.vn = new CategoryFrame(3);
            this.indicatorColumn = new List$1(Number_$type, 0);
            this.zf = new AxisRange(-100, 100);
        }
        zt(a) {
            if (this.v4 != null && !this.v4.c1()) {
                this.qm(true);
            }
        }
        zl(a, b, c) {
            if (isNaN_(b.x) || isNaN_(b.y)) {
                return false;
            }
            let d = this.v4;
            let e = 0;
            if (d != null) {
                e = d.e4(d.l7);
            }
            if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
                return true;
            }
            return false;
        }
        bt() {
            if (this.bu == 0) {
                return 1;
            }
            else {
                return super.bt();
            }
        }
        u5(a) {
            if (this.vl == null || this.v4 == null) {
                return Rect.empty;
            }
            let b = this.up(a);
            let c = this.cl.by;
            let d = this.cl.bx;
            let e = this.getEffectiveViewport1(this.cl);
            let f = new ScalerParams(0, c, d, this.v4.ch, e);
            f.b = this.id();
            let g = this.aj(this.vl, this.vn.f, this.xi(this.cl), this.xk(this.cl), a, true);
            if (g == null) {
                return Rect.empty;
            }
            let h = g[0];
            let i = g[1];
            let j = Math.abs(b.x - h[0]);
            let k = Math.abs(b.x - i[0]);
            let l = this.v4.ej(this.v4.l7, f);
            let m = 1;
            if (j < k) {
                let n = h[0] - 0.5 * m;
                let o = h[1];
                let p = l;
                return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
            }
            else {
                let q = i[0] - 0.5 * m;
                let r = i[1];
                let s = l;
                return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
            }
        }
        gf(a, b) {
            let c = this.uu(this.uz(a), true, false);
            if (this.zi == 1) {
                if (this.zl(a, c, b)) {
                    return true;
                }
            }
            if (this.zi == 1 || this.zi == 0) {
                if (this.ge(a, b)) {
                    return true;
                }
            }
            if (this.zi == 2) {
                if (this.gi(a, b)) {
                    return true;
                }
            }
            return false;
        }
        oc(a, b, c, d) {
            super.oc(a, b, c, d);
            if (this.vl != null && typeCast(ISortingAxis_$type, this.vl) !== null) {
                this.vl.i$i();
            }
            if (this.zg.ca) {
                this.zg.b8.g$e(a, b, c, d);
            }
            if (d != null && this.wx.containsKey(d)) {
                let e = this.wx.tryGetValue(d, d);
                d = e.p1;
            }
            if (this.vl != null && typeCast(ISortingAxis_$type, this.vl) !== null) {
                a = 4;
                b = 0;
                c = this.dd.count;
            }
            switch (a) {
                case 3:
                    if (this.zk(b, c, d)) {
                        this.zv(b, c, d);
                        this.zt(true);
                    }
                    break;
                case 2:
                    if (this.zk(b, this.dd.count - b, d)) {
                        this.zv(b, this.dd.count - b, d);
                        this.zt(true);
                    }
                    break;
                case 1:
                    if (this.zk(b, this.dd.count - b, d)) {
                        let f = new Array(c);
                        for (let g = 0; g < c; g++) {
                            f[g] = 0;
                        }
                        this.indicatorColumn.s(b, f);
                        this.zv(b, this.dd.count - b, d);
                        this.zt(true);
                    }
                    break;
                case 0:
                    if (this.zk(b, this.dd.count - b, d)) {
                        this.indicatorColumn.v(b, c);
                        this.zv(b, this.dd.count - b, d);
                        this.zt(true);
                    }
                    break;
                case 4:
                    if (this.zk(b, this.dd.count - b, d)) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.dd.count);
                        let h = new Array(c);
                        for (let i = 0; i < c; i++) {
                            h[i] = 0;
                        }
                        this.indicatorColumn.s(0, h);
                        this.zv(b, this.dd.count - b, d);
                        this.zt(true);
                    }
                    break;
            }
        }
        get_zh() {
            return 0;
        }
        get zh() {
            return this.get_zh();
        }
        get z6() {
            return this.c(FinancialIndicator.zw);
        }
        set z6(a) {
            this.h(FinancialIndicator.zw, a);
        }
        zq() {
            return -1;
        }
        get indicatorColumn() {
            return this._indicatorColumn;
        }
        set indicatorColumn(a) {
            this._indicatorColumn = a;
        }
        p5(a, b, c, d) {
            switch (b) {
                case "XAxis":
                    this.zg.cg();
                    break;
                case "TrendLineType":
                    let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                    if (e != 0) {
                        this.zg.b8 = CategoryTrendLineManagerFactory.a(this.zg.b8, this.vl, this.ro, this, this.dg);
                    }
                    break;
            }
            super.p5(a, b, c, d);
            if (this.zg.ca && this.zg.b8.g$b(a, b, c, d)) {
                this.qm(false);
                let f = typeCast(FinancialIndicatorView.$, this.ck);
                if (f != null && f.ca) {
                    f.b8.g$b(a, b, c, d);
                }
                this.ph();
            }
            switch (b) {
                case "FastItemsSource":
                    if (this.dd != null) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.dd.count);
                        let g = new Array(this.dd.count);
                        for (let h = 0; h < this.dd.count; h++) {
                            g[h] = 0;
                        }
                        this.indicatorColumn.s(0, g);
                        this.zv(0, this.dd.count, null);
                        if (this.v4 != null && !this.v4.c1()) {
                            this.v2.b0.e(this.hu);
                            this.qm(this.f0 && c != null);
                        }
                    }
                    break;
                case "TrendLineBrush":
                    this.qb(b);
                    break;
                case FinancialIndicator.$$p[0]:
                    this.n7(true, this.cl);
                    this.rb();
                    this.qm(false);
                    this.ph();
                    break;
                case "OpenColumn":
                case "HighColumn":
                case "LowColumn":
                case "CloseColumn":
                case "VolumeColumn":
                    if (this.dd != null) {
                        if (this.indicatorColumn.count != this.dd.count) {
                            this.indicatorColumn = new List$1(Number_$type, 2, this.dd.count);
                            let i = new Array(this.dd.count);
                            for (let j = 0; j < this.dd.count; j++) {
                                i[j] = 0;
                            }
                            this.indicatorColumn.s(0, i);
                        }
                        if (this.zk(0, this.dd.count - 1, b)) {
                            this.zu();
                        }
                    }
                    break;
                case "XAxis":
                    if (this.vl != null && (typeCast(ISortingAxis_$type, this.vl) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                        this.zu();
                    }
                    break;
                case "YAxis":
                case FinancialIndicator.$$p[1]:
                    this.zu();
                    this.ph();
                    break;
                case "TrendLineType":
                    this.ph();
                    break;
            }
        }
        il(a, b, c) {
            if (this.indicatorColumn == null) {
                return super.il(a, b, c);
            }
            let d = this.getEffectiveViewport1(this.cl);
            let e = this.xc(this.cl.by, this.cl.bx, d);
            let f = new ScalerParams(0, this.cl.by, this.cl.bx, this.vl.ch, d);
            f.c = this.c1.vw;
            return this.io(this.indicatorColumn, a, this.vl, f, e, runOn(this, this.xb), b, c);
        }
        jq(a, b) {
            if (this.indicatorColumn == null) {
                return super.jq(a, b);
            }
            return this.jr(a, b, this.vl, runOn(this, this.xb), this.indicatorColumn);
        }
        jo(a, b) {
            if (this.indicatorColumn == null) {
                return super.jo(a, b);
            }
            return this.jp(a, b, this.vl, runOn(this, this.xb), this.indicatorColumn);
        }
        get_gv() {
            return true;
        }
        zk(a, b, c) {
            if (c == null) {
                return true;
            }
            if (this.zm(a, b).contains(c)) {
                return true;
            }
            return false;
        }
        zv(a, b, c) {
            this.zj(a, b);
        }
        aq(a) {
            if (this.dd == null) {
                return null;
            }
            if (a != null && a == this.v4) {
                return this.zf;
            }
            return null;
        }
        fx(a) {
            let b = this.dd != null ? this.dd.indexOf(a) : -1;
            let c = this.cl.by;
            c = c.copy();
            let d = this.cl.bx;
            let e = new Rect(0, 0, 0, 1, 1);
            let f = this.u3(this.cl);
            if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
                if (this.vl != null) {
                    let g = new ScalerParams(0, e, e, this.vl.ch, f);
                    let h = this.vl.ej(b, g);
                    if (h < c.left + 0.1 * c.width) {
                        h = h + 0.4 * c.width;
                    }
                    if (h > c.right - 0.1 * c.width) {
                        h = h - 0.4 * c.width;
                    }
                    c.x = h - 0.5 * c.width;
                }
                if (this.v4 != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                    let i = new ScalerParams(0, e, e, this.v4.ch, f);
                    i.b = this.id();
                    let j = this.v4.ej(this.indicatorColumn._inner[b], i);
                    if (j < c.top + 0.1 * c.height) {
                        j = j + 0.4 * c.height;
                    }
                    if (j > c.bottom - 0.1 * c.height) {
                        j = j - 0.4 * c.height;
                    }
                    c.y = j - 0.5 * c.height;
                }
                this.ct.au(this.c1, c, true);
            }
            return b >= 0;
        }
        gw(a, b, c) {
            let d = super.gw(a, b, c);
            if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
                d = false;
            }
            return d;
        }
        yr(a, b) {
            super.yr(a, b);
            let c = b.by;
            let d = b.bx;
            let e = this.getEffectiveViewport1(b);
            let f = this.vl;
            let g = this.v4;
            let h = new ScalerParams(0, c, d, f.ch, e);
            let i = new ScalerParams(0, c, d, g.ch, e);
            i.b = this.id();
            let j = this.vl.ag();
            let k = j[0];
            let l = j[1];
            a.f.clear();
            a.n.clear();
            a.q.clear();
            let m = 0;
            let n = typeCast(ISortingAxis_$type, this.vl);
            if (n != null && n.i$b.count != this.dd.count) {
                return;
            }
            m = this.xc(c, d, e);
            let o = this.zq();
            if (o == -1) {
                o = this.trendLinePeriod;
            }
            let p = typeCast(FinancialIndicatorView.$, b);
            if (p.ca) {
                p.b8.prepareLineCore(a.q, this.trendLineType, this.indicatorColumn, o, (q) => this.vl.ej(q, h), (q) => this.v4.ej(q, i), ((() => {
                    let $ret = new TrendResolutionParams();
                    $ret.e = b.b0.b;
                    $ret.f = b.b0.c;
                    $ret.g = b.b0.d;
                    $ret.a = m;
                    $ret.d = this.hu;
                    $ret.h = d;
                    $ret.i = c;
                    $ret.b = l;
                    $ret.c = k;
                    return $ret;
                })()));
            }
            let q = this.vl.em(2, h) - this.vl.em(1, h);
            for (let r = b.b0.c; r <= b.b0.d; ++r) {
                let s;
                if (n == null) {
                    s = b.b0.getBucket(r);
                }
                else {
                    let t = n.i$b._inner[r];
                    let u = n.i$d(t);
                    let v = this.indicatorColumn._inner[r];
                    let w = v;
                    let x = u;
                    while (r < b.b0.d) {
                        t = n.i$b._inner[r + 1];
                        x = n.i$d(t);
                        if (x - u > q) {
                            break;
                        }
                        r++;
                        let y = this.indicatorColumn._inner[r];
                        v = Math.min(v, y);
                        w = Math.max(w, y);
                    }
                    let z = NaN;
                    if (!isNaN_(u)) {
                        z = this.vl.ej(u, h);
                    }
                    s = [z, v, w];
                }
                if (!isNaN_(s[0])) {
                    if (this.vl != null && typeCast(ISortingAxis_$type, this.vl) !== null) {
                        s[0] = s[0] + m;
                    }
                    else {
                        s[0] = f.ej(s[0], h) + m;
                    }
                    s[1] = g.ej(s[1], i);
                    if (b.b0.b > 1 || n != null) {
                        s[2] = g.ej(s[2], i);
                    }
                    else {
                        s[2] = s[1];
                    }
                    a.f.add(s);
                }
            }
            return;
        }
        n7(a, b) {
            super.n7(a, b);
            let c = b;
            c.cb(a);
            if (c.ca) {
                c.b8.g$d();
            }
        }
        vv() {
            switch (this.zi) {
                case 1: return 1;
                case 2: return 1;
                case 0: return 12;
            }
            return 1;
        }
        yt(a, b) {
            super.yt(a, b);
            let c = typeCast(FinancialIndicatorView.$, b);
            let d = (e) => a.f._inner[e][0];
            let e = (f) => a.f._inner[f][1];
            if (c.ca) {
                c.b8.g$d();
                c.b8.g$g(a.q);
            }
            let f = b.bx;
            let g = this.getEffectiveViewport1(b);
            let h = 0;
            let i = this.tw;
            let j = this.zb;
            if (b.b3(a)) {
                c.cb(false);
                if (a.f.count > 0) {
                    switch (this.zi) {
                        case 0:
                            let k = CategorySeries.ww(a.f, a.f.count - 1, f, b.by, false);
                            c.cf(a.f.count, d, e, true, k);
                            break;
                        case 1:
                            if (this.v4 != null) {
                                h = this.xg(b);
                            }
                            else {
                                h = 0.5 * (f.top + f.bottom);
                            }
                            let l = CategorySeries.ww(a.f, a.f.count - 1, f, b.by, false);
                            c.cd(a.f.count, d, e, true, h, l);
                            break;
                        case 2:
                            h = this.xg(b);
                            c.ce(a.f.count, d, e, true, h);
                            break;
                        default: throw new NotImplementedException(0);
                    }
                }
                b.b5(a);
            }
            let m = a.f;
            let n = this.dd.count;
            this.vu.a2(this, this.wt(), runOn(this, this.vd), this.xi(b), this.xk(b));
            let o = false;
            let p = this.vu.b;
            if (p != null) {
                o = true;
            }
            this.vu.ak = i;
            this.vu.ag = i;
            if (o) {
                let q = new ScalerParams(0, b.by, b.bx, this.vl.ch, g);
                this.vu.f = false;
                this.yq(m, -1, n, this.vl, q, b.q, -1);
            }
            this.vu.ad(c.cx, true, false, true, false);
            this.vu.ad(c.cz, true, false, true, false);
            this.vu.ad(c.cy, false, true, false, false);
            c.cy._opacity = 0.8 * this.vu.j * this.hq;
            this.vu.ad(c.cw, true, false, false, false);
            this.vu.ak = j;
            this.vu.ag = j;
            if (o) {
                let r = new ScalerParams(0, b.by, b.bx, this.vl.ch, g);
                this.vu.f = true;
                this.yq(m, -1, n, this.vl, r, b.q, -1);
            }
            this.vu.ad(c.ct, true, false, true, false);
            this.vu.ad(c.cv, true, false, true, false);
            this.vu.ad(c.cu, false, true, false, false);
            c.cu._opacity = 0.8 * this.vu.j * this.hq;
            this.vu.ad(c.cs, true, false, false, false);
            c.ch();
        }
        ra() {
            super.ra();
            if (this.index < 0) {
                return;
            }
            if (this.zg.ca) {
                this.zg.ci();
            }
        }
        zu() {
            if (this.zg.ca) {
                this.zg.b8.g$i();
            }
            this.zj(0, this.indicatorColumn.count);
            if (this.v4 != null && !this.v4.c1()) {
                this.qm(this.f0 && this.dv);
            }
        }
        ow(a) {
            super.ow(a);
            this.a4.exportTrendlineData(this, a, this.zg.b8.g$j);
        }
        a6(a) {
            if (this.zi == 1 || this.zi == 2) {
                return 3;
            }
            else if (this.zi == 0) {
                return 2;
            }
            return a;
        }
    }
    FinancialIndicator.$t = /*@__PURE__*/ markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialIndicator.zw = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    FinancialIndicator.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:zi:zx', [IndicatorDisplayType_$type, /*@__PURE__*/ enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:zo:zy', [1, 0], 'TrendLineType::z4', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::z3', [1, 1.5], 'TrendLinePeriod::z2', [1, 7], 'TrendLineBrush::zz', [Brush.$, null], 'TrendLineZIndex:zp:z5', [1, 1001], 'TrendLineDashArray:z7:z0', [DoubleCollection.$], 'TrendLineDashCap:z8:z1', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialIndicator;
})();
/**
 * @hidden
 */
export let FinancialIndicatorBucketCalculator = /*@__PURE__*/ (() => {
    class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = a * this.b;
            let c = Math.min(b + this.b - 1, this.f.b6.indicatorColumn.count - 1);
            let d = NaN;
            let e = NaN;
            for (let f = b; f <= c; ++f) {
                let g = this.f.b6.indicatorColumn._inner[f];
                if (!isNaN_(d)) {
                    if (!isNaN_(g)) {
                        d = Math.min(d, g);
                        e = Math.max(e, g);
                    }
                }
                else {
                    d = g;
                    e = g;
                }
            }
            if (!isNaN_(d)) {
                return [0.5 * (b + c), d, e];
            }
            return [NaN, NaN, NaN];
        }
    }
    FinancialIndicatorBucketCalculator.$t = /*@__PURE__*/ markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
    return FinancialIndicatorBucketCalculator;
})();
/**
 * @hidden
 */
export let FinancialIndicatorView = /*@__PURE__*/ (() => {
    class FinancialIndicatorView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.b6 = null;
            this.b9 = null;
            this.cx = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.ct = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cy = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cu = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cz = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cv = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cw = ((() => {
                let $ret = new Path();
                $ret.an = new GeometryGroup();
                return $ret;
            })());
            this.cs = ((() => {
                let $ret = new Path();
                $ret.an = new GeometryGroup();
                return $ret;
            })());
            this.b7 = null;
            this.cp = new Path();
            this.cr = new Path();
            this.cq = new Path();
            this.co = new Path();
            this.cl = new Path();
            this.cn = new Path();
            this.cm = new Path();
            this.ck = new Path();
            this.b6 = a;
            this.b9 = ((() => {
                let $ret = new Pool$1(LineGeometry.$);
                $ret.create = runOn(this, this.cj);
                $ret.destroy = runOn(this, this.cc);
                return $ret;
            })());
        }
        b1() {
            return new FinancialIndicatorBucketCalculator(this);
        }
        au() {
            super.au();
            if (!this.q) {
                this.b6.zb = Defaults.ah;
                this.b6.zi = this.b6.zh;
            }
        }
        cj() {
            return new LineGeometry();
        }
        cc(a) {
        }
        get b8() {
            if (this.b7 == null) {
                this.b7 = CategoryTrendLineManagerFactory.a(this.b7, this.e.as(), this.e.ro, this.e, this.e.dg);
            }
            return this.b7;
        }
        set b8(a) {
            this.b7 = a;
        }
        get ca() {
            return this.b7 != null;
        }
        cb(a) {
            Extensions.e(this.cx.an);
            Extensions.e(this.cy.an);
            Extensions.e(this.cz.an);
            Extensions.e(this.ct.an);
            Extensions.e(this.cu.an);
            Extensions.e(this.cv.an);
            Extensions.d(this.cw.an);
            Extensions.d(this.cs.an);
            if (a) {
                this.b9.count = 0;
            }
            this.as();
        }
        ch() {
        }
        cf(a, b, c, d, e) {
            IndicatorRenderer.g(a, b, c, d, this.by, this.bx, this.cx, this.ct, this.b0.b, this.e.hu, e);
            this.as();
        }
        cd(a, b, c, d, e, f) {
            IndicatorRenderer.e(a, b, c, d, this.by, this.bx, this.cx, this.cy, this.ct, this.cu, e, this.b0.b, this.e.hu, f);
            this.as();
        }
        ce(a, b, c, d, e) {
            IndicatorRenderer.f(a, b, c, d, this.bx, e, this.b9, this.cw, this.cs);
            this.as();
        }
        ci() {
            this.b6.z6 = null;
            if (this.b6.trendLineBrush != null) {
                this.b6.z6 = this.b6.trendLineBrush;
            }
            else {
                this.b6.z6 = this.b6.tw;
            }
        }
        be() {
            super.be();
            let a = this.br();
            this.cp.an = this.cx.an;
            this.cr.an = this.cz.an;
            this.cq.an = this.cy.an;
            this.co.an = this.cw.an;
            this.cl.an = this.ct.an;
            this.cn.an = this.cv.an;
            this.cm.an = this.cu.an;
            this.ck.an = this.cs.an;
            this.cp._stroke = a;
            this.cr._stroke = a;
            this.cp.ad = this.e.hv + 3;
            this.cr.ad = this.e.hv + 3;
            this.cq._fill = a;
            this.cq._opacity = 1;
            this.co._stroke = a;
            this.co.ad = this.e.hv + 3;
            this.cl._stroke = a;
            this.cn._stroke = a;
            this.cl.ad = this.e.hv + 3;
            this.cn.ad = this.e.hv + 3;
            this.cm._fill = a;
            this.cm._opacity = 1;
            this.ck._stroke = a;
            this.ck.ad = this.e.hv + 3;
        }
        a8(a, b) {
            super.a8(a, b);
            if (a.d) {
                if (b) {
                    if (this.b6.zi == 2) {
                        a.t(this.co);
                        a.t(this.ck);
                    }
                    else {
                        a.t(this.cq);
                        a.t(this.cp);
                        a.t(this.cr);
                        a.t(this.cm);
                        a.t(this.cl);
                        a.t(this.cn);
                    }
                }
                else {
                    if (this.b6.zi == 2) {
                        a.t(this.cw);
                        a.t(this.cs);
                    }
                    else {
                        a.t(this.cy);
                        a.t(this.cx);
                        a.t(this.cz);
                        a.t(this.cu);
                        a.t(this.ct);
                        a.t(this.cv);
                    }
                }
            }
        }
        a7(a, b) {
            if (a.d) {
                if (this.b6.trendLineType != 0 && !b) {
                    let c = this.b8.g$j;
                    c.ad = this.b6.trendLineThickness;
                    c._stroke = this.b6.z6;
                    c.aj = this.b6.z8;
                    c.ai = this.b6.z7;
                    a.v(c);
                }
            }
            super.a7(a, b);
        }
        an(a) {
            super.an(a);
            this.e.a4.exportPathData(a, this.cw, "positiveColumnsShape", ["Positive", "Main"]);
            this.e.a4.exportPathData(a, this.cs, "negativeColumnsShape", ["Negative"]);
            this.e.a4.exportPathData(a, this.cx, "positive0", ["Positive", "Main"]);
            this.e.a4.exportPathData(a, this.cz, "positive1", ["Positive"]);
            this.e.a4.exportPathData(a, this.cy, "positive01", ["PositiveFill"]);
            this.e.a4.exportPathData(a, this.ct, "negative0", ["Negative", "Main"]);
            this.e.a4.exportPathData(a, this.cv, "negative1", ["Negative"]);
            this.e.a4.exportPathData(a, this.cu, "negative01", ["NegativeFill"]);
        }
        cg() {
            if (this.ca) {
                this.b7 = CategoryTrendLineManagerFactory.a(this.b7, this.e.as(), this.e.ro, this.e, this.e.dg);
            }
        }
    }
    FinancialIndicatorView.$t = /*@__PURE__*/ markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
    return FinancialIndicatorView;
})();
