/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { DependencyProperty } from "igniteui-react-core";
import { SplineType_$type } from "./SplineType";
import { AxisRange } from "./AxisRange";
import { Array_$type, typeCast, Point_$type, enumGetBox, markType, markDep } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CollisionAvoider } from "./CollisionAvoider";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { ScalerParams } from "./ScalerParams";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { Numeric } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_ } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
export let SplineSeriesBase = /*@__PURE__*/ (() => {
    class SplineSeriesBase extends HorizontalAnchoredCategorySeries {
        constructor() {
            super(...arguments);
            this.aaw = null;
            this.aa2 = NaN;
            this.aa1 = NaN;
        }
        i0() {
            if (!isNaN_(this.iz)) {
                return super.i0();
            }
            return this.aax.de();
        }
        ci() {
            return new SplineSeriesBaseView(this);
        }
        px(a) {
            super.px(a);
            this.aax = a;
        }
        qx(a) {
            super.qx(a);
            this.aaz = true;
        }
        aq(a) {
            if (!this.aaz || this.aaw == null || this.aaw.length == 0) {
                return super.aq(a);
            }
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            this.aa9(this.aax);
            if (this.aaw == null || this.aaw.length == 0) {
                return null;
            }
            if (a == this.fetchYAxis()) {
                if (isNaN_(this.aa5) || isNaN_(this.aa6)) {
                    return null;
                }
                return new AxisRange(this.aa6, this.aa5);
            }
            return null;
        }
        get_eg() {
            return true;
        }
        aau(a) {
            if (a.cu.d == 0) {
                return null;
            }
            let b = new List$1(Array_$type, 0);
            let c = a.by;
            let d = a.bx;
            let e = this.getEffectiveViewport1(a);
            let f = 0;
            let g = 0;
            let h = 0;
            let i = this;
            let j = typeCast(CategoryAxisBase.$, i.fetchXAxis());
            let k = i.u1(this.cl);
            let l = i.dd;
            if (c.isEmpty || d.isEmpty || j == null || l == null || l.count == 0) {
                f = 0;
                return null;
            }
            let m = this.hu;
            let n = typeCast(ISortingAxis_$type, j);
            if (n == null || n.i$b == null) {
                let o = new ScalerParams(0, c, d, j.ch, e);
                let p = 0;
                let q = j.lg - 1;
                let r = Math.floor((q - p + 1) * m / k.width);
                f = truncate(Math.max(1, r));
                g = truncate(Math.max(0, Math.floor(p / f) - 1));
                h = truncate(Math.ceil(q / f));
            }
            else {
                g = 0;
                h = j.lg - 1;
                f = 1;
            }
            if (n != null && n.i$b.count != this.dd.count) {
                return null;
            }
            this.aa9(a);
            let s = truncate(Math.ceil(d.width / (h - g)));
            let t = new CollisionAvoider();
            if (n != null) {
                return this.aav(a);
            }
            let u = (v) => v;
            let v = (w) => this.valueColumn.item(w);
            let w = a;
            w.c9();
            for (let x = g; x <= h; ++x) {
                let y = null;
                if (f == 1) {
                    if (x >= (this.valueColumn.count - 1)) {
                        break;
                    }
                    let z = u(x);
                    let aa = v(x);
                    let ab = u(x + 1);
                    let ac = v(x + 1);
                    let ad = ab - z;
                    let ae = this.aaw[x];
                    let af = this.aaw[x + 1];
                    b.add([aa, ac]);
                    for (let ag = 1; ag < s; ++ag) {
                        let ah = z + ad * ag / s;
                        let ai = (ab - ah) / ad;
                        let aj = (ah - z) / ad;
                        let ak = ai * aa + aj * ac + ((ai * ai * ai - ai) * ae + (aj * aj * aj - aj) * af) * (ad * ad) / 6;
                        b.add([ak, ak]);
                    }
                }
                else {
                    y = a.cu.getBucket(x);
                    if (!isNaN_(y[0])) {
                        b.add([y[1], y[2]]);
                    }
                }
            }
            w.db();
            return b.toArray();
        }
        aav(a) {
            let b = typeCast(ISortingAxis_$type, this.aab);
            let c = this.getEffectiveViewport1(a);
            let d = a.by;
            let e = a.bx;
            let f = new List$1(Array_$type, 0);
            if (b == null) {
                return null;
            }
            let g = this.aab;
            let h = 0;
            let i = 0;
            let j = 0;
            let k = this.hu;
            let l = this.u1(this.cl);
            if (b == null || b.i$b == null) {
                let m = new ScalerParams(0, d, e, g.ch, c);
                let n = 0;
                let o = g.lg - 1;
                let p = Math.floor((o - n + 1) * k / l.width);
                h = truncate(Math.max(1, p));
                i = truncate(Math.max(0, Math.floor(n / h) - 1));
                j = truncate(Math.ceil(o / h));
            }
            else {
                i = 0;
                j = g.lg - 1;
                h = 1;
            }
            let q = (r) => r;
            let r = (s) => this.valueColumn.item(b.i$b._inner[s]);
            let s = truncate(Math.ceil(e.width / (j - i)));
            let t = new CollisionAvoider();
            if (h <= 0 || (i <= 0 && j <= 0)) {
                return null;
            }
            for (let u = i; u < j + 1; ++u) {
                let v = null;
                let w = u * h;
                if (b != null && b.i$b != null && w >= 0 && w < b.i$b.count) {
                    w = b.i$b._inner[w];
                }
                if (u >= (this.valueColumn.count - 1)) {
                    break;
                }
                let x = q(u);
                let y = r(u);
                let z = q(u + 1);
                let aa = r(u + 1);
                let ab = z - x;
                let ac = this.aaw[u];
                let ad = this.aaw[u + 1];
                f.add([y, y]);
                for (let ae = 1; ae < s; ++ae) {
                    let af = ae / s;
                    let ag = x + ab * af;
                    let ah = (z - ag) / ab;
                    let ai = (ag - x) / ab;
                    let aj = ah * y + ai * aa + ((ah * ah * ah - ah) * ac + (ai * ai * ai - ai) * ad) * (ab * ab) / 6;
                    f.add([aj, aj]);
                }
            }
            return f.toArray();
        }
        aba(a, b, c, d, e, f) {
            let g = typeCast(ISortingAxis_$type, d);
            let h = this.getEffectiveViewport1(f);
            if (g == null) {
                return;
            }
            let i = new ScalerParams(0, b, c, d.ch, h);
            let j = new ScalerParams(0, b, c, e.ch, h);
            j.b = this.id();
            let k = this.vr();
            let l = 0;
            let m = this.aa4(d, b, c, h);
            let n = (o) => o;
            let o = (p) => this.valueColumn.item(g.i$b._inner[p]);
            let p = this.xb.cu.f;
            let q = this.xb.cu.e;
            let r = truncate(Math.ceil(c.width / (p - q)));
            let s = new CollisionAvoider();
            let t = this.xb.cu.d;
            if (t <= 0 || (q <= 0 && p <= 0)) {
                this.xb.cx.count = l;
                return;
            }
            let u = 0;
            let v = 0;
            for (let w = q; w < p + 1; ++w) {
                let x = null;
                let y = w * t;
                if (g != null && g.i$b != null && y >= 0 && y < g.i$b.count) {
                    y = g.i$b._inner[y];
                }
                if (w >= (this.valueColumn.count - 1)) {
                    if (k && this.aa0(a, a.f._inner[a.f.count - 1], s, Math.min(y, this.dd.count - 1), l, f, u - 1)) {
                        ++l;
                    }
                    break;
                }
                let z = n(w);
                let aa = o(w);
                let ab = n(w + 1);
                let ac = o(w + 1);
                let ad = ab - z;
                let ae = this.aaw[w];
                let af = this.aaw[w + 1];
                let ag = g.i$d(g.i$b._inner[w]);
                let ah = d.ej(ag, i) + m;
                let ai = e.ej(aa, j);
                a.f.add([ah, ai, ai]);
                u++;
                v = u;
                for (let aj = 1; aj < r; ++aj) {
                    let ak = aj / r;
                    let al = z + ad * ak;
                    let am = (ab - al) / ad;
                    let an = (al - z) / ad;
                    let ao = am * aa + an * ac + ((am * am * am - am) * ae + (an * an * an - an) * af) * (ad * ad) / 6;
                    let ap = g.i$d(g.i$b._inner[w]);
                    let aq = g.i$d(g.i$b._inner[w + 1]);
                    let ar = ap + (aq - ap) * ak;
                    al = d.ej(ar, i) + m;
                    ao = e.ej(ao, j);
                    a.f.add([al, ao, ao]);
                    u++;
                }
                if (k) {
                    x = [ah, ai, ai];
                }
                if (k && this.aa0(a, x, s, Math.min(y, this.dd.count - 1), l, f, v - 1)) {
                    ++l;
                }
            }
            f.cx.count = l;
        }
        aa0(a, b, c, d, e, f, g) {
            let h = b[0];
            let i = b[1];
            let j = new Rect(0, h - 5, i - 5, 11, 11);
            if (!isNaN_(h) && !isNaN_(i) && c.tryAdd(j)) {
                a.n.add({ $type: Point_$type, x: h, y: i });
                let k = f.cx.item(e);
                k.content.item = this.dd.item(d);
                k.al = g;
                k.ak = d;
                return true;
            }
            return false;
        }
        aj(a, b, c, d, e, f) {
            if (a == null || a.cn || this.x3(this.cl) > 1 || this.x3(this.cl) == 0) {
                return super.aj(this.w1(), this.w2.f, this.x3(this.cl), this.x4(this.cl), e, f);
            }
            if (this.w2.f.count == 0) {
                return null;
            }
            let g = this.aax.cu.f;
            let h = this.cl.bx;
            let i = truncate(Math.ceil(h.width));
            if (g != d) {
                i = truncate(Math.ceil(h.width / (g - d)));
            }
            let j = -1;
            let k = -1;
            let l = this.h6(e);
            let m = this.jq(e, f);
            let n = this.jo(e, f);
            let o = truncate(Math.floor(m / this.x3(this.cl)));
            let p = truncate(Math.floor(n / this.x3(this.cl)));
            j = o - this.x4(this.cl);
            k = p - this.x4(this.cl);
            let q = j * i;
            let r = k * i;
            let s = 0;
            if (m != n) {
                s = (l - m) / (n - m);
            }
            let t = truncate(Math.floor(q + s * (r - q)));
            j = t;
            k = t + 1;
            if (j < 0) {
                j = 0;
            }
            if (j > this.w2.f.count - 1) {
                j = this.w2.f.count - 1;
            }
            if (k < 0) {
                k = 0;
            }
            if (k > this.w2.f.count - 1) {
                k = this.w2.f.count - 1;
            }
            let u = this.w2.f._inner[j];
            let v = this.w2.f._inner[k];
            let w = new Array(2);
            w[0] = u;
            w[1] = v;
            return w;
        }
        yi(a, b) {
            super.yi(a, b);
            if (a.f.count <= 1) {
                return;
            }
            if (b.cu.d == 0) {
                return;
            }
            let c = b.by;
            let d = b.bx;
            let e = this.getEffectiveViewport1(b);
            let f = this.aab;
            let g = this.aah;
            let h = new ScalerParams(0, c, d, f.ch, e);
            let i = ((() => {
                let $ret = new ScalerParams(0, c, d, g.ch, e);
                $ret.b = this.id();
                return $ret;
            })());
            a.f.clear();
            a.n.clear();
            let j = this.vr();
            let k = 0;
            let l = typeCast(ISortingAxis_$type, this.aab);
            if (l != null && l.i$b.count != this.dd.count) {
                return;
            }
            let m = this.aa4(f, c, d, e);
            let n = b.cu.d;
            this.aa9(b);
            let o = b.cu.f;
            let p = b.cu.e;
            let q = truncate(Math.ceil(d.width / (o - p)));
            let r = new CollisionAvoider();
            if (l != null) {
                this.aba(a, c, d, f, g, b);
                return;
            }
            let s = (t) => t;
            let t = (u) => this.valueColumn.item(u);
            let u = b;
            u.c9();
            let v = 0;
            let w = 0;
            for (let x = p; x <= o; ++x) {
                let y = null;
                if (n == 1) {
                    if (x >= (this.valueColumn.count - 1)) {
                        if (j && this.aa0(a, a.f._inner[a.f.count - 1], r, Math.min(x * n, this.dd.count - 1), k, b, v - 1)) {
                            ++k;
                        }
                        break;
                    }
                    let z = s(x);
                    let aa = t(x);
                    let ab = s(x + 1);
                    let ac = t(x + 1);
                    let ad = ab - z;
                    let ae = this.aaw[x];
                    let af = this.aaw[x + 1];
                    let ag = f.ej(z, h) + m;
                    let ah = g.ej(aa, i);
                    a.f.add([ag, ah, ah]);
                    v++;
                    w = v;
                    for (let ai = 1; ai < q; ++ai) {
                        let aj = z + ad * ai / q;
                        let ak = (ab - aj) / ad;
                        let al = (aj - z) / ad;
                        let am = ak * aa + al * ac + ((ak * ak * ak - ak) * ae + (al * al * al - al) * af) * (ad * ad) / 6;
                        aj = f.ej(aj, h) + m;
                        am = g.ej(am, i);
                        a.f.add([aj, am, am]);
                        v++;
                    }
                    if (j) {
                        y = b.cu.getBucket(x);
                        y[0] = (f.ej(y[0], h) + m);
                        y[1] = g.ej(y[1], i);
                        y[2] = g.ej(y[2], i);
                    }
                }
                else {
                    y = b.cu.getBucket(x);
                    if (!isNaN_(y[0])) {
                        y[0] = (f.ej(y[0], h) + m);
                        y[1] = g.ej(y[1], i);
                        y[2] = g.ej(y[2], i);
                        a.f.add(y);
                        v++;
                        w = v;
                    }
                }
                if (j && this.aa0(a, y, r, Math.min(x * n, this.dd.count - 1), k, b, w - 1)) {
                    ++k;
                }
            }
            u.db();
            b.cx.count = k;
        }
        aa9(a) {
            let b = a.cu.d;
            let c = (d) => d;
            let d = (e) => this.valueColumn.item(e);
            if (b < 1 || this.valueColumn == null || this.valueColumn.count == 0) {
                return;
            }
            if ((this.aaw == null || this.aaw.length != this.valueColumn.count) && b == 1) {
                let e = this.aay == 0 ? NaN : 0;
                if (this.aab != null && typeCast(ISortingAxis_$type, this.aab) !== null && this.aab.i$b != null) {
                    let f = new SafeSortedReadOnlyDoubleCollection(1, this.valueColumn, this.aab.i$b, NaN);
                    d = (g) => f.item(g);
                }
                this.aaw = Numeric.c(this.valueColumn.count, c, d, e, e);
                if (this.aaz) {
                    let g = -1.7976931348623157E+308;
                    let h = 1.7976931348623157E+308;
                    let i = this.aau(a);
                    if (i == null) {
                        return;
                    }
                    for (let j = 0; j < i.length; j++) {
                        if (isNaN_(i[j][0]) || isNaN_(i[j][1])) {
                            continue;
                        }
                        if (i[j][1] > g) {
                            g = i[j][1];
                        }
                        if (i[j][0] < h) {
                            h = i[j][0];
                        }
                    }
                    this.aa6 = h;
                    this.aa5 = g;
                }
            }
        }
        aa3(a, b, c, d, e, f, g) {
            let h = d - b;
            let i = b + h * a;
            let j = (d - i) / h;
            let k = (i - b) / h;
            let l = j * c + k * e + ((j * j * j - j) * f + (k * k * k - k) * g) * (h * h) / 6;
            return l;
        }
        ia(a, b, c, d, e, f, g, h) {
            let i = NaN;
            if (c >= 0 && c < b.count) {
                i = b.item(c);
            }
            let j = NaN;
            if (d >= 0 && d < b.count) {
                j = b.item(d);
            }
            if (f == 0) {
                return j;
            }
            if (e == b.count - 1) {
                return i;
            }
            if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
                return i;
            }
            if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
                return j;
            }
            let k = e;
            let l = f;
            let m = i;
            let n = j;
            let o = NaN;
            let p = NaN;
            if (this.aaw != null && e >= 0 && e < this.aaw.length) {
                o = this.aaw[e];
            }
            if (this.aaw != null && f >= 0 && f < this.aaw.length) {
                p = this.aaw[f];
            }
            return this.aa3(a, k, m, l, n, o, p);
        }
        aa4(a, b, c, d) {
            let e = this.preferredCategoryMode(a);
            if (e == 0 && a.categoryMode != 0) {
                e = 1;
            }
            let f = 0;
            switch (e) {
                case 0:
                    f = 0;
                    break;
                case 1:
                    f = 0.5 * a.getCategorySize(b, c, d);
                    break;
                case 2:
                    f = a.getGroupCenter(this.index, b, c, d);
                    break;
            }
            if (a.ch) {
                f = -f;
            }
            return f;
        }
        get aa6() {
            return this.aa2;
        }
        set aa6(a) {
            this.aa2 = a;
        }
        get aa5() {
            return this.aa1;
        }
        set aa5(a) {
            this.aa1 = a;
        }
        abb() {
            this.aaw = null;
            this.aa6 = NaN;
            this.aa5 = NaN;
            if (this.yAxis != null) {
                this.yAxis.c1();
            }
        }
        p5(a, b, c, d) {
            switch (b) {
                case "ValueColumn":
                case "FastItemsSource":
                    this.abb();
                    break;
            }
            super.p5(a, b, c, d);
            switch (b) {
                case SplineSeriesBase.$$p[1]:
                    this.abb();
                    this.qm(false);
                    this.ph();
                    break;
            }
        }
        oc(a, b, c, d) {
            this.abb();
            super.oc(a, b, c, d);
        }
        get useHighMarkerFidelity() {
            return this.xy;
        }
    }
    SplineSeriesBase.$t = /*@__PURE__*/ markType(SplineSeriesBase, 'SplineSeriesBase', HorizontalAnchoredCategorySeries.$);
    SplineSeriesBase.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, SplineSeriesBase, 'raisePropertyChanged', ['IsSplineShapePartOfRange:aaz:abc', [0, false], 'SplineType:aay:abd', [SplineType_$type, /*@__PURE__*/ enumGetBox(SplineType_$type, 0)]]);
    return SplineSeriesBase;
})();
/**
 * @hidden
 */
export let SplineSeriesBaseView = /*@__PURE__*/ (() => {
    class SplineSeriesBaseView extends AnchoredCategorySeriesView {
        constructor(a) {
            super(a);
            this.dd = null;
            this.dd = a;
        }
        de() {
            let a = 1;
            if (this.dd.c1 != null) {
                a = this.dd.c1.g9;
            }
            return Math.max(1 / (a * 3), 0.3);
        }
        af() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.uj = a;
            this.e.i2 = 3;
            this.e.i3 = 1;
            this.e.i4 = 4;
            this.e.gu = false;
        }
    }
    SplineSeriesBaseView.$t = /*@__PURE__*/ markType(SplineSeriesBaseView, 'SplineSeriesBaseView', AnchoredCategorySeriesView.$);
    return SplineSeriesBaseView;
})();
