/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryYAxis } from "./CategoryYAxis";
import { IVerticalAnchoredCategorySeriesInteractionManager_$type } from "./IVerticalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { runOn, typeCast, EnumUtil, markType, markDep } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { Rect } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
/**
 * @hidden
 */
export let VerticalAnchoredCategorySeries = /*@__PURE__*/ (() => {
    class VerticalAnchoredCategorySeries extends AnchoredCategorySeries {
        constructor() {
            super(...arguments);
            this.aac = null;
        }
        ca() {
            if (this.xAxis != null && this.xAxis.ch) {
                return 4;
            }
            return 3;
        }
        cb() {
            return 1;
        }
        n4() {
            super.n4();
            this.xAxis = null;
            this.yAxis = null;
        }
        get aad() {
            if (this.aac == null) {
                this.aac = DVContainer.instance.createInstance(IVerticalAnchoredCategorySeriesInteractionManager_$type, () => this.dg.n);
            }
            return this.aac;
        }
        get_isVertical() {
            return true;
        }
        w1() {
            return this.yAxis;
        }
        xh() {
            return this.xAxis;
        }
        getOffsetValue() {
            return this.w7.r(this.w1(), this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl));
        }
        getCategoryWidth() {
            return this.yAxis.getCategorySize(this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl));
        }
        jo(a, b) {
            return this.jp(a, b, this.w1(), runOn(this, this.x1), this.valueColumn);
        }
        jq(a, b) {
            return this.jr(a, b, this.w1(), runOn(this, this.x1), this.valueColumn);
        }
        h4(a, b, c, d, e) {
            if (this.valueColumn == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.h5(a, b, this.yAxis, d, e, this.valueColumn.count, runOn(this, this.x1));
        }
        ar(a) {
            if (a.isEmpty && this.c1 != null) {
                a = this.c1.vh;
            }
            if (this.valueColumn == null) {
                return null;
            }
            let b = this.u1(this.cl);
            let c = this.w1();
            let d = new ScalerParams(0, a, this.c1.vw, c.ch, this.getEffectiveViewport());
            let e = (c.em(b.top, d));
            let f = (c.em(b.bottom, d));
            if (!c.ch) {
                let g = e;
                e = f;
                f = g;
            }
            e -= this.y9;
            f += this.y9;
            let h = null;
            if (c.cn) {
                h = c;
                e = h.i$f(e);
                f = h.i$f(f);
            }
            else {
                e = Math.floor(e);
                f = Math.ceil(f);
            }
            if (isNaN_(e) || isNaN_(f)) {
                return null;
            }
            e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
            f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
            let i = 1.7976931348623157E+308;
            let j = -1.7976931348623157E+308;
            if (truncate(e) <= truncate(f)) {
                for (let k = truncate(e); k <= truncate(f); k++) {
                    let l = k;
                    if (h != null) {
                        l = h.i$b._inner[k];
                    }
                    let m = this.valueColumn.item(l);
                    if (this.valueColumn.mayContainUnknowns) {
                        if (isInfinity(m) || isNaN_(m)) {
                            continue;
                        }
                    }
                    i = Math.min(i, m);
                    j = Math.max(j, m);
                }
            }
            let n = new AxisRange(i, j);
            n = this.ap(n, this.xh(), a);
            return n;
        }
        bt() {
            if (this.bu == 0) {
                return 1;
            }
            else {
                return super.bt();
            }
        }
        u7(a) {
            if (!this.hasMarkers || !this.vr()) {
                return Rect.empty;
            }
            return this.aad.e$b(this, this.w2.n, a, runOn(this, this.aal));
        }
        aal(a) {
            return this.yv.dc(a);
        }
        gf(a, b) {
            if (this.ge(a, b)) {
                return true;
            }
            if (this.vs(a, b)) {
                return true;
            }
            return false;
        }
        il(a, b, c) {
            if (this.c1 == null) {
                return NaN;
            }
            let d = this.getEffectiveViewport1(this.cl);
            let e = this.w1();
            let f = new ScalerParams(0, this.c1.vh, this.cl.bx, e.ch, d);
            let g = this.w7.r(e, this.c1.vh, this.cl.bx, d);
            return this.io(this.valueColumn, a, e, f, g, runOn(this, this.x1), b, c);
        }
        uu(a, b, c) {
            let d = this.w1();
            return this.uw(a, b, c, this.w7.r(d, this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl)), this.xh(), d, null, null, null);
        }
        fetchXAxis() {
            return this.xAxis;
        }
        fetchYAxis() {
            return this.yAxis;
        }
        zp(a) {
            this.xAxis = typeCast(NumericXAxis.$, a);
        }
        zq(a) {
            this.yAxis = typeCast(CategoryYAxis.$, a);
        }
        xx() {
            return this.xAxis != null && this.xAxis.c1();
        }
        wv(a, b) {
            return this.ys(a, b, this.yAxis);
        }
        h6(a) {
            return this.aad.e$a(this, a);
        }
        x1(a) {
            return this.h8(a, this.w1());
        }
        jj(a) {
            return truncate(Math.round(this.h6(a)));
        }
        j2(a) {
            let b = this.jj(a);
            return b >= 0 && this.dd != null && b < this.dd.count ? this.dd.item(b) : null;
        }
        p5(a, b, c, d) {
            super.p5(a, b, c, d);
            switch (b) {
                case VerticalAnchoredCategorySeries.$$p[0]:
                    if (c != d) {
                        this.od(typeCast(Axis.$, c));
                        this.qc(typeCast(Axis.$, d));
                        this.xb.cu.g(this.hu);
                        if (this.c1 != null) {
                            this.c1.nm();
                        }
                        this.qm(false);
                        this.ph();
                    }
                    break;
                case VerticalAnchoredCategorySeries.$$p[1]:
                    if (c != d) {
                        this.od(typeCast(Axis.$, c));
                        this.qc(typeCast(Axis.$, d));
                        this.xb.cu.g(this.hu);
                        this.xx();
                        this.qm(false);
                        this.ph();
                    }
                    break;
                case "TrendLineType":
                    let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                    if (e != 0) {
                        this.yv.c5 = CategoryTrendLineManagerFactory.a(this.yv.c5, this.yAxis, this.ro, this, this.dg);
                    }
                    break;
            }
        }
        aag(a) {
            if (typeCast(CategoryYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        aaf(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        get useHighMarkerFidelity() {
            return this.xy;
        }
    }
    VerticalAnchoredCategorySeries.$t = /*@__PURE__*/ markType(VerticalAnchoredCategorySeries, 'VerticalAnchoredCategorySeries', AnchoredCategorySeries.$);
    VerticalAnchoredCategorySeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, VerticalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::aaj', [NumericXAxis.$, null], 'YAxis::aak', [CategoryYAxis.$, null]]);
    return VerticalAnchoredCategorySeries;
})();
