import { IgrPolarLineSeriesBase } from "./igr-polar-line-series-base";
import { PolarSplineAreaSeries } from "./PolarSplineAreaSeries";
/**
 * Represents a IgxDataChartComponent polar spline area series.
*/
export class IgrPolarSplineAreaSeries extends IgrPolarLineSeriesBase {
    createImplementation() {
        return new PolarSplineAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea() {
        return this.i.ef;
    }
    /**
     * Gets whether the current series shows a spline shape.
    */
    get isSpline() {
        return this.i.fl;
    }
    /**
     * Gets or sets the Stiffness property.
    */
    get stiffness() {
        return this.i.aa3;
    }
    set stiffness(v) {
        this.i.aa3 = +v;
    }
}
