import { IgrPolarLineSeriesBase } from "./igr-polar-line-series-base";
import { PolarSplineSeries } from "./PolarSplineSeries";
/**
 * Represents a IgxDataChartComponent polar spline series.
*/
export class IgrPolarSplineSeries extends IgrPolarLineSeriesBase {
    createImplementation() {
        return new PolarSplineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether the current series shows a spline shape.
    */
    get isSpline() {
        return this.i.fl;
    }
    /**
     * Gets or sets the Stiffness property.
    */
    get stiffness() {
        return this.i.aa3;
    }
    set stiffness(v) {
        this.i.aa3 = +v;
    }
}
