/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __generator, __values } from "tslib";
import { EventArgs, Base, markType, typeCast, runOn, delegateCombine, enumGetBox, Point_$type, String_$type, Number_$type, fromEnum, toEnum, Date_$type, markDep, Delegate_$type } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-react-core";
import { IFastItemColumn$1_$type } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { SeriesView } from "./SeriesView";
import { truncate, intDivide, isInfinity, isNaN_ } from "igniteui-react-core";
import { IHasCategoryAxis_$type } from "./IHasCategoryAxis";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode_$type } from "./CategoryMode";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FastReflectionHelper } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { Dictionary$2 } from "igniteui-react-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { FinancialValueList } from "./FinancialValueList";
import { CategoryXAxis } from "./CategoryXAxis";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { SafeReadOnlyDoubleCollection } from "./SafeReadOnlyDoubleCollection";
import { SafeEnumerable } from "./SafeEnumerable";
import { CalculatedColumn } from "./CalculatedColumn";
import { TrendCalculators } from "igniteui-react-core";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { dateToStringFormat } from "igniteui-react-core";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
import { SRProvider } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
var FinancialEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialEventArgs, _super);
    function FinancialEventArgs(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this._position = 0;
        _this._count = 0;
        _this._dataSource = null;
        _this._supportingCalculations = null;
        _this._basedOn = null;
        _this.position = a;
        _this.count = b;
        _this.dataSource = c;
        _this.supportingCalculations = d;
        if (c != null) {
            c.series = e;
        }
        return _this;
    }
    Object.defineProperty(FinancialEventArgs.prototype, "position", {
        get: function () {
            return this._position;
        },
        set: function (a) {
            this._position = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (a) {
            this._dataSource = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "supportingCalculations", {
        get: function () {
            return this._supportingCalculations;
        },
        set: function (a) {
            this._supportingCalculations = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "basedOn", {
        get: function () {
            return this._basedOn;
        },
        set: function (a) {
            this._basedOn = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialEventArgs.$t = markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
    return FinancialEventArgs;
}(EventArgs));
export { FinancialEventArgs };
/**
 * @hidden
 */
var FinancialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialBucketCalculator, _super);
    function FinancialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.a = a;
        _this.c = -1;
        _this.d = _this.d;
        _this.b = 0;
        return _this;
    }
    FinancialBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    FinancialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    FinancialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    FinancialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.b2.hu;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    FinancialBucketCalculator.prototype.e = function (a) {
        var b = this.a.by;
        var c = this.a.bx;
        var d = this.a.bx;
        if (this.a.b2 != null) {
            d = this.a.b2.getEffectiveViewport1(this.a);
        }
        if (b.isEmpty || c.isEmpty || this.a.b2.vl == null) {
            this.b = 0;
            return;
        }
        var e = (this.a.b2.vl != null) ? this.a.b2.vl.ch : false;
        var f = new ScalerParams(0, b, c, e, d);
        var g = this.a.b2.u1(this.a);
        var h = typeCast(ISortingAxis_$type, this.a.b2.vl);
        if (h == null || h.i$b == null) {
            var i = Math.floor(this.a.b2.vl.em(g.left, f));
            var j = Math.ceil(this.a.b2.vl.em(g.right, f));
            if (this.a.b2.vl.ch) {
                j = Math.ceil(this.a.b2.vl.em(g.left, f));
                i = Math.floor(this.a.b2.vl.em(g.right, f));
            }
            var k = Math.floor((j - i + 1) * a / g.width);
            this.b = truncate(Math.max(1, k));
            this.c = truncate(Math.floor(i / this.b));
            this.d = truncate(Math.ceil(j / this.b));
        }
        else {
            this.c = h.i$e(b, c, d, g);
            this.d = h.i$g(b, c, d, g);
            this.b = 1;
        }
    };
    FinancialBucketCalculator.prototype.cacheValues = function () {
    };
    FinancialBucketCalculator.prototype.unCacheValues = function () {
    };
    FinancialBucketCalculator.$t = markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
    return FinancialBucketCalculator;
}(Base));
export { FinancialBucketCalculator };
/**
 * @hidden
 */
var FinancialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialSeries, _super);
    function FinancialSeries() {
        var _this = _super.call(this) || this;
        _this.wc = null;
        _this.wa = null;
        _this.wb = null;
        _this.v9 = null;
        _this.wd = null;
        _this.wm = false;
        _this.assigningCategoryStyle = null;
        _this.vu = null;
        _this.ww = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
        _this.wx = new Dictionary$2(String_$type, String_$type, 0);
        _this.wl = false;
        _this.v8 = null;
        _this.vp = null;
        _this.vr = null;
        _this.vn = null;
        _this.vx = null;
        _this.typical = null;
        _this.typicalBasedOn = null;
        _this.wk = false;
        _this.w9 = null;
        _this.w7 = null;
        _this.w8 = null;
        _this.w6 = null;
        _this.xa = null;
        _this.vq = null;
        _this.vm = null;
        _this.vs = 0;
        _this.v3 = null;
        _this.v5 = null;
        _this.vu = new CategorySeriesRenderManager();
        _this.wm = false;
        _this.vx = new CategoryTransitionSourceFramePreparer();
        _this.vq = new CategoryFrame(3);
        _this.ab = FinancialSeries.$;
        _this.vt = 0;
        return _this;
    }
    FinancialSeries.prototype.hb = function () {
        var a = _super.prototype.hb.call(this);
        {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "OpenMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedOpenMemberPath";
                $ret.q = true;
                return $ret;
            })());
            b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.yo));
            a.add(b);
        }
        {
            var c = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "HighMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedHighMemberPath";
                $ret.q = true;
                return $ret;
            })());
            c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.ym));
            a.add(c);
        }
        {
            var d = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "LowMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedLowMemberPath";
                $ret.q = true;
                return $ret;
            })());
            d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.yn));
            a.add(d);
        }
        {
            var e = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "CloseMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedCloseMemberPath";
                $ret.q = true;
                return $ret;
            })());
            e.valueResolving = delegateCombine(e.valueResolving, runOn(this, this.yl));
            a.add(e);
        }
        {
            var f = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "VolumeMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedVolumeMemberPath";
                $ret.q = true;
                return $ret;
            })());
            f.valueResolving = delegateCombine(f.valueResolving, runOn(this, this.yp));
            a.add(f);
        }
        {
            var g = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Brush";
                $ret.p = true;
                $ret.y = "ActualBrush";
                $ret.q = true;
                return $ret;
            })());
            g.valueResolving = delegateCombine(g.valueResolving, runOn(this, this.qu));
            a.add(g);
        }
        {
            var h = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Outline";
                $ret.p = true;
                $ret.y = "ActualOutline";
                $ret.q = true;
                return $ret;
            })());
            h.valueResolving = delegateCombine(h.valueResolving, runOn(this, this.qu));
            a.add(h);
        }
        {
            var i = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "NegativeBrush";
                $ret.p = true;
                $ret.q = true;
                return $ret;
            })());
            i.valueResolving = delegateCombine(i.valueResolving, runOn(this, this.qu));
            a.add(i);
        }
        {
            var j = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "NegativeOutline";
                $ret.p = true;
                $ret.q = true;
                return $ret;
            })());
            j.valueResolving = delegateCombine(j.valueResolving, runOn(this, this.qu));
            a.add(j);
        }
        var k = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "IsTransitionInEnabled";
            $ret.x = true;
            $ret.q = true;
            return $ret;
        })());
        a.add(k);
        var l = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "TransitionInMode";
            $ret.x = enumGetBox(CategoryTransitionInMode_$type, 20);
            $ret.q = true;
            return $ret;
        })());
        a.add(l);
        return a;
    };
    FinancialSeries.prototype.yo = function (a, b) {
        if (this.xy != null) {
            b.value = this.xy;
            return;
        }
        b.value = this.yb;
    };
    FinancialSeries.prototype.ym = function (a, b) {
        if (this.xu != null) {
            b.value = this.xu;
            return;
        }
        b.value = this.x2;
    };
    FinancialSeries.prototype.yn = function (a, b) {
        if (this.xw != null) {
            b.value = this.xw;
            return;
        }
        b.value = this.x7;
    };
    FinancialSeries.prototype.yl = function (a, b) {
        if (this.xs != null) {
            b.value = this.xs;
            return;
        }
        b.value = this.xp;
    };
    FinancialSeries.prototype.yp = function (a, b) {
        if (this.x0 != null) {
            b.value = this.x0;
            return;
        }
        b.value = this.yf;
    };
    FinancialSeries.prototype.j7 = function () {
        if (this.dr()) {
            return this.be.vr;
        }
        else {
            return this.be.vn;
        }
    };
    FinancialSeries.prototype.px = function (a) {
        _super.prototype.px.call(this, a);
        this.v2 = a;
    };
    FinancialSeries.prototype.get_er = function () {
        return true;
    };
    FinancialSeries.prototype.ag = function () {
        return [this.vl, this.v4];
    };
    FinancialSeries.prototype.j5 = function (a, b) {
        var c = this.mh(b);
        if (c == FinancialSeries.$$p[11]) {
            return this.j6(a, b, this.yb);
        }
        if (c == FinancialSeries.$$p[1]) {
            return this.j6(a, b, this.x2);
        }
        if (c == FinancialSeries.$$p[9]) {
            return this.j6(a, b, this.x7);
        }
        if (c == FinancialSeries.$$p[0]) {
            return this.j6(a, b, this.xp);
        }
        if (c == FinancialSeries.$$p[13]) {
            return this.j6(a, b, this.yf);
        }
        if (c == FinancialSeries.$$p[5]) {
            return this.j6(a, b, this.xy);
        }
        if (c == FinancialSeries.$$p[3]) {
            return this.j6(a, b, this.xu);
        }
        if (c == FinancialSeries.$$p[4]) {
            return this.j6(a, b, this.xw);
        }
        if (c == FinancialSeries.$$p[2]) {
            return this.j6(a, b, this.xs);
        }
        if (c == FinancialSeries.$$p[6]) {
            return this.j6(a, b, this.x0);
        }
        return _super.prototype.j5.call(this, a, b);
    };
    FinancialSeries.prototype.li = function (a) {
        var b = this.mh(a);
        if (b == FinancialSeries.$$p[11]) {
            return this.yb;
        }
        if (b == FinancialSeries.$$p[1]) {
            return this.x2;
        }
        if (b == FinancialSeries.$$p[9]) {
            return this.x7;
        }
        if (b == FinancialSeries.$$p[0]) {
            return this.xp;
        }
        if (b == FinancialSeries.$$p[13]) {
            return this.yf;
        }
        if (b == FinancialSeries.$$p[5]) {
            return this.xy;
        }
        if (b == FinancialSeries.$$p[3]) {
            return this.xu;
        }
        if (b == FinancialSeries.$$p[4]) {
            return this.xw;
        }
        if (b == FinancialSeries.$$p[2]) {
            return this.xs;
        }
        if (b == FinancialSeries.$$p[6]) {
            return this.x0;
        }
        return _super.prototype.li.call(this, a);
    };
    FinancialSeries.prototype.xl = function () {
        return 2;
    };
    FinancialSeries.prototype.xj = function () {
        return 4;
    };
    FinancialSeries.prototype.ah = function (a) {
        var b = this.aj(this.vl, this.vn.f, this.xi(this.cl), this.xk(this.cl), this.uz(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        var g = this.xl();
        f[0] = { $type: Point_$type, x: c[0], y: c[g] };
        f[1] = { $type: Point_$type, x: d[0], y: d[g] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.ai = function (a) {
        var b = this.aj(this.vl, this.vn.f, this.xi(this.cl), this.xk(this.cl), this.uz(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.ue = function () {
        return this.zb;
    };
    FinancialSeries.prototype.uf = function () {
        return this.zb;
    };
    FinancialSeries.prototype.n4 = function () {
        _super.prototype.n4.call(this);
        this.vl = null;
        this.v4 = null;
    };
    FinancialSeries.prototype.get_d6 = function () {
        return true;
    };
    FinancialSeries.prototype.get_fq = function () {
        return this.v4 != null && this.v4.ch;
    };
    Object.defineProperty(FinancialSeries.prototype, "wh", {
        get: function () {
            return this.wc;
        },
        set: function (a) {
            if (this.wc != a) {
                var b = this.wc;
                this.wc = a;
                this.raisePropertyChanged("OpenColumn", b, this.wc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "wf", {
        get: function () {
            return this.wa;
        },
        set: function (a) {
            if (this.wa != a) {
                var b = this.wa;
                this.wa = a;
                this.raisePropertyChanged("HighColumn", b, this.wa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "wg", {
        get: function () {
            return this.wb;
        },
        set: function (a) {
            if (this.wb != a) {
                var b = this.wb;
                this.wb = a;
                this.raisePropertyChanged("LowColumn", b, this.wb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "we", {
        get: function () {
            return this.v9;
        },
        set: function (a) {
            if (this.v9 != a) {
                var b = this.v9;
                this.v9 = a;
                this.raisePropertyChanged("CloseColumn", b, this.v9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "wj", {
        get: function () {
            return this.wd;
        },
        set: function (a) {
            if (this.wd != a) {
                var b = this.wd;
                this.wd = a;
                this.raisePropertyChanged("VolumeColumn", b, this.wd);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.fv = function () {
        return this.highlightedItemsSource != null || (this.xy != null && this.xu != null && this.xw != null && this.xs != null);
    };
    FinancialSeries.prototype.wt = function () {
        return (this.assigningCategoryStyle != null && this.wm) || this.bo != 1 || this.cf != 1 || this.ce != 1;
    };
    FinancialSeries.prototype.ys = function (a) {
        if (this.assigningCategoryStyle != null && this.wm) {
            this.assigningCategoryStyle(this, a);
        }
    };
    FinancialSeries.prototype.yq = function (a, b, c, d, e, f, g) {
        var h = this.bo != 1;
        var i = this.cf != 1;
        var j = this.ce != 1;
        this.vu.a3(this.vu.b, d.cn, a, b, c, d, e, f, false, g);
        this.vu.ab(this.hs);
        var k = this.vu.ay;
        var l = null;
        var m = null;
        var n = null;
        var o = this.dd;
        if (h && this.c1 != null) {
            l = this.c1.dj.getHighlightingInfo(this, o, k.z, k.y, false);
            k.c = l;
        }
        if (i && this.c1 != null) {
            m = this.c1.dk.getHighlightingInfo(this, o, k.z, k.y, false);
            if (m == null && this.be != null) {
                m = this.c1.dk.getHighlightingInfo(this.be, this.be.dd, k.z, k.y, false);
            }
            k.d = m;
        }
        if (j && this.c1 != null) {
            n = this.c1.di.getHighlightingInfo(this, o, k.z, k.y, false);
            k.b = n;
        }
        k.h = f;
        this.ys(k);
        this.vu.z(this, l, m, n, f, h, i, j, b < 0);
    };
    FinancialSeries.prototype.xb = function (a) {
        return this.h8(a, this.vl);
    };
    FinancialSeries.prototype.jq = function (a, b) {
        return this.jr(a, b, this.vl, runOn(this, this.xb), new FinancialValueList(this.wh, this.wf, this.wg, this.we, this.wj));
    };
    FinancialSeries.prototype.jo = function (a, b) {
        return this.jp(a, b, this.vl, runOn(this, this.xb), new FinancialValueList(this.wh, this.wf, this.wg, this.we, this.wj));
    };
    FinancialSeries.prototype.h4 = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.vl.lf;
        return this.h5(a, b, this.vl, d, e, f, runOn(this, this.xb));
    };
    FinancialSeries.prototype.getOffsetValue = function () {
        return this.xc(this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl));
    };
    FinancialSeries.prototype.getCategoryWidth = function () {
        return this.vl.getCategorySize(this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl));
    };
    FinancialSeries.prototype.uu = function (a, b, c) {
        return this.uw(a, b, c, this.xc(this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl)), this.v4, this.vl, null, null, null);
    };
    FinancialSeries.prototype.il = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cl);
        var e = this.xc(this.cl.by, this.cl.bx, d);
        var f = new ScalerParams(0, this.cl.by, this.cl.bx, this.vl.ch, d);
        return this.io(new FinancialValueList(this.wh, this.wf, this.wg, this.we, this.wj), a, this.vl, f, e, runOn(this, this.xb), b, c);
    };
    FinancialSeries.prototype.ih = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cl);
        var e = this.xc(this.cl.by, this.cl.bx, d);
        var f = new ScalerParams(0, this.cl.by, this.cl.bx, this.vl.ch, d);
        return this.io(this.wf, a, this.vl, f, e, runOn(this, this.xb), b, c);
    };
    FinancialSeries.prototype.ij = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cl);
        var e = this.xc(this.cl.by, this.cl.bx, d);
        var f = new ScalerParams(0, this.cl.by, this.cl.bx, this.vl.ch, d);
        return this.io(this.wg, a, this.vl, f, e, runOn(this, this.xb), b, c);
    };
    FinancialSeries.prototype.xd = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cl);
        var e = this.xc(this.cl.by, this.cl.bx, d);
        var f = new ScalerParams(0, this.cl.by, this.cl.bx, this.vl.ch, d);
        return this.io(this.we, a, this.vl, f, e, runOn(this, this.xb), b, c);
    };
    FinancialSeries.prototype.xe = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cl);
        var e = this.xc(this.cl.by, this.cl.bx, d);
        var f = new ScalerParams(0, this.cl.by, this.cl.bx, this.vl.ch, d);
        return this.io(this.wh, a, this.vl, f, e, runOn(this, this.xb), b, c);
    };
    FinancialSeries.prototype.xf = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cl);
        var e = this.xc(this.cl.by, this.cl.bx, d);
        var f = new ScalerParams(0, this.cl.by, this.cl.bx, this.vl.ch, d);
        return this.io(this.wj, a, this.vl, f, e, runOn(this, this.xb), b, c);
    };
    FinancialSeries.prototype.uq = function (a, b, c) {
        var _this = this;
        return this.uw(a, b, c, this.xc(this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl)), this.v4, this.vl, runOn(this, this.ih), function (d, e) { return _this.jr(d, e, _this.vl, runOn(_this, _this.xb), _this.wf); }, function (d, e) { return _this.jp(d, e, _this.vl, runOn(_this, _this.xb), _this.wf); });
    };
    FinancialSeries.prototype.us = function (a, b, c) {
        var _this = this;
        return this.uw(a, b, c, this.xc(this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl)), this.v4, this.vl, runOn(this, this.ij), function (d, e) { return _this.jr(d, e, _this.vl, runOn(_this, _this.xb), _this.wg); }, function (d, e) { return _this.jp(d, e, _this.vl, runOn(_this, _this.xb), _this.wg); });
    };
    FinancialSeries.prototype.zd = function (a, b, c) {
        var _this = this;
        return this.uw(a, b, c, this.xc(this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl)), this.v4, this.vl, runOn(this, this.xe), function (d, e) { return _this.jr(d, e, _this.vl, runOn(_this, _this.xb), _this.wh); }, function (d, e) { return _this.jp(d, e, _this.vl, runOn(_this, _this.xb), _this.wh); });
    };
    FinancialSeries.prototype.zc = function (a, b, c) {
        var _this = this;
        return this.uw(a, b, c, this.xc(this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl)), this.v4, this.vl, runOn(this, this.xd), function (d, e) { return _this.jr(d, e, _this.vl, runOn(_this, _this.xb), _this.we); }, function (d, e) { return _this.jp(d, e, _this.vl, runOn(_this, _this.xb), _this.we); });
    };
    FinancialSeries.prototype.ze = function (a, b, c) {
        var _this = this;
        return this.uw(a, b, c, this.xc(this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl)), this.v4, this.vl, runOn(this, this.xf), function (d, e) { return _this.jr(d, e, _this.vl, runOn(_this, _this.xb), _this.wj); }, function (d, e) { return _this.jp(d, e, _this.vl, runOn(_this, _this.xb), _this.wj); });
    };
    FinancialSeries.prototype.o6 = function () {
        _super.prototype.o6.call(this);
        if (this.vl != null) {
            this.vl.h8(false);
        }
        if (this.v4 != null) {
            this.v4.h8(false);
        }
    };
    FinancialSeries.prototype.rk = function (a, b) {
        this.v2.b0.e(this.hu);
        this.qm(false);
    };
    FinancialSeries.prototype.rj = function (a, b) {
        if (this.gk && this.i6 < 0.05) {
            this.gl = true;
            this.go = false;
            this.f4 = false;
        }
        this.v2.b0.e(this.hu);
        this.qm(false);
    };
    FinancialSeries.prototype.wi = function (a, b, c) {
        var d = this.da(b);
        this.ww.addItem(d, b);
        this.wx.addItem(b, c);
        return d;
    };
    FinancialSeries.prototype.yk = function (a, b) {
        if (b == null) {
            return;
        }
        a.deregisterColumn(b);
        var c = this.ww.item(b);
        this.wx.removeItem(c);
        this.ww.removeItem(b);
    };
    FinancialSeries.prototype.p5 = function (a, b, c, d) {
        _super.prototype.p5.call(this, a, b, c, d);
        switch (b) {
            case "SyncLink":
                if (this.ct != null && this.c1 != null) {
                    this.v2.b0.e(this.hu);
                    this.qm(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.vl != null) {
                        this.vl.b0(this);
                    }
                    if (this.v4 != null) {
                        this.v4.b0(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.vl != null) {
                        this.vl.ct(this);
                    }
                    if (this.v4 != null) {
                        this.v4.ct(this);
                    }
                }
                this.v2.b0.e(this.hu);
                this.qm(false);
                break;
            case "FastItemsSource":
                this.wl = true;
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    this.yk(typeCast(IFastItemsSource_$type, c), this.wh);
                    this.yk(typeCast(IFastItemsSource_$type, c), this.wf);
                    this.yk(typeCast(IFastItemsSource_$type, c), this.wg);
                    this.yk(typeCast(IFastItemsSource_$type, c), this.we);
                    this.yk(typeCast(IFastItemsSource_$type, c), this.wj);
                    this.wh = null;
                    this.wf = null;
                    this.wg = null;
                    this.we = null;
                    this.wj = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    if (stringIsNullOrEmpty(this.yb) == false) {
                        this.wh = this.wi(typeCast(IFastItemsSource_$type, d), this.yb, "OpenColumn");
                    }
                    if (stringIsNullOrEmpty(this.x2) == false) {
                        this.wf = this.wi(typeCast(IFastItemsSource_$type, d), this.x2, "HighColumn");
                    }
                    if (stringIsNullOrEmpty(this.x7) == false) {
                        this.wg = this.wi(typeCast(IFastItemsSource_$type, d), this.x7, "LowColumn");
                    }
                    if (stringIsNullOrEmpty(this.xp) == false) {
                        this.we = this.wi(typeCast(IFastItemsSource_$type, d), this.xp, "CloseColumn");
                    }
                    if (stringIsNullOrEmpty(this.yf) == false) {
                        this.wj = this.wi(typeCast(IFastItemsSource_$type, d), this.yf, "VolumeColumn");
                    }
                }
                this.wl = false;
                if (this.v4 != null && !this.v4.c1()) {
                    this.v2.b0.e(this.hu);
                    this.qm(this.f0 && c != null);
                }
                break;
            case FinancialSeries.$$p[11]:
                if (this.dd != null) {
                    this.yk(this.dd, this.wh);
                    this.wh = this.wi(this.dd, this.yb, "OpenColumn");
                }
                break;
            case "OpenColumn":
                if (this.v4 != null && !this.v4.c1() && !this.wl) {
                    this.v2.b0.e(this.hu);
                    this.qm(this.f0 && this.dv);
                }
                break;
            case FinancialSeries.$$p[1]:
                if (this.dd != null) {
                    this.yk(this.dd, this.wf);
                    this.wf = this.wi(this.dd, this.x2, "HighColumn");
                }
                break;
            case "HighColumn":
                if (this.v4 != null && !this.v4.c1() && !this.wl) {
                    this.v2.b0.e(this.hu);
                    this.qm(this.f0 && this.dv);
                }
                break;
            case FinancialSeries.$$p[9]:
                if (this.dd != null) {
                    this.yk(this.dd, this.wg);
                    this.wg = this.wi(this.dd, this.x7, "LowColumn");
                }
                break;
            case "LowColumn":
                if (this.v4 != null && !this.v4.c1() && !this.wl) {
                    this.v2.b0.e(this.hu);
                    this.qm(this.f0 && this.dv);
                }
                break;
            case FinancialSeries.$$p[0]:
                if (this.dd != null) {
                    this.yk(this.dd, this.we);
                    this.we = this.wi(this.dd, this.xp, "CloseColumn");
                }
                break;
            case "CloseColumn":
                if (this.v4 != null && !this.v4.c1() && !this.wl) {
                    this.v2.b0.e(this.hu);
                    this.qm(this.f0 && this.dv);
                }
                this.yu();
                break;
            case FinancialSeries.$$p[13]:
                if (this.dd != null) {
                    this.yk(this.dd, this.wj);
                    this.wj = this.wi(this.dd, this.yf, "VolumeColumn");
                }
                break;
            case "VolumeColumn":
                if (this.v4 != null && !this.v4.c1() && !this.wl) {
                    this.v2.b0.e(this.hu);
                    this.qm(this.f0 && this.dv);
                }
                break;
            case FinancialSeries.$$p[14]:
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.v2.b0.e(this.hu);
                this.qm(false);
                this.ph();
                this.v3 = typeCast(ITimeRangeSelectorAxis_$type, this.vl);
                break;
            case FinancialSeries.$$p[15]:
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.v2.b0.e(this.hu);
                if (this.v4 != null) {
                    this.v4.c1();
                }
                {
                    this.qm(false);
                }
                this.ph();
                break;
            case "TransitionProgress":
                this.vr.c(this.i6, this.vp, this.vn);
                if (this.dt(this.cl)) {
                    return;
                }
                if (this.i6 == 1) {
                    this.vn.w();
                    this.yt(this.vn, this.v2);
                    if (this.gk) {
                        this.gk = false;
                        this.n8();
                        this.c2.r = truncate(this.iq());
                        this.c2.b = this.c3;
                    }
                    if (this.gn) {
                        this.gn = false;
                        this.n8();
                        this.c2.r = truncate(this.iq());
                        this.c2.b = this.c3;
                        this.pw();
                    }
                    this.pk();
                }
                else {
                    this.yt(this.vr, this.v2);
                }
                if (this.c1 != null) {
                    this.c1.p6(this);
                }
                break;
            case FinancialSeries.$$p[10]:
                this.qm(false);
                break;
            case "IsCustomCategoryStyleAllowed":
                this.wm = this.wp();
                this.qm(false);
                break;
            case "CategoryMode":
                if (this.vl != null) {
                    this.vl.l5(true);
                }
                break;
        }
    };
    FinancialSeries.prototype.wo = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.wn = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.ce) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.ve = function (a, b, c) {
        if (b < a || a < 0 || a > this.dd.count || b < 0 || b > this.dd.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cn;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.dd.item(g);
        }
        return d;
    };
    FinancialSeries.prototype.xi = function (a) {
        return a.b0.b;
    };
    FinancialSeries.prototype.xk = function (a) {
        return a.b0.c;
    };
    FinancialSeries.prototype.vd = function (a, b) {
        return this.ve(a, b, this.v4);
    };
    FinancialSeries.prototype.get_ez = function () {
        return true;
    };
    FinancialSeries.prototype.n5 = function () {
        _super.prototype.n5.call(this);
        this.v8 = null;
    };
    FinancialSeries.prototype.c6 = function (a, b, c) {
        if (this.d1 && this.fk(this.bo) && !c) {
            var d = this.v7(a, b, this.v8);
            this.v8 = d;
            return d;
        }
        else {
            var e = this.v6(a, b, this.v8);
            this.v8 = e;
            return e;
        }
    };
    FinancialSeries.prototype.xm = function (a) {
        var b = this.vo();
        var c = this.cl.bx;
        var d = this.cl.by;
        var e = this.vl;
        var f = 0;
        if (e.cp) {
            var g = (a.y - d.top) / d.height;
            f = g * c.height + c.top;
        }
        else {
            var h = (a.x - d.left) / d.width;
            f = h * c.width + c.left;
        }
        var i = b.f.count;
        var j = 0;
        for (j = 0; j < i; j++) {
            var k = b.f._inner[j];
            var l = null;
            if (j < i - 1) {
                l = b.f._inner[j + 1];
            }
            if (k[0] <= f && l == null || l[0] >= f) {
                if (l != null) {
                    if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                        return j;
                    }
                    else {
                        return j + 1;
                    }
                }
                else {
                    return j;
                }
            }
        }
        return j;
    };
    FinancialSeries.prototype.v7 = function (a, b, c) {
        var d = this.dd.count;
        var e = this.v2.b0.c;
        var f = this.v2.b0.d;
        var g = this.v2.b0.b;
        var h = this.vl;
        var i = -1;
        var j = -1;
        if (h.cn) {
            var k = this.vo();
            var l = this.xm(b);
            if (k.m != null && l >= 0 && l < k.m.count) {
                l = truncate(Math.round(k.m._inner[l]));
            }
            i = l;
            j = l;
        }
        else {
            var m = this.jj(b);
            i = truncate(Math.floor((intDivide(m, g)))) * g;
            j = i + (g - 1);
        }
        if (c != null && c.g == i && c.f == j) {
            return c;
        }
        var n = new HighlightingInfo();
        n.i = this;
        n.g = i;
        n.f = j;
        return n;
    };
    FinancialSeries.prototype.v6 = function (a, b, c) {
        var d = new HighlightingInfo();
        d.i = this;
        d.g = 0;
        d.f = this.dd.count - 1;
        d.c = true;
        if (c != null && c.g == d.g && c.f == d.f) {
            return c;
        }
        return d;
    };
    FinancialSeries.prototype.wp = function () {
        return this.wr;
    };
    FinancialSeries.prototype.h6 = function (a) {
        var b = this.cl.by;
        var c = this.cl.bx;
        var d = -1;
        if (!b.isEmpty && !c.isEmpty && this.vl != null) {
            var e = this.getEffectiveViewport1(this.cl);
            var f = new ScalerParams(0, b, c, this.vl.ch, e);
            var g = this.u1(this.cl);
            var h = this.vl.em(g.left, f);
            var i = this.vl.em(g.right, f);
            var j = (a.x - b.left) / b.width;
            var k = h + (j * (i - h));
            if (this.vl.categoryMode != 0) {
                k -= 0.5;
            }
            d = k;
        }
        return d;
    };
    FinancialSeries.prototype.jj = function (a) {
        return truncate(Math.round(this.h6(a)));
    };
    FinancialSeries.prototype.get_fd = function () {
        return typeCast(ISortingAxis_$type, this.vl) !== null;
    };
    FinancialSeries.prototype.as = function () {
        return this.vl;
    };
    FinancialSeries.prototype.jl = function (a) {
        var b = this.cl.by;
        var c = this.cl.bx;
        var d = this.getEffectiveViewport1(this.cl);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        var e = new Rect(0, 0, 0, 1, 1);
        var f = new ScalerParams(0, b, c, this.vl.ch, d);
        var g = typeCast(ISortingAxis_$type, this.vl);
        var h = this.u1(this.cl);
        var i = h.left;
        var j = h.right;
        var k = this.up(a).x;
        var l = this.vl.em(k, f);
        var m = this.vl.em(i, f);
        var n = this.vl.em(j, f);
        l = Math.max(m, Math.min(n, l));
        var o = g.i$f(l);
        return o;
    };
    FinancialSeries.prototype.j2 = function (a) {
        var b = 0;
        if (typeCast(ISortingAxis_$type, this.vl) !== null) {
            b = this.jl(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.jj(a);
        }
        return b >= 0 && this.dd != null && b < this.dd.count ? this.dd.item(b) : null;
    };
    FinancialSeries.prototype.vo = function () {
        var a = this.vn;
        if (this.dr()) {
            if (this.c2.g) {
                this.c2.t();
            }
            a = this.vr;
        }
        return a;
    };
    FinancialSeries.prototype.xc = function (a, b, c) {
        if (this.vl == null) {
            return 0;
        }
        return this.vl.k5(a, b, c, this.index);
    };
    FinancialSeries.prototype.f7 = function () {
        return this.ws;
    };
    FinancialSeries.prototype.vv = function () {
        return 11;
    };
    FinancialSeries.prototype.cu = function () {
        return 3;
    };
    FinancialSeries.prototype.cx = function () {
        return 3;
    };
    FinancialSeries.prototype.yt = function (a, b) {
        this.pt();
        this.u0 = a.ab;
        b.aw();
    };
    FinancialSeries.prototype.yr = function (a, b) {
        a.v();
    };
    FinancialSeries.prototype.gw = function (a, b, c) {
        var d = _super.prototype.gw.call(this, a, b, c);
        var e = c;
        if (this.dd == null || this.dd.count == 0 || !c.o() || b.isEmpty || a.isEmpty || this.vl == null || this.v4 == null || e.b0.b < 1 || this.vl.bi == null || this.v4.bi == null || this.v4.lx == this.v4.lw || this.vl.itemsSource == null || this.vl.lf < 1) {
            e.b0.b = 0;
            d = false;
        }
        return d;
    };
    FinancialSeries.prototype.getViewInfo = function (a, b) {
        b = this.cl.by;
        a = this.cl.bx;
        return {
            p0: a,
            p1: b
        };
    };
    FinancialSeries.prototype.xg = function (a) {
        var b = 0;
        var c = a.by;
        var d = a.bx;
        var e = this.getEffectiveViewport1(this.cl);
        if (!c.isEmpty && !d.isEmpty && this.v4 != null) {
            var f = new ScalerParams(0, c, d, this.v4.ch, e);
            f.b = this.id();
            b = this.v4.ej(this.v4.l7, f);
        }
        return b;
    };
    FinancialSeries.prototype.n8 = function () {
        _super.prototype.n8.call(this);
        this.vp.w();
        this.vn.w();
        this.vr.w();
    };
    FinancialSeries.prototype.qn = function (a) {
        var _this = this;
        _super.prototype.qn.call(this, a);
        this.v2.b0.e(this.hu);
        if (this.dt(this.cl)) {
            return;
        }
        if (this.gb) {
            if (this.dr()) {
                this.yt(this.vr, this.v2);
            }
            else {
                this.yt(this.vn, this.v2);
            }
            return;
        }
        if (this.fz(a)) {
            var b = this.vp;
            if (this.dr()) {
                if (this.c2.g) {
                    this.c2.t();
                }
                this.vp = this.vr;
                this.vr = b;
            }
            else {
                this.vp = this.vn;
                this.vn = b;
            }
            this.yr(this.vn, this.v2);
            var c = false;
            if (this.gm) {
                this.c2.w();
                this.c2.r = truncate(this.ir());
                this.c2.b = this.c4 != null ? this.c4 : this.c3;
                if (this.gn) {
                    var d = this.vr;
                    this.vr = this.vp;
                    this.vp = d;
                    c = true;
                }
                this.vx.s(this, this.vp, this.vn, this.isVertical, this.vl, this.v4, this.vw, this.vv(), this.cv, this.cu(), function () { return _this.xg(_this.v2); }, this.v2.bx);
                if (this.gn) {
                    var e = this.vr;
                    this.vr = this.vp;
                    this.vp = e;
                }
                this.gn = false;
            }
            if (this.gp) {
                this.c2.w();
                this.c2.r = truncate(this.is());
                this.c2.b = this.c5 != null ? this.c5 : this.c3;
                if (this.gk) {
                    var f = this.vr;
                    this.vr = this.vp;
                    this.vp = f;
                    c = true;
                }
                this.vx.s(this, this.vp, this.vn, this.isVertical, this.vl, this.v4, this.vw, this.vv(), this.cv, this.cu(), function () { return _this.xg(_this.v2); }, this.v2.bx);
                var g = this.vn;
                this.vn = this.vp;
                this.vp = g;
                if (this.gk) {
                    var h = this.vr;
                    this.vr = this.vp;
                    this.vp = h;
                }
                this.gk = false;
            }
            this.dx = false;
            if (!c) {
                this.n3();
            }
            this.q0();
            if (this.gm) {
                this.gl = false;
                this.go = false;
                this.f4 = false;
                this.gk = true;
            }
            if (this.gp) {
                this.go = false;
                this.gn = true;
            }
        }
        else {
            this.yr(this.vn, this.v2);
            this.yt(this.vn, this.v2);
        }
    };
    FinancialSeries.prototype.f8 = function () {
        return true;
    };
    FinancialSeries.prototype.wu = function (a) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                switch (b) {
                    case "HighColumn":
                        if (this.wf == null) {
                            return false;
                        }
                        break;
                    case "LowColumn":
                        if (this.wg == null) {
                            return false;
                        }
                        break;
                    case "OpenColumn":
                        if (this.wh == null) {
                            return false;
                        }
                        break;
                    case "CloseColumn":
                        if (this.we == null) {
                            return false;
                        }
                        break;
                    case "VolumeColumn":
                        if (this.wj == null) {
                            return false;
                        }
                        break;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    Object.defineProperty(FinancialSeries.prototype, "wv", {
        get: function () {
            return this.vl != null && typeCast(ISortingAxis_$type, this.vl) !== null;
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.wq = function () {
        return this.typical != null;
    };
    FinancialSeries.prototype.yj = function (a) {
        this.typical(this, a);
    };
    Object.defineProperty(FinancialSeries.prototype, "w3", {
        get: function () {
            return this.w0();
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype._w0 = function () {
        var a, b, _a, _b, c, e_2_1, d, e, f, g, h;
        var e_2, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    a = false;
                    if (!this.wq())
                        return [3 /*break*/, 8];
                    b = this.vy(0, this.dd.count);
                    this.yj(new FinancialEventArgs(0, this.dd.count, b, this.vz(b), this));
                    if (!(b.typicalColumn != null))
                        return [3 /*break*/, 8];
                    a = true;
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 6, 7, 8]);
                    _a = __values(fromEnum(b.typicalColumn)), _b = _a.next();
                    _d.label = 2;
                case 2:
                    if (!!_b.done)
                        return [3 /*break*/, 5];
                    c = _b.value;
                    return [4 /*yield*/, c];
                case 3:
                    _d.sent();
                    _d.label = 4;
                case 4:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_2_1 = _d.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_b && !_b.done && (_c = _a.return))
                            _c.call(_a);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                    return [7 /*endfinally*/];
                case 8:
                    if (!!a)
                        return [3 /*break*/, 17];
                    if (!(this.wv && this.vl.i$b != null))
                        return [3 /*break*/, 13];
                    d = this.dd.count;
                    e = this.vl.i$b;
                    f = 0;
                    _d.label = 9;
                case 9:
                    if (!(f < d))
                        return [3 /*break*/, 12];
                    return [4 /*yield*/, (this.wf.item(e.item(f)) + this.wg.item(e.item(f)) + this.we.item(e.item(f))) / 3];
                case 10:
                    _d.sent();
                    _d.label = 11;
                case 11:
                    ++f;
                    return [3 /*break*/, 9];
                case 12: return [3 /*break*/, 17];
                case 13:
                    g = this.dd.count;
                    h = 0;
                    _d.label = 14;
                case 14:
                    if (!(h < g))
                        return [3 /*break*/, 17];
                    return [4 /*yield*/, (this.wf.item(h) + this.wg.item(h) + this.we.item(h)) / 3];
                case 15:
                    _d.sent();
                    _d.label = 16;
                case 16:
                    ++h;
                    return [3 /*break*/, 14];
                case 17: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.w0 = function () {
        var _this = this;
        return toEnum(function () { return _this._w0(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "w2", {
        get: function () {
            return this.wz();
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype._wz = function () {
        var a, b, c, d, e;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.wv && this.vl.i$b != null))
                        return [3 /*break*/, 7];
                    a = this.wf.count;
                    b = this.vl.i$b;
                    if (!(a > 0))
                        return [3 /*break*/, 2];
                    return [4 /*yield*/, this.xh(this.wf.item(b.item(0)) - this.wg.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a))
                        return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.max(this.xh(this.wf.item(b.item(c)) - this.wg.item(b.item(c))), Math.max(this.xh(Math.abs(this.wf.item(b.item(c)) - this.we.item(b.item(c - 1)))), this.xh(Math.abs(this.wg.item(b.item(c)) - this.we.item(b.item(c - 1))))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++c;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.wf.count;
                    if (!(d > 0))
                        return [3 /*break*/, 9];
                    return [4 /*yield*/, this.xh(this.wf.item(0) - this.wg.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d))
                        return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.max(this.xh(this.wf.item(e) - this.wg.item(e)), Math.max(this.xh(Math.abs(this.wf.item(e) - this.we.item(e - 1))), this.xh(Math.abs(this.wg.item(e) - this.we.item(e - 1)))))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    ++e;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.wz = function () {
        var _this = this;
        return toEnum(function () { return _this._wz(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "w1", {
        get: function () {
            return this.wy();
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype._wy = function () {
        var a, b, c, d, e;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.wv && this.vl.i$b != null))
                        return [3 /*break*/, 7];
                    a = this.wg.count;
                    b = this.vl.i$b;
                    if (!(a > 0))
                        return [3 /*break*/, 2];
                    return [4 /*yield*/, this.xh(this.wg.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a))
                        return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.min(this.xh(this.wg.item(b.item(c))), this.xh(this.we.item(b.item(c - 1))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    c++;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.wg.count;
                    if (!(d > 0))
                        return [3 /*break*/, 9];
                    return [4 /*yield*/, this.xh(this.wg.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d))
                        return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.min(this.xh(this.wg.item(e)), this.xh(this.we.item(e - 1)))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    e++;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.wy = function () {
        var _this = this;
        return toEnum(function () { return _this._wy(); });
    };
    FinancialSeries.prototype.w5 = function (a) {
        if (a == null) {
            return null;
        }
        if (this.wv && this.vl.i$b != null) {
            return new SafeSortedReadOnlyDoubleCollection(0, a, this.vl.i$b);
        }
        return new SafeReadOnlyDoubleCollection(0, a);
    };
    FinancialSeries.prototype.w4 = function () {
        var a = new List$1(String_$type, 0);
        a.add("HighColumn");
        a.add("LowColumn");
        a.add("CloseColumn");
        if (this.typicalBasedOn != null && this.dd != null && !this.wk) {
            this.wk = true;
            var b = this.vy(0, this.dd.count);
            this.wk = false;
            var c = new FinancialEventArgs(0, this.dd.count, b, this.vz(b), this);
            this.typicalBasedOn(this, c);
            if (c.basedOn != null && c.basedOn.count > 0) {
                return c.basedOn;
            }
        }
        return a;
    };
    FinancialSeries.prototype.getOpenColumnAsArray = function () {
        if (this.wh == null) {
            return null;
        }
        if (this.vl != null && typeCast(ISortingAxis_$type, this.vl) !== null) {
            if (this.w9 != null) {
                return this.w9.asArray();
            }
            var a = new List$1(Number_$type, 2, this.wh.count);
            var b = this.vl.i$b;
            var c = this.wh.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.w9 = a;
            return this.w9.asArray();
        }
        else {
            return this.wh.asArray();
        }
    };
    FinancialSeries.prototype.getHighColumnAsArray = function () {
        if (this.wf == null) {
            return null;
        }
        if (this.vl != null && typeCast(ISortingAxis_$type, this.vl) !== null) {
            if (this.w7 != null) {
                return this.w7.asArray();
            }
            var a = new List$1(Number_$type, 2, this.wf.count);
            var b = this.vl.i$b;
            var c = this.wf.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.w7 = a;
            return this.w7.asArray();
        }
        else {
            return this.wf.asArray();
        }
    };
    FinancialSeries.prototype.getLowColumnAsArray = function () {
        if (this.wg == null) {
            return null;
        }
        if (this.vl != null && typeCast(ISortingAxis_$type, this.vl) !== null) {
            if (this.w8 != null) {
                return this.w8.asArray();
            }
            var a = new List$1(Number_$type, 2, this.wg.count);
            var b = this.vl.i$b;
            var c = this.wg.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.w8 = a;
            return this.w8.asArray();
        }
        else {
            return this.wg.asArray();
        }
    };
    FinancialSeries.prototype.getCloseColumnAsArray = function () {
        if (this.we == null) {
            return null;
        }
        if (this.vl != null && typeCast(ISortingAxis_$type, this.vl) !== null) {
            if (this.w6 != null) {
                return this.w6.asArray();
            }
            var a = new List$1(Number_$type, 2, this.we.count);
            var b = this.vl.i$b;
            var c = this.we.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.w6 = a;
            return this.w6.asArray();
        }
        else {
            return this.we.asArray();
        }
    };
    FinancialSeries.prototype.getVolumeColumnAsArray = function () {
        if (this.wj == null) {
            return null;
        }
        if (this.vl != null && typeCast(ISortingAxis_$type, this.vl) !== null) {
            if (this.xa != null) {
                return this.xa.asArray();
            }
            var a = new List$1(Number_$type, 2, this.wj.count);
            var b = this.vl.i$b;
            var c = this.wj.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.xa = a;
            return this.xa.asArray();
        }
        else {
            return this.wj.asArray();
        }
    };
    FinancialSeries.prototype.oc = function (a, b, c, d) {
        _super.prototype.oc.call(this, a, b, c, d);
        if (this.vl == null || !(typeCast(ISortingAxis_$type, this.vl) !== null)) {
            return;
        }
        var e = this.vl.i$b;
        switch (a) {
            case 1:
                for (var f = b; f < c; f++) {
                    var g = e._inner[f];
                    if (this.w9 != null) {
                        this.w9.insert(f, this.wh.item(g));
                    }
                    if (this.w7 != null) {
                        this.w7.insert(f, this.wf.item(g));
                    }
                    if (this.w8 != null) {
                        this.w8.insert(f, this.wg.item(g));
                    }
                    if (this.w6 != null) {
                        this.w6.insert(f, this.we.item(g));
                    }
                    if (this.xa != null) {
                        this.xa.insert(f, this.wj.item(g));
                    }
                }
                break;
            case 0:
                if (this.w9 != null) {
                    this.w9.v(b, c);
                }
                if (this.w7 != null) {
                    this.w7.v(b, c);
                }
                if (this.w8 != null) {
                    this.w8.v(b, c);
                }
                if (this.w6 != null) {
                    this.w6.v(b, c);
                }
                if (this.xa != null) {
                    this.xa.v(b, c);
                }
                break;
            case 4:
                if (this.w9 != null) {
                    this.w9 = new List$1(Number_$type, 0);
                }
                if (this.w7 != null) {
                    this.w7 = new List$1(Number_$type, 0);
                }
                if (this.w8 != null) {
                    this.w8 = new List$1(Number_$type, 0);
                }
                if (this.w6 != null) {
                    this.w6 = new List$1(Number_$type, 0);
                }
                if (this.xa != null) {
                    this.xa = new List$1(Number_$type, 0);
                }
                break;
            case 3:
            case 2:
                for (var h = b; h < c; h++) {
                    var i = e._inner[h];
                    if (this.w9 != null) {
                        this.w9._inner[h] = this.wh.item(i);
                    }
                    if (this.w7 != null) {
                        this.w7._inner[h] = this.wf.item(i);
                    }
                    if (this.w8 != null) {
                        this.w8._inner[h] = this.wg.item(i);
                    }
                    if (this.w6 != null) {
                        this.w6._inner[h] = this.we.item(i);
                    }
                    if (this.xa != null) {
                        this.xa._inner[h] = this.wj.item(i);
                    }
                }
                break;
        }
        this.yu();
        this.rg();
    };
    FinancialSeries.prototype.vy = function (a, b) {
        var _this = this;
        var c = this.w5(this.wh);
        var d = this.w5(this.we);
        var e = this.w5(this.wf);
        var f = this.w5(this.wg);
        var g = this.w5(this.wj);
        var h = ((function () {
            var $ret = new FinancialCalculationDataSource();
            $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(_this.w3), _this.w4());
            $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(_this.w2), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("HighColumn");
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(_this.w1), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.openColumn = c;
            $ret.closeColumn = d;
            $ret.highColumn = e;
            $ret.lowColumn = f;
            $ret.volumeColumn = g;
            $ret.calculateFrom = a;
            $ret.calculateCount = b;
            $ret.minimumValue = NaN;
            $ret.maximumValue = NaN;
            $ret.count = _this.dd != null ? _this.dd.count : 0;
            return $ret;
        })());
        return h;
    };
    FinancialSeries.prototype.xh = function (a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    };
    FinancialSeries.prototype.vz = function (a) {
        var _this = this;
        return ((function () {
            var $ret = new FinancialCalculationSupportingCalculations();
            $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
            $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
            $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
            $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
            $ret.h = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.shortPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.f = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.longPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.g = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.shortPeriod); }, a.typicalColumn.basedOn);
            $ret.e = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.longPeriod); }, a.typicalColumn.basedOn);
            $ret.k = Series.g8;
            $ret.j = Series.g7;
            $ret.i = runOn(_this, _this.xh);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialSeries.prototype, "categoryAxis", {
        get: function () {
            return this.vl;
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.qo = function (a, b) {
        _super.prototype.qo.call(this, a, b);
        if (!this.gj) {
            this.cl.a4(b);
            return;
        }
        var c = typeCast(FinancialSeriesView.$, this.ck);
        this.cl.a4(b);
        c.b0.e(this.hu);
        if (this.dt(this.ck)) {
            return;
        }
        if (!this.gc) {
            this.yr(this.vq, c);
        }
        this.gc = false;
        this.yt(this.vq, c);
        this.gj = false;
    };
    FinancialSeries.prototype.ql = function (a, b, c, d, e) {
        _super.prototype.ql.call(this, a, b, c, d, e);
        var f = this.a2.a$i.item(d);
        var g = f;
        g.b0.e(this.hu);
        f.a3(c);
        if (this.dt(g)) {
            return;
        }
        if (this.vm == null) {
            this.vm = new CategoryFrame(3);
        }
        this.vm.v();
        this.yr(this.vm, g);
        this.yt(this.vm, g);
    };
    FinancialSeries.prototype.ao = function (a) {
        if (this.vl == a) {
            return this.v4;
        }
        if (this.v4 == a) {
            return this.vl;
        }
        return null;
    };
    FinancialSeries.prototype.preferredCategoryMode = function (a) {
        var b = typeCast(IDateTimeAxis_$type, this.vl);
        return b != null ? b.preferredCategoryMode(this) : this.vt;
    };
    Object.defineProperty(FinancialSeries.prototype, "vt", {
        get: function () {
            return this.vs;
        },
        set: function (a) {
            var b = this.vt;
            if (a != b) {
                this.vs = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.vt));
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.get_e7 = function () {
        return true;
    };
    FinancialSeries.prototype.qw = function (a, b) {
        _super.prototype.qw.call(this, a, b);
        this.zb = a;
    };
    FinancialSeries.prototype.yu = function () {
        this.h2 = this.we == null || this.we.count == 0 ? NaN : this.we.item(this.we.count - 1);
    };
    FinancialSeries.prototype.j4 = function (a) {
        if (this.v3 != null && a != null) {
            if (this.v5 == null || this.v5.propertyName != this.v3.dateTimeMemberPath) {
                this.v5 = new FastReflectionHelper(false, this.v3.dateTimeMemberPath);
            }
            var b = this.v5.getPropertyValue(a);
            if (typeCast(Date_$type, b) !== null) {
                return dateToStringFormat(b, this.v3.itemLabelFormat());
            }
        }
        return _super.prototype.j4.call(this, a);
    };
    FinancialSeries.$t = markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
    FinancialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:xp:yv', [2, null], 'HighMemberPath:x2:y1', [2, null], 'HighlightedCloseMemberPath:xs:yw', [2, null], 'HighlightedHighMemberPath:xu:yx', [2, null], 'HighlightedLowMemberPath:xw:yy', [2, null], 'HighlightedOpenMemberPath:xy:yz', [2, null], 'HighlightedVolumeMemberPath:x0:y0', [2, null], 'IsCustomCategoryStyleAllowed:wr:y2', [0, false], 'IsTransitionInEnabled:ws:y3', [0, false], 'LowMemberPath:x7:y4', [2, null], 'NegativeBrush:zb:y5', [Brush.$, null], 'OpenMemberPath:yb:y6', [2, null], 'TransitionInMode:vw:y7', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:yf:y8', [2, null], 'XAxis:vl:y9', [CategoryAxisBase.$, null], 'YAxis:v4:za', [NumericYAxis.$, null]]);
    return FinancialSeries;
}(Series));
export { FinancialSeries };
/**
 * @hidden
 */
var FinancialCalculationSupportingCalculations = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialCalculationSupportingCalculations, _super);
    function FinancialCalculationSupportingCalculations() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = null;
        _this.d = null;
        _this.b = null;
        _this.h = null;
        _this.f = null;
        _this.g = null;
        _this.e = null;
        _this.k = null;
        _this.j = null;
        _this.i = null;
        return _this;
    }
    FinancialCalculationSupportingCalculations.$t = markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
    return FinancialCalculationSupportingCalculations;
}(Base));
export { FinancialCalculationSupportingCalculations };
/**
 * @hidden
 */
var DataSourceSupportingCalculation = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataSourceSupportingCalculation, _super);
    function DataSourceSupportingCalculation(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    _this = _super.call(this, Delegate_$type, 0, c) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this = _super.call(this, Delegate_$type, 1, c, d) || this;
                }
                break;
        }
        return _this;
    }
    DataSourceSupportingCalculation.$t = markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
    return DataSourceSupportingCalculation;
}(SupportingCalculation$1));
export { DataSourceSupportingCalculation };
/**
 * @hidden
 */
var FinancialCalculationDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialCalculationDataSource, _super);
    function FinancialCalculationDataSource() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._openColumn = null;
        _this._closeColumn = null;
        _this._highColumn = null;
        _this._lowColumn = null;
        _this._volumeColumn = null;
        _this._indicatorColumn = null;
        _this._typicalColumn = null;
        _this._trueRange = null;
        _this._trueLow = null;
        _this._period = 0;
        _this._shortPeriod = 0;
        _this._longPeriod = 0;
        _this._count = 0;
        _this._calculateFrom = 0;
        _this._calculateCount = 0;
        _this._multiplier = 0;
        _this._minimumValue = 0;
        _this._maximumValue = 0;
        _this._specifiesRange = false;
        _this._series = null;
        return _this;
    }
    Object.defineProperty(FinancialCalculationDataSource.prototype, "openColumn", {
        get: function () {
            return this._openColumn;
        },
        set: function (a) {
            this._openColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "closeColumn", {
        get: function () {
            return this._closeColumn;
        },
        set: function (a) {
            this._closeColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "highColumn", {
        get: function () {
            return this._highColumn;
        },
        set: function (a) {
            this._highColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "lowColumn", {
        get: function () {
            return this._lowColumn;
        },
        set: function (a) {
            this._lowColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "volumeColumn", {
        get: function () {
            return this._volumeColumn;
        },
        set: function (a) {
            this._volumeColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "typicalColumn", {
        get: function () {
            return this._typicalColumn;
        },
        set: function (a) {
            this._typicalColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueRange", {
        get: function () {
            return this._trueRange;
        },
        set: function (a) {
            this._trueRange = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueLow", {
        get: function () {
            return this._trueLow;
        },
        set: function (a) {
            this._trueLow = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "period", {
        get: function () {
            return this._period;
        },
        set: function (a) {
            this._period = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "shortPeriod", {
        get: function () {
            return this._shortPeriod;
        },
        set: function (a) {
            this._shortPeriod = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "longPeriod", {
        get: function () {
            return this._longPeriod;
        },
        set: function (a) {
            this._longPeriod = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateFrom", {
        get: function () {
            return this._calculateFrom;
        },
        set: function (a) {
            this._calculateFrom = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateCount", {
        get: function () {
            return this._calculateCount;
        },
        set: function (a) {
            this._calculateCount = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "multiplier", {
        get: function () {
            return this._multiplier;
        },
        set: function (a) {
            this._multiplier = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "minimumValue", {
        get: function () {
            return this._minimumValue;
        },
        set: function (a) {
            this._minimumValue = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "maximumValue", {
        get: function () {
            return this._maximumValue;
        },
        set: function (a) {
            this._maximumValue = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "specifiesRange", {
        get: function () {
            return this._specifiesRange;
        },
        set: function (a) {
            this._specifiesRange = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialCalculationDataSource.$t = markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
    return FinancialCalculationDataSource;
}(Base));
export { FinancialCalculationDataSource };
/**
 * @hidden
 */
var FinancialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialSeriesView, _super);
    function FinancialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.b2 = null;
        _this.b0 = null;
        _this.b4 = 0;
        _this.b4 = -1;
        _this.b2 = a;
        _this.b0 = _this.b1();
        return _this;
    }
    FinancialSeriesView.prototype.b3 = function (a) {
        if (this.b4 != a.u) {
            return true;
        }
        return false;
    };
    FinancialSeriesView.prototype.b5 = function (a) {
        this.b4 = a.u;
    };
    FinancialSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
        }
    };
    FinancialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.b2.vl.ce) {
            a += "<span>${itemLabel}</span><br/>";
        }
        else if (this.b2.vl.f0 != null) {
            a += "<span>${item." + this.b2.vl.f0 + "}</span><br/>";
        }
        a += "<span class='ui-priority-primary'";
        var b = this.e.a2.a$t(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        var c = new SRProvider(this.w);
        var d = c.b1("financialSeries_Open");
        var e = c.b1("financialSeries_High");
        var f = c.b1("financialSeries_Low");
        var g = c.b1("financialSeries_Close");
        d = stringIsNullOrEmpty(d) ? "Open" : d;
        e = stringIsNullOrEmpty(e) ? "High" : e;
        f = stringIsNullOrEmpty(f) ? "Low" : f;
        g = stringIsNullOrEmpty(g) ? "Close" : g;
        a += ">" + this.b2.title + "</span><table><tr><td>" + d + ":</td><td>" + "${item." + this.b2.yb + "}</td></tr><tr><td>" + e + ":</td><td>" + "${item." + this.b2.x2 + "}</td></tr><tr><td>" + f + ":</td><td>" + "${item." + this.b2.x7 + "}</td></tr><tr><td>" + g + ":</td><td>" + "${item." + this.b2.xp + "}</td></tr>";
        if (!stringIsNullOrEmpty(this.b2.yf)) {
            var h = c.b1("financialSeries_Volume");
            h = stringIsNullOrEmpty(h) ? "Volume" : h;
            a += "<tr><td>" + h + ":</td><td>" + "${item." + this.b2.yf + "}</td></tr>";
        }
        a += "</table></div>";
        return a;
    };
    FinancialSeriesView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.uj = a;
        this.e.i2 = 5;
        this.e.i3 = 2;
        this.e.i4 = 2;
    };
    FinancialSeriesView.$t = markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
    return FinancialSeriesView;
}(SeriesView));
export { FinancialSeriesView };
