/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryYAxis } from "./CategoryYAxis";
import { IVerticalAnchoredCategorySeriesInteractionManager_$type } from "./IVerticalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { runOn, typeCast, EnumUtil, markType, markDep } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { Rect } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
/**
 * @hidden
 */
var VerticalAnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalAnchoredCategorySeries, _super);
    function VerticalAnchoredCategorySeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.aac = null;
        return _this;
    }
    VerticalAnchoredCategorySeries.prototype.ca = function () {
        if (this.xAxis != null && this.xAxis.ch) {
            return 4;
        }
        return 3;
    };
    VerticalAnchoredCategorySeries.prototype.cb = function () {
        return 1;
    };
    VerticalAnchoredCategorySeries.prototype.n4 = function () {
        _super.prototype.n4.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "aad", {
        get: function () {
            var _this = this;
            if (this.aac == null) {
                this.aac = DVContainer.instance.createInstance(IVerticalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.dg.n; });
            }
            return this.aac;
        },
        enumerable: false,
        configurable: true
    });
    VerticalAnchoredCategorySeries.prototype.get_isVertical = function () {
        return true;
    };
    VerticalAnchoredCategorySeries.prototype.w1 = function () {
        return this.yAxis;
    };
    VerticalAnchoredCategorySeries.prototype.xh = function () {
        return this.xAxis;
    };
    VerticalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        return this.w7.r(this.w1(), this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl));
    };
    VerticalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        return this.yAxis.getCategorySize(this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl));
    };
    VerticalAnchoredCategorySeries.prototype.jo = function (a, b) {
        return this.jp(a, b, this.w1(), runOn(this, this.x1), this.valueColumn);
    };
    VerticalAnchoredCategorySeries.prototype.jq = function (a, b) {
        return this.jr(a, b, this.w1(), runOn(this, this.x1), this.valueColumn);
    };
    VerticalAnchoredCategorySeries.prototype.h4 = function (a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.h5(a, b, this.yAxis, d, e, this.valueColumn.count, runOn(this, this.x1));
    };
    VerticalAnchoredCategorySeries.prototype.ar = function (a) {
        if (a.isEmpty && this.c1 != null) {
            a = this.c1.vh;
        }
        if (this.valueColumn == null) {
            return null;
        }
        var b = this.u1(this.cl);
        var c = this.w1();
        var d = new ScalerParams(0, a, this.c1.vw, c.ch, this.getEffectiveViewport());
        var e = (c.em(b.top, d));
        var f = (c.em(b.bottom, d));
        if (!c.ch) {
            var g = e;
            e = f;
            f = g;
        }
        e -= this.y9;
        f += this.y9;
        var h = null;
        if (c.cn) {
            h = c;
            e = h.i$f(e);
            f = h.i$f(f);
        }
        else {
            e = Math.floor(e);
            f = Math.ceil(f);
        }
        if (isNaN_(e) || isNaN_(f)) {
            return null;
        }
        e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
        f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
        var i = 1.7976931348623157E+308;
        var j = -1.7976931348623157E+308;
        if (truncate(e) <= truncate(f)) {
            for (var k = truncate(e); k <= truncate(f); k++) {
                var l = k;
                if (h != null) {
                    l = h.i$b._inner[k];
                }
                var m = this.valueColumn.item(l);
                if (this.valueColumn.mayContainUnknowns) {
                    if (isInfinity(m) || isNaN_(m)) {
                        continue;
                    }
                }
                i = Math.min(i, m);
                j = Math.max(j, m);
            }
        }
        var n = new AxisRange(i, j);
        n = this.ap(n, this.xh(), a);
        return n;
    };
    VerticalAnchoredCategorySeries.prototype.bt = function () {
        if (this.bu == 0) {
            return 1;
        }
        else {
            return _super.prototype.bt.call(this);
        }
    };
    VerticalAnchoredCategorySeries.prototype.u7 = function (a) {
        if (!this.hasMarkers || !this.vr()) {
            return Rect.empty;
        }
        return this.aad.e$b(this, this.w2.n, a, runOn(this, this.aal));
    };
    VerticalAnchoredCategorySeries.prototype.aal = function (a) {
        return this.yv.dc(a);
    };
    VerticalAnchoredCategorySeries.prototype.gf = function (a, b) {
        if (this.ge(a, b)) {
            return true;
        }
        if (this.vs(a, b)) {
            return true;
        }
        return false;
    };
    VerticalAnchoredCategorySeries.prototype.il = function (a, b, c) {
        if (this.c1 == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.cl);
        var e = this.w1();
        var f = new ScalerParams(0, this.c1.vh, this.cl.bx, e.ch, d);
        var g = this.w7.r(e, this.c1.vh, this.cl.bx, d);
        return this.io(this.valueColumn, a, e, f, g, runOn(this, this.x1), b, c);
    };
    VerticalAnchoredCategorySeries.prototype.uu = function (a, b, c) {
        var d = this.w1();
        return this.uw(a, b, c, this.w7.r(d, this.cl.by, this.cl.bx, this.getEffectiveViewport1(this.cl)), this.xh(), d, null, null, null);
    };
    VerticalAnchoredCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    VerticalAnchoredCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    VerticalAnchoredCategorySeries.prototype.zp = function (a) {
        this.xAxis = typeCast(NumericXAxis.$, a);
    };
    VerticalAnchoredCategorySeries.prototype.zq = function (a) {
        this.yAxis = typeCast(CategoryYAxis.$, a);
    };
    VerticalAnchoredCategorySeries.prototype.xx = function () {
        return this.xAxis != null && this.xAxis.c1();
    };
    VerticalAnchoredCategorySeries.prototype.wv = function (a, b) {
        return this.ys(a, b, this.yAxis);
    };
    VerticalAnchoredCategorySeries.prototype.h6 = function (a) {
        return this.aad.e$a(this, a);
    };
    VerticalAnchoredCategorySeries.prototype.x1 = function (a) {
        return this.h8(a, this.w1());
    };
    VerticalAnchoredCategorySeries.prototype.jj = function (a) {
        return truncate(Math.round(this.h6(a)));
    };
    VerticalAnchoredCategorySeries.prototype.j2 = function (a) {
        var b = this.jj(a);
        return b >= 0 && this.dd != null && b < this.dd.count ? this.dd.item(b) : null;
    };
    VerticalAnchoredCategorySeries.prototype.p5 = function (a, b, c, d) {
        _super.prototype.p5.call(this, a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.od(typeCast(Axis.$, c));
                    this.qc(typeCast(Axis.$, d));
                    this.xb.cu.g(this.hu);
                    if (this.c1 != null) {
                        this.c1.nm();
                    }
                    this.qm(false);
                    this.ph();
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.od(typeCast(Axis.$, c));
                    this.qc(typeCast(Axis.$, d));
                    this.xb.cu.g(this.hu);
                    this.xx();
                    this.qm(false);
                    this.ph();
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.yv.c5 = CategoryTrendLineManagerFactory.a(this.yv.c5, this.yAxis, this.ro, this, this.dg);
                }
                break;
        }
    };
    VerticalAnchoredCategorySeries.prototype.aag = function (a) {
        if (typeCast(CategoryYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    VerticalAnchoredCategorySeries.prototype.aaf = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.xy;
        },
        enumerable: false,
        configurable: true
    });
    VerticalAnchoredCategorySeries.$t = markType(VerticalAnchoredCategorySeries, 'VerticalAnchoredCategorySeries', AnchoredCategorySeries.$);
    VerticalAnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, VerticalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::aaj', [NumericXAxis.$, null], 'YAxis::aak', [CategoryYAxis.$, null]]);
    return VerticalAnchoredCategorySeries;
}(AnchoredCategorySeries));
export { VerticalAnchoredCategorySeries };
