/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.xr = null;
        _this.xs = null;
        _this.x8 = 0;
        _this.ya = 5;
        _this.x9 = 0;
        _this.x7 = 5;
        _this.yp = 5;
        _this.yr = 0;
        _this.yq = 5;
        _this.yo = 0;
        _this.adi = null;
        _this.adp = null;
        _this.adg = null;
        _this.adh = null;
        _this.yj = 0;
        _this.y0 = 0;
        _this.yi = NaN;
        _this.yz = NaN;
        _this.yl = NaN;
        _this.y2 = NaN;
        _this.yk = NaN;
        _this.y1 = NaN;
        _this.yh = NaN;
        _this.yy = NaN;
        _this.ado = null;
        _this.adv = null;
        _this.aaa = null;
        _this.aae = null;
        _this.aac = null;
        _this.aag = null;
        _this.z5 = null;
        _this.z6 = null;
        _this.adj = null;
        _this.adq = null;
        _this.yb = DeviceUtils.g(1);
        _this.ys = DeviceUtils.g(1);
        _this.yc = DeviceUtils.g(1);
        _this.yt = DeviceUtils.g(1);
        _this.adl = null;
        _this.ads = null;
        _this.adm = null;
        _this.adt = null;
        _this.yd = DeviceUtils.g(1);
        _this.yu = DeviceUtils.g(1);
        _this.ye = DeviceUtils.g(8);
        _this.yv = 0;
        _this.adn = null;
        _this.adu = null;
        _this.yf = DeviceUtils.g(1);
        _this.yw = DeviceUtils.g(1);
        _this.aab = null;
        _this.aaf = null;
        _this.adk = null;
        _this.adr = null;
        _this.x6 = 0;
        _this.yn = 0;
        _this.x5 = NaN;
        _this.ym = NaN;
        _this.yg = 0;
        _this.yx = -90;
        _this.x1 = false;
        _this.x2 = false;
        _this.adb = 1;
        _this.aee = 1;
        _this.ada = 1;
        _this.adc = 2;
        _this.aec = 0;
        _this.aed = 1;
        _this.aei = 0;
        _this.aej = 0;
        _this.xz = 4;
        _this.xx = 4;
        _this.z9 = null;
        _this.xl = null;
        _this.aad = null;
        _this.xm = null;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.xp();
            var c = this.xq();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.ti = function () {
        _super.prototype.ti.call(this);
        var a = this.xp();
        var b = this.xq();
        if (a != null && a.az != null) {
            this.ady = a.az.textColor;
        }
        if (b != null && b.az != null) {
            this.ad5 = b.az.textColor;
        }
        this.ad3 = AxisDefaults.j;
        this.aea = AxisDefaults.j;
        this.adz = AxisDefaults.h;
        this.ad6 = AxisDefaults.h;
        this.ad2 = AxisDefaults.g;
        this.ad9 = AxisDefaults.g;
    };
    XYChart.prototype.t8 = function (a, b, c) {
        var _this = this;
        _super.prototype.t8.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.ac2(function (d) { return d.leftMargin = _this.za; });
                break;
            case "XAxisLabelTopMargin":
                this.ac2(function (d) { return d.topMargin = _this.zc; });
                break;
            case "XAxisLabelRightMargin":
                this.ac2(function (d) { return d.rightMargin = _this.zb; });
                break;
            case "XAxisLabelBottomMargin":
                this.ac2(function (d) { return d.bottomMargin = _this.y9; });
                break;
            case "YAxisLabelLeftMargin":
                this.ac7(function (d) { return d.leftMargin = _this.zr; });
                break;
            case "YAxisLabelTopMargin":
                this.ac7(function (d) { return d.topMargin = _this.zt; });
                break;
            case "YAxisLabelRightMargin":
                this.ac7(function (d) { return d.rightMargin = _this.zs; });
                break;
            case "YAxisLabelBottomMargin":
                this.ac7(function (d) { return d.bottomMargin = _this.zq; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.adw = this.wn(this.ady);
                this.adx = this.wn(this.ad5);
                break;
            case "XAxisLabelTextColor":
                this.adw = this.wn(this.ady);
                break;
            case "YAxisLabelTextColor":
                this.adx = this.wn(this.ad5);
                break;
            case "ActualXAxisLabelTextColor":
                this.ac2(function (d) { return d.textColor = _this.adw; });
                break;
            case "ActualYAxisLabelTextColor":
                this.ac7(function (d) { return d.textColor = _this.adx; });
                break;
            case "XAxisTitleMargin":
                this.ac4(function (d) { return d.margin = _this.zl; });
                break;
            case "YAxisTitleMargin":
                this.ac9(function (d) { return d.margin = _this.z2; });
                break;
            case "XAxisTitleLeftMargin":
                this.ac4(function (d) { return d.leftMargin = _this.zk; });
                break;
            case "YAxisTitleLeftMargin":
                this.ac9(function (d) { return d.leftMargin = _this.z1; });
                break;
            case "XAxisTitleTopMargin":
                this.ac4(function (d) { return d.topMargin = _this.zn; });
                break;
            case "YAxisTitleTopMargin":
                this.ac9(function (d) { return d.topMargin = _this.z4; });
                break;
            case "XAxisTitleRightMargin":
                this.ac4(function (d) { return d.rightMargin = _this.zm; });
                break;
            case "YAxisTitleRightMargin":
                this.ac9(function (d) { return d.rightMargin = _this.z3; });
                break;
            case "XAxisTitleBottomMargin":
                this.ac4(function (d) { return d.bottomMargin = _this.zj; });
                break;
            case "YAxisTitleBottomMargin":
                this.ac9(function (d) { return d.bottomMargin = _this.z0; });
                break;
            case "XAxisTitleTextColor":
                this.ac4(function (d) { return d.textColor = _this.ad4; });
                break;
            case "YAxisTitleTextColor":
                this.ac9(function (d) { return d.textColor = _this.aeb; });
                break;
            case "XAxisFormatLabel":
                this.ac0(function (d) { return d.au = _this.xt; });
                break;
            case "YAxisFormatLabel":
                this.ac5(function (d) { return d.au = _this.xu; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "xt", {
        get: function () {
            return this.xr;
        },
        set: function (a) {
            var b = this.xt;
            if (a != b) {
                this.xr = a;
                this.t5("XAxisFormatLabel", b, this.xt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xu", {
        get: function () {
            return this.xs;
        },
        set: function (a) {
            var b = this.xu;
            if (a != b) {
                this.xs = a;
                this.t5("YAxisFormatLabel", b, this.xu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "za", {
        get: function () {
            return this.x8;
        },
        set: function (a) {
            var b = this.za;
            if (a != b) {
                this.x8 = a;
                this.t5("XAxisLabelLeftMargin", b, this.za);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zc", {
        get: function () {
            return this.ya;
        },
        set: function (a) {
            var b = this.zc;
            if (a != b) {
                this.ya = a;
                this.t5("XAxisLabelTopMargin", b, this.zc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zb", {
        get: function () {
            return this.x9;
        },
        set: function (a) {
            var b = this.zb;
            if (a != b) {
                this.x9 = a;
                this.t5("XAxisLabelRightMargin", b, this.zb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "y9", {
        get: function () {
            return this.x7;
        },
        set: function (a) {
            var b = this.y9;
            if (a != b) {
                this.x7 = a;
                this.t5("XAxisLabelBottomMargin", b, this.y9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zr", {
        get: function () {
            return this.yp;
        },
        set: function (a) {
            var b = this.zr;
            if (a != b) {
                this.yp = a;
                this.t5("YAxisLabelLeftMargin", b, this.zr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zt", {
        get: function () {
            return this.yr;
        },
        set: function (a) {
            var b = this.zt;
            if (a != b) {
                this.yr = a;
                this.t5("YAxisLabelTopMargin", b, this.zt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zs", {
        get: function () {
            return this.yq;
        },
        set: function (a) {
            var b = this.zs;
            if (a != b) {
                this.yq = a;
                this.t5("YAxisLabelRightMargin", b, this.zs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zq", {
        get: function () {
            return this.yo;
        },
        set: function (a) {
            var b = this.zq;
            if (a != b) {
                this.yo = a;
                this.t5("YAxisLabelBottomMargin", b, this.zq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ady", {
        get: function () {
            return this.adi;
        },
        set: function (a) {
            var b = this.ady;
            if (a != b) {
                this.adi = a;
                this.t5("XAxisLabelTextColor", b, this.ady);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad5", {
        get: function () {
            return this.adp;
        },
        set: function (a) {
            var b = this.ad5;
            if (a != b) {
                this.adp = a;
                this.t5("YAxisLabelTextColor", b, this.ad5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adw", {
        get: function () {
            return this.adg;
        },
        set: function (a) {
            var b = this.adg;
            if (a != b) {
                this.adg = a;
                this.t5("ActualXAxisLabelTextColor", b, this.adw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adx", {
        get: function () {
            return this.adh;
        },
        set: function (a) {
            var b = this.adh;
            if (a != b) {
                this.adh = a;
                this.t5("ActualYAxisLabelTextColor", b, this.adx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zl", {
        get: function () {
            return this.yj;
        },
        set: function (a) {
            var b = this.zl;
            if (a != b) {
                this.yj = a;
                this.t5("XAxisTitleMargin", b, this.zl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "z2", {
        get: function () {
            return this.y0;
        },
        set: function (a) {
            var b = this.z2;
            if (a != b) {
                this.y0 = a;
                this.t5("YAxisTitleMargin", b, this.z2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zk", {
        get: function () {
            return this.yi;
        },
        set: function (a) {
            var b = this.zk;
            if (a != b) {
                this.yi = a;
                this.t5("XAxisTitleLeftMargin", b, this.zk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "z1", {
        get: function () {
            return this.yz;
        },
        set: function (a) {
            var b = this.z1;
            if (a != b) {
                this.yz = a;
                this.t5("YAxisTitleLeftMargin", b, this.z1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zn", {
        get: function () {
            return this.yl;
        },
        set: function (a) {
            var b = this.zn;
            if (a != b) {
                this.yl = a;
                this.t5("XAxisTitleTopMargin", b, this.zn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "z4", {
        get: function () {
            return this.y2;
        },
        set: function (a) {
            var b = this.z4;
            if (a != b) {
                this.y2 = a;
                this.t5("YAxisTitleTopMargin", b, this.z4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zm", {
        get: function () {
            return this.yk;
        },
        set: function (a) {
            var b = this.zm;
            if (a != b) {
                this.yk = a;
                this.t5("XAxisTitleRightMargin", b, this.zm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "z3", {
        get: function () {
            return this.y1;
        },
        set: function (a) {
            var b = this.z3;
            if (a != b) {
                this.y1 = a;
                this.t5("YAxisTitleRightMargin", b, this.z3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zj", {
        get: function () {
            return this.yh;
        },
        set: function (a) {
            var b = this.zj;
            if (a != b) {
                this.yh = a;
                this.t5("XAxisTitleBottomMargin", b, this.zj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "z0", {
        get: function () {
            return this.yy;
        },
        set: function (a) {
            var b = this.z0;
            if (a != b) {
                this.yy = a;
                this.t5("YAxisTitleBottomMargin", b, this.z0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad4", {
        get: function () {
            return this.ado;
        },
        set: function (a) {
            var b = this.ad4;
            if (a != b) {
                this.ado = a;
                this.t5("XAxisTitleTextColor", b, this.ad4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aeb", {
        get: function () {
            return this.adv;
        },
        set: function (a) {
            var b = this.aeb;
            if (a != b) {
                this.adv = a;
                this.t5("YAxisTitleTextColor", b, this.aeb);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.t9 = function (a, b, c) {
        var _this = this;
        _super.prototype.t9.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.ac2(function (d) { return d.textStyle = _this.aay; });
                break;
            case "YAxisLabelTextStyle":
                this.ac7(function (d) { return d.textStyle = _this.ab3; });
                break;
            case "XAxisTitleTextStyle":
                this.ac4(function (d) { return d.textStyle = _this.abm; });
                break;
            case "YAxisTitleTextStyle":
                this.ac9(function (d) { return d.textStyle = _this.acr; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "aay", {
        get: function () {
            return this.aaa;
        },
        set: function (a) {
            var b = this.aay;
            if (a != b) {
                this.aaa = a;
                this.t5("XAxisLabelTextStyle", b, this.aay);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab3", {
        get: function () {
            return this.aae;
        },
        set: function (a) {
            var b = this.ab3;
            if (a != b) {
                this.aae = a;
                this.t5("YAxisLabelTextStyle", b, this.ab3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abm", {
        get: function () {
            return this.aac;
        },
        set: function (a) {
            var b = this.abm;
            if (a != b) {
                this.aac = a;
                this.t5("XAxisTitleTextStyle", b, this.abm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acr", {
        get: function () {
            return this.aag;
        },
        set: function (a) {
            var b = this.acr;
            if (a != b) {
                this.aag = a;
                this.t5("YAxisTitleTextStyle", b, this.acr);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.acx = function (a) {
        var _this = this;
        this.acu(a, function (b) { return b.leftMargin = _this.za; });
        this.acu(a, function (b) { return b.topMargin = _this.zc; });
        this.acu(a, function (b) { return b.rightMargin = _this.zb; });
        this.acu(a, function (b) { return b.bottomMargin = _this.y9; });
        this.acu(a, function (b) { return b.textColor = _this.adw; });
        this.acv(a, function (b) { return b.textColor = _this.ad4; });
        this.acv(a, function (b) { return b.leftMargin = _this.zk; });
        this.acv(a, function (b) { return b.topMargin = _this.zn; });
        this.acv(a, function (b) { return b.rightMargin = _this.zm; });
        this.acv(a, function (b) { return b.bottomMargin = _this.zj; });
        this.acu(a, function (b) { return b.textStyle = _this.aay; });
        this.acv(a, function (b) { return b.textStyle = _this.abm; });
    };
    XYChart.prototype.acz = function (a) {
        var _this = this;
        this.acu(a, function (b) { return b.leftMargin = _this.zr; });
        this.acu(a, function (b) { return b.topMargin = _this.zt; });
        this.acu(a, function (b) { return b.rightMargin = _this.zs; });
        this.acu(a, function (b) { return b.bottomMargin = _this.zq; });
        this.acu(a, function (b) { return b.textColor = _this.adx; });
        this.acv(a, function (b) { return b.textColor = _this.aeb; });
        this.acv(a, function (b) { return b.leftMargin = _this.z1; });
        this.acv(a, function (b) { return b.topMargin = _this.z4; });
        this.acv(a, function (b) { return b.rightMargin = _this.z3; });
        this.acv(a, function (b) { return b.bottomMargin = _this.z0; });
        this.acu(a, function (b) { return b.textStyle = _this.ab3; });
        this.acv(a, function (b) { return b.textStyle = _this.acr; });
    };
    XYChart.prototype.us = function (a) {
        var b = this.bg(a);
        var c = this.c6(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        if (a.highlightedData != null) {
            c.highlightedItemsSource = a.highlightedData;
        }
        c.name = this.pe(a);
        c.title = this.pf(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.ac0 = function (a) {
        this.ac1(a, null);
    };
    XYChart.prototype.ac1 = function (a, b) {
        a(this.xp());
    };
    XYChart.prototype.ac6 = function (a, b) {
        a(this.xq());
    };
    XYChart.prototype.ac5 = function (a) {
        this.ac6(a, true);
    };
    XYChart.prototype.s2 = function (a, b) {
        this.ac0(a);
        this.ac6(a, b);
    };
    XYChart.prototype.ac4 = function (a) {
        this.acv(this.xp(), a);
    };
    XYChart.prototype.ac9 = function (a) {
        this.acv(this.xq(), a);
    };
    XYChart.prototype.ac7 = function (a) {
        this.acu(this.xq(), a);
    };
    XYChart.prototype.ac2 = function (a) {
        this.acu(this.xp(), a);
    };
    XYChart.prototype.y3 = function (a) {
        var b = this.xp();
        return b.ej(a, new ScalerParams(1, this.ww, this.wv, b.ch));
    };
    XYChart.prototype.y5 = function (a) {
        var b = this.xp();
        return b.em(a, new ScalerParams(1, this.ww, this.wv, b.ch));
    };
    XYChart.prototype.y4 = function (a) {
        var b = this.xq();
        return b.ej(a, new ScalerParams(1, this.ww, this.wv, b.ch));
    };
    XYChart.prototype.y6 = function (a) {
        var b = this.xq();
        return b.em(a, new ScalerParams(1, this.ww, this.wv, b.ch));
    };
    XYChart.prototype.up = function (a) {
        _super.prototype.up.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.xp();
            var c = this.xq();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.aaj = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    XYChart.prototype.td = function (a) {
        _super.prototype.td.call(this, a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.xp());
            this.dataChart.axes.add(this.xq());
        }
    };
    XYChart.prototype.acw = function (a) {
        var _this = this;
        if (a != null && this.kz != null && a.fl == null) {
            a.provideRenderer(this.kz);
        }
        a.jw = this.adz;
        a.er = this.zd;
        a.jx = this.ad0;
        a.eu = this.ze;
        a.jz = this.ad2;
        a.fg = this.zf;
        a.jy = this.ad1;
        a.fh = this.zg;
        a.j0 = this.ad3;
        a.fi = this.zh;
        a.c4 = true;
        a.cu = this.g2;
        a.cw = this.g2;
        var b = a == this.xp();
        if (b) {
            a.g6 = this.abd;
        }
        a.f0 = this.z7;
        a.gg = this.aap;
        a.ah = this.xn;
        this.acu(a, function (c) { return c.angle = _this.y8; });
        this.acu(a, function (c) {
            if (c.extent != _this.y7) {
                c.extent = _this.y7;
            }
        });
        this.acu(a, function (c) { return c.horizontalAlignment = _this.add; });
        this.acu(a, function (c) { return c.verticalAlignment = _this.aef; });
        this.acu(a, function (c) { return c.visibility = _this.aek; });
        this.acu(a, function (c) { return c.location = _this.xv(_this.xy); });
        this.acv(a, function (c) { return c.horizontalAlignment = _this.ade; });
        this.acv(a, function (c) { return c.angle = _this.zi; });
        this.acx(a);
    };
    XYChart.prototype.acy = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.kz != null && a.fl == null) {
            a.provideRenderer(this.kz);
        }
        a.cu = this.g2;
        a.cw = this.g2;
        this.acu(a, function (b) { return b.angle = _this.zp; });
        this.acu(a, function (b) {
            if (b.extent != _this.zo) {
                b.extent = _this.zo;
            }
        });
        this.acu(a, function (b) { return b.horizontalAlignment = _this.adf; });
        this.acu(a, function (b) { return b.verticalAlignment = _this.aeg; });
        this.acu(a, function (b) { return b.visibility = _this.ael; });
        this.acu(a, function (b) { return b.location = _this.xw(_this.x0); });
        this.acv(a, function (b) { return b.verticalAlignment = _this.aeh; });
        this.acv(a, function (b) { return b.angle = _this.zz; });
        a.jw = this.ad6;
        a.er = this.zu;
        a.jx = this.ad7;
        a.eu = this.zv;
        a.jz = this.ad9;
        a.fg = this.zw;
        a.jy = this.ad8;
        a.fh = this.zx;
        a.j0 = this.aea;
        a.fi = this.zy;
        var b = a == this.xq();
        if (b) {
            a.g6 = this.aci;
        }
        a.gg = this.abu;
        a.ah = this.xo;
        this.acz(a);
    };
    XYChart.prototype.ta = function () {
        _super.prototype.ta.call(this);
        this.acw(this.xp());
        this.acy(this.xq());
    };
    XYChart.prototype.acu = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.az == null) {
            a.az = new AxisLabelSettings();
            a.az.angle = a.d5();
            a.az.bottomMargin = a.d6();
            a.az.leftMargin = a.d7();
            a.az.rightMargin = a.d8();
            a.az.topMargin = a.d9();
            a.az.horizontalAlignment = a.jr();
            a.az.location = a.a0();
            a.az.verticalAlignment = a.kk();
        }
        b(a.az);
    };
    XYChart.prototype.acv = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bf == null) {
            a.bf = new TitleSettings();
            a.bf.bottomMargin = a.eb();
            a.bf.leftMargin = a.ec();
            a.bf.rightMargin = a.ed();
            a.bf.topMargin = a.ee();
            a.bf.location = a.a1();
            a.bf.angle = a.ea();
            a.bf.horizontalAlignment = a.js();
            a.bf.verticalAlignment = a.kl();
        }
        b(a.bf);
    };
    XYChart.prototype.t5 = function (a, b, c) {
        var _this = this;
        _super.prototype.t5.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.ac2(function (d) { return d.angle = _this.y8; });
                break;
            case "YAxisLabelAngle":
                this.ac7(function (d) { return d.angle = _this.zp; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.ac2(function (d) { return d.horizontalAlignment = _this.add; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.ac7(function (d) { return d.horizontalAlignment = _this.adf; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.ac2(function (d) { return d.verticalAlignment = _this.aef; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.ac7(function (d) { return d.verticalAlignment = _this.aeg; });
                break;
            case "XAxisLabelVisibility":
                this.ac2(function (d) { return d.visibility = _this.aek; });
                break;
            case "YAxisLabelVisibility":
                this.ac7(function (d) { return d.visibility = _this.ael; });
                break;
            case "XAxisLabel":
                this.ac0(function (d) { return d.f0 = _this.z7; });
                break;
            case "YAxisLabel":
                this.ac5(function (d) { return d.f0 = _this.z8; });
                break;
            case "XAxisLabelFormat":
                this.ac0(function (d) { return d.gg = _this.aap; });
                break;
            case "XAxisLabelFormatSpecifiers":
                this.ac0(function (d) { return d.ah = _this.xn; });
                break;
            case "YAxisLabelFormat":
                this.ac5(function (d) { return d.gg = _this.abu; });
                break;
            case "YAxisLabelFormatSpecifiers":
                this.ac5(function (d) { return d.ah = _this.xo; });
                break;
            case "XAxisTitleAngle":
                this.ac4(function (d) { return d.angle = _this.zi; });
                break;
            case "YAxisTitleAngle":
                this.ac9(function (d) { return d.angle = _this.zz; });
                break;
            case "XAxisTitleAlignment":
                this.ac4(function (d) { return d.horizontalAlignment = _this.ade; });
                break;
            case "YAxisTitleAlignment":
                this.ac9(function (d) { return d.verticalAlignment = _this.aeh; });
                break;
            case "XAxisTitle":
                this.ac0(function (d) { return d.g6 = _this.abd; });
                break;
            case "YAxisTitle":
                this.ac6(function (d) { return d.g6 = _this.aci; }, false);
                break;
            case "XAxisMajorStroke":
                this.ac1(function (d) { return d.jw = _this.adz; }, a);
                break;
            case "YAxisMajorStroke":
                this.ac5(function (d) { return d.jw = _this.ad6; });
                break;
            case "XAxisMajorStrokeThickness":
                this.ac1(function (d) { return d.er = _this.zd; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.ac5(function (d) { return d.er = _this.zu; });
                break;
            case "XAxisMinorStroke":
                this.ac0(function (d) { return d.jx = _this.ad0; });
                break;
            case "YAxisMinorStroke":
                this.ac5(function (d) { return d.jx = _this.ad7; });
                break;
            case "XAxisMinorStrokeThickness":
                this.ac0(function (d) { return d.eu = _this.ze; });
                break;
            case "YAxisMinorStrokeThickness":
                this.ac5(function (d) { return d.eu = _this.zv; });
                break;
            case "XAxisTickLength":
                this.ac0(function (d) { return d.fh = _this.zg; });
                break;
            case "YAxisTickLength":
                this.ac5(function (d) { return d.fh = _this.zx; });
                break;
            case "XAxisTickStroke":
                this.ac0(function (d) { return d.j0 = _this.ad3; });
                break;
            case "YAxisTickStroke":
                this.ac5(function (d) { return d.j0 = _this.aea; });
                break;
            case "XAxisTickStrokeThickness":
                this.ac0(function (d) { return d.fi = _this.zh; });
                break;
            case "YAxisTickStrokeThickness":
                this.ac5(function (d) { return d.fi = _this.zy; });
                break;
            case "XAxisStroke":
                this.ac0(function (d) { return d.jz = _this.ad2; });
                break;
            case "YAxisStroke":
                this.ac5(function (d) { return d.jz = _this.ad9; });
                break;
            case "XAxisStrokeThickness":
                this.ac0(function (d) { return d.fg = _this.zf; });
                break;
            case "YAxisStrokeThickness":
                this.ac5(function (d) { return d.fg = _this.zw; });
                break;
            case "XAxisExtent":
                this.ac2(function (d) { return d.extent = _this.y7; });
                break;
            case "YAxisExtent":
                this.ac7(function (d) { return d.extent = _this.zo; });
                break;
            case "XAxisStrip":
                this.ac0(function (d) { return d.jy = _this.ad1; });
                break;
            case "YAxisStrip":
                this.ac5(function (d) { return d.jy = _this.ad8; });
                break;
            case "XAxisInverted":
                this.ac0(function (d) { return d.ch = _this.x3; });
                break;
            case "YAxisInverted":
                this.ac5(function (d) { return d.ch = _this.x4; });
                break;
            case "YAxisLabelLocation":
                this.ac8();
                break;
            case "XAxisLabelLocation":
                this.ac3();
                break;
        }
    };
    XYChart.prototype.ac8 = function () {
        var a = this.xw(this.x0);
        if (a == 2 || a == 7) {
            this.adf = 2;
        }
        else {
            this.adf = 0;
        }
        this.ac7(function (b) { return b.location = a; });
    };
    XYChart.prototype.ac3 = function () {
        var a = this.xv(this.xy);
        if (a == 1 || a == 5) {
            this.aef = 0;
        }
        else {
            this.aef = 2;
        }
        this.ac2(function (b) { return b.location = a; });
    };
    XYChart.prototype.xw = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.b5 == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    XYChart.prototype.xv = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(XYChart.prototype, "z7", {
        get: function () {
            return this.z5;
        },
        set: function (a) {
            var b = this.z7;
            if (a != b) {
                this.z5 = a;
                this.t5("XAxisLabel", b, this.z7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "z8", {
        get: function () {
            return this.z6;
        },
        set: function (a) {
            var b = this.z8;
            if (a != b) {
                this.z6 = a;
                this.t5("YAxisLabel", b, this.z8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adz", {
        get: function () {
            return this.adj;
        },
        set: function (a) {
            var b = this.adz;
            if (a != b) {
                this.adj = a;
                this.t5("XAxisMajorStroke", b, this.adz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad6", {
        get: function () {
            return this.adq;
        },
        set: function (a) {
            var b = this.ad6;
            if (a != b) {
                this.adq = a;
                this.t5("YAxisMajorStroke", b, this.ad6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zd", {
        get: function () {
            return this.yb;
        },
        set: function (a) {
            var b = this.zd;
            if (a != b) {
                this.yb = a;
                this.t5("XAxisMajorStrokeThickness", b, this.zd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zu", {
        get: function () {
            return this.ys;
        },
        set: function (a) {
            var b = this.zu;
            if (a != b) {
                this.ys = a;
                this.t5("YAxisMajorStrokeThickness", b, this.zu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ze", {
        get: function () {
            return this.yc;
        },
        set: function (a) {
            var b = this.ze;
            if (a != b) {
                this.yc = a;
                this.t5("XAxisMinorStrokeThickness", b, this.ze);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zv", {
        get: function () {
            return this.yt;
        },
        set: function (a) {
            var b = this.zv;
            if (a != b) {
                this.yt = a;
                this.t5("YAxisMinorStrokeThickness", b, this.zv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad1", {
        get: function () {
            return this.adl;
        },
        set: function (a) {
            var b = this.ad1;
            if (a != b) {
                this.adl = a;
                this.t5("XAxisStrip", b, this.ad1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad8", {
        get: function () {
            return this.ads;
        },
        set: function (a) {
            var b = this.ad8;
            if (a != b) {
                this.ads = a;
                this.t5("YAxisStrip", b, this.ad8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad2", {
        get: function () {
            return this.adm;
        },
        set: function (a) {
            var b = this.ad2;
            if (a != b) {
                this.adm = a;
                this.t5("XAxisStroke", b, this.ad2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad9", {
        get: function () {
            return this.adt;
        },
        set: function (a) {
            var b = this.ad9;
            if (a != b) {
                this.adt = a;
                this.t5("YAxisStroke", b, this.ad9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zf", {
        get: function () {
            return this.yd;
        },
        set: function (a) {
            var b = this.zf;
            if (a != b) {
                this.yd = a;
                this.t5("XAxisStrokeThickness", b, this.zf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zw", {
        get: function () {
            return this.yu;
        },
        set: function (a) {
            var b = this.zw;
            if (a != b) {
                this.yu = a;
                this.t5("YAxisStrokeThickness", b, this.zw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zg", {
        get: function () {
            return this.ye;
        },
        set: function (a) {
            var b = this.zg;
            if (a != b) {
                this.ye = a;
                this.t5("XAxisTickLength", b, this.zg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zx", {
        get: function () {
            return this.yv;
        },
        set: function (a) {
            var b = this.zx;
            if (a != b) {
                this.yv = a;
                this.t5("YAxisTickLength", b, this.zx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad3", {
        get: function () {
            return this.adn;
        },
        set: function (a) {
            var b = this.ad3;
            if (a != b) {
                this.adn = a;
                this.t5("XAxisTickStroke", b, this.ad3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aea", {
        get: function () {
            return this.adu;
        },
        set: function (a) {
            var b = this.aea;
            if (a != b) {
                this.adu = a;
                this.t5("YAxisTickStroke", b, this.aea);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zh", {
        get: function () {
            return this.yf;
        },
        set: function (a) {
            var b = this.zh;
            if (a != b) {
                this.yf = a;
                this.t5("XAxisTickStrokeThickness", b, this.zh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zy", {
        get: function () {
            return this.yw;
        },
        set: function (a) {
            var b = this.zy;
            if (a != b) {
                this.yw = a;
                this.t5("YAxisTickStrokeThickness", b, this.zy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abd", {
        get: function () {
            return this.aab;
        },
        set: function (a) {
            var b = this.abd;
            if (a != b) {
                this.aab = a;
                this.t5("XAxisTitle", b, this.abd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aci", {
        get: function () {
            return this.aaf;
        },
        set: function (a) {
            var b = this.aci;
            if (a != b) {
                this.aaf = a;
                this.t5("YAxisTitle", b, this.aci);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad0", {
        get: function () {
            return this.adk;
        },
        set: function (a) {
            var b = this.ad0;
            if (a != b) {
                this.adk = a;
                this.t5("XAxisMinorStroke", b, this.ad0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad7", {
        get: function () {
            return this.adr;
        },
        set: function (a) {
            var b = this.ad7;
            if (a != b) {
                this.adr = a;
                this.t5("YAxisMinorStroke", b, this.ad7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "y8", {
        get: function () {
            return this.x6;
        },
        set: function (a) {
            var b = this.y8;
            if (a != b) {
                this.x6 = a;
                this.t5("XAxisLabelAngle", b, this.y8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zp", {
        get: function () {
            return this.yn;
        },
        set: function (a) {
            var b = this.zp;
            if (a != b) {
                this.yn = a;
                this.t5("YAxisLabelAngle", b, this.zp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "y7", {
        get: function () {
            return this.x5;
        },
        set: function (a) {
            var b = this.y7;
            if (a != b) {
                this.x5 = a;
                this.t5("XAxisExtent", b, this.y7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zo", {
        get: function () {
            return this.ym;
        },
        set: function (a) {
            var b = this.zo;
            if (a != b) {
                this.ym = a;
                this.t5("YAxisExtent", b, this.zo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zi", {
        get: function () {
            return this.yg;
        },
        set: function (a) {
            var b = this.zi;
            if (a != b) {
                this.yg = a;
                this.t5("XAxisTitleAngle", b, this.zi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zz", {
        get: function () {
            return this.yx;
        },
        set: function (a) {
            var b = this.zz;
            if (a != b) {
                this.yx = a;
                this.t5("YAxisTitleAngle", b, this.zz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x3", {
        get: function () {
            return this.x1;
        },
        set: function (a) {
            var b = this.x3;
            if (a != b) {
                this.x1 = a;
                this.t5("XAxisInverted", b, this.x3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x4", {
        get: function () {
            return this.x2;
        },
        set: function (a) {
            var b = this.x4;
            if (a != b) {
                this.x2 = a;
                this.t5("YAxisInverted", b, this.x4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ade", {
        get: function () {
            return this.adb;
        },
        set: function (a) {
            var b = this.ade;
            if (a != b) {
                this.adb = a;
                this.t5("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ade));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aeh", {
        get: function () {
            return this.aee;
        },
        set: function (a) {
            var b = this.aeh;
            if (a != b) {
                this.aee = a;
                this.t5("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.aeh));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "add", {
        get: function () {
            return this.ada;
        },
        set: function (a) {
            var b = this.add;
            if (a != b) {
                this.ada = a;
                this.t5("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.add));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_adf = function () {
        return this.adc;
    };
    XYChart.prototype.set_adf = function (a) {
        var b = this.adf;
        if (a != b) {
            this.adc = a;
            this.t5("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.adf));
        }
    };
    Object.defineProperty(XYChart.prototype, "adf", {
        get: function () {
            return this.get_adf();
        },
        set: function (a) {
            this.set_adf(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aef", {
        get: function () {
            return this.aec;
        },
        set: function (a) {
            var b = this.aef;
            if (a != b) {
                this.aec = a;
                this.t5("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.aef));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aeg", {
        get: function () {
            return this.aed;
        },
        set: function (a) {
            var b = this.aeg;
            if (a != b) {
                this.aed = a;
                this.t5("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.aeg));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aek", {
        get: function () {
            return this.aei;
        },
        set: function (a) {
            var b = this.aek;
            if (a != b) {
                this.aei = a;
                this.t5("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.aek));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ael", {
        get: function () {
            return this.aej;
        },
        set: function (a) {
            var b = this.ael;
            if (a != b) {
                this.aej = a;
                this.t5("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ael));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_x0 = function () {
        return this.xz;
    };
    XYChart.prototype.set_x0 = function (a) {
        var b = this.x0;
        if (a != b) {
            this.xz = a;
            this.t5("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.x0));
        }
    };
    Object.defineProperty(XYChart.prototype, "x0", {
        get: function () {
            return this.get_x0();
        },
        set: function (a) {
            this.set_x0(a);
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_xy = function () {
        return this.xx;
    };
    XYChart.prototype.set_xy = function (a) {
        var b = this.xy;
        if (a != b) {
            this.xx = a;
            this.t5("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.xy));
        }
    };
    Object.defineProperty(XYChart.prototype, "xy", {
        get: function () {
            return this.get_xy();
        },
        set: function (a) {
            this.set_xy(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aap", {
        get: function () {
            return this.z9;
        },
        set: function (a) {
            var b = this.z9;
            if (a != b) {
                this.z9 = a;
                this.t5("XAxisLabelFormat", b, this.z9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xn", {
        get: function () {
            return this.xl;
        },
        set: function (a) {
            var b = this.xl;
            if (a != b) {
                this.xl = a;
                this.t5("XAxisLabelFormatSpecifiers", b, this.xl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abu", {
        get: function () {
            return this.aad;
        },
        set: function (a) {
            var b = this.aad;
            if (a != b) {
                this.aad = a;
                this.t5("YAxisLabelFormat", b, this.aad);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xo", {
        get: function () {
            return this.xm;
        },
        set: function (a) {
            var b = this.xm;
            if (a != b) {
                this.xm = a;
                this.t5("YAxisLabelFormatSpecifiers", b, this.xm);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
