import { IgrSeries } from "./igr-series";
/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
var IgrChartCursorEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrChartCursorEventArgs() {
        this.mounted = false;
    }
    Object.defineProperty(IgrChartCursorEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrChartCursorEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrChartCursorEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrChartCursorEventArgs.prototype, "item", {
        /**
         * Gets the ItemsSource item associated with the current event.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrChartCursorEventArgs.prototype, "series", {
        /**
         * Gets the series associated with the current event.
        */
        get: function () {
            var r = this.i.series;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrSeries._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrChartCursorEventArgs.prototype, "seriesViewer", {
        /**
         * Gets the Chart associated with the current event.
        */
        get: function () {
            var r = this.i.seriesViewer;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.seriesViewer = null : this.i.seriesViewer = v.i;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Provides a human readable expresion of the event arguments.
    
    */
    IgrChartCursorEventArgs.prototype.toString = function () {
        var iv = this.i.toString();
        return (iv);
    };
    return IgrChartCursorEventArgs;
}());
export { IgrChartCursorEventArgs };
