import { __extends } from "tslib";
import { TreemapNodeStyleMappingTargetType_$type } from "./TreemapNodeStyleMappingTargetType";
import { TreemapValueMappingMode_$type } from "./TreemapValueMappingMode";
import { IgrTreemapNodeStyle } from "./igr-treemap-node-style";
import { TreemapNodeStyleMapping } from "./TreemapNodeStyleMapping";
import { ensureEnum } from "igniteui-react-core";
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
var IgrTreemapNodeStyleMapping = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTreemapNodeStyleMapping, _super);
    function IgrTreemapNodeStyleMapping(props) {
        return _super.call(this, props) || this;
    }
    IgrTreemapNodeStyleMapping.prototype.createImplementation = function () {
        return new TreemapNodeStyleMapping();
    };
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "targetType", {
        /**
         * Gets or sets the unique name of the mapping.
        */
        get: function () {
            return this.i.bo;
        },
        set: function (v) {
            this.i.bo = ensureEnum(TreemapNodeStyleMappingTargetType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "name", {
        /**
         * Gets or sets the unique name of the mapping.
        */
        get: function () {
            return this.i.b1;
        },
        set: function (v) {
            this.i.b1 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "minimumValue", {
        /**
         * Gets or sets the minimum value to which the mapping applies.
        */
        get: function () {
            return this.i.bu;
        },
        set: function (v) {
            this.i.bu = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "maximumValue", {
        /**
         * Gets or sets the maximum value to which the mapping applies.
        */
        get: function () {
            return this.i.bt;
        },
        set: function (v) {
            this.i.bt = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "value", {
        /**
         * Gets or sets the value to which the mapping applies.
        */
        get: function () {
            return this.i.bw;
        },
        set: function (v) {
            this.i.bw = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "mappingMode", {
        /**
         * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
        */
        get: function () {
            return this.i.bq;
        },
        set: function (v) {
            this.i.bq = ensureEnum(TreemapValueMappingMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrTreemapNodeStyleMapping;
}(IgrTreemapNodeStyle));
export { IgrTreemapNodeStyleMapping };
