import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private yz;
    get y0(): IAnchoredCategorySeriesInteractionManager;
    yv: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    lj(): string;
    protected ci(): SeriesView;
    px(a: SeriesView): void;
    y4: boolean;
    constructor();
    zl: string;
    j5(a: any, b: string): any;
    li(a: string): string;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private y1;
    zd: string;
    zh: string;
    zj: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get z8(): Brush;
    set z8(a: Brush);
    static readonly zu: DependencyProperty;
    trendLineThickness: number;
    aaa: PenLineCap;
    z9: DoubleCollection;
    trendLinePeriod: number;
    y8: number;
    fx(a: any): boolean;
    protected ys(a: number, b: number, c: Axis): any[];
    protected p5(a: any, b: string, c: any, d: any): void;
    aq(a: Axis): AxisRange;
    protected oc(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected x2(): number;
    y7(a: CategorySeriesView): number;
    zr(a: PointCollection, b: number, c: CategorySeriesView): void;
    yt(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    yu(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    protected fv(): boolean;
    protected hb(): List$1<SeriesLayerPropertyOverlay>;
    private zn;
    gw(a: Rect, b: Rect, c: SeriesView): boolean;
    n7(a: boolean, b: SeriesView): void;
    yi(a: CategoryFrame, b: CategorySeriesView): void;
    yl(a: CategoryFrame, b: CategorySeriesView): void;
    yw: CategoryFrame;
    ql(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    zo(a: CategoryFrame, b: CategorySeriesView): void;
    protected ra(): void;
    j9(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected zb: string;
    protected za: string;
    abstract zp(a: Axis): void;
    abstract zq(a: Axis): void;
    protected ow(a: any): void;
    yx: CategorySeriesMarkerCollisionAvoidance;
    j2(a: Point): any;
    yy: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    id(): number;
    protected get_y9(): number;
    protected get y9(): number;
    ar(a: Rect): AxisRange;
    private zt;
    private y3;
    private y5;
    y6: number;
    private zs;
    ip(a: ValueLayerValueMode, b: Axis): number;
    am(a: ValueLayerValueMode): number[];
    ux(a: ValueLayerValueMode): Point;
    uy(a: number[]): Point;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c3: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c4;
    get c5(): ITrendLineManager;
    set c5(a: ITrendLineManager);
    get c6(): boolean;
    da(): void;
    c8(): void;
    c7(): void;
    cv(): CategoryBucketCalculator;
    c9(): void;
    db(): void;
    dc(a: number): Rect;
    protected a7(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
