import { Base, Type, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategoryMode } from "./CategoryMode";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Pool$1 } from "igniteui-react-core";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { TransitionOutSpeedType } from "./TransitionOutSpeedType";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    private i;
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    private s;
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected get q(): List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected abstract j(a: PreparationParams): ValuesHolder;
}
/**
 * @hidden
 */
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    private aa;
    private ab;
    protected ac: IHasCategoryTrendline;
    protected ad: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    protected j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
}
/**
 * @hidden
 */
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    static $t: Type;
    w7: CategoryFramePreparer;
    protected ci(): SeriesView;
    xb: CategorySeriesView;
    private xf;
    get xg(): ICategorySeriesInteractionManager;
    dz(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    private x7;
    px(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get categoryAxis(): CategoryAxisBase;
    w1(): CategoryAxisBase;
    xh(): NumericAxisBase;
    protected get_d6(): boolean;
    protected get_fq(): boolean;
    protected get_ej(): boolean;
    constructor();
    ac(): void;
    xs: boolean;
    xr: boolean;
    protected xo: boolean;
    protected xn: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    xu(): boolean;
    protected xv(): boolean;
    protected yk(a: AssigningCategoryStyleEventArgs): void;
    protected yj(a: AssigningCategoryMarkerStyleEventArgs): void;
    wv(a: number, b: number): any[];
    n7(a: boolean, b: SeriesView): void;
    bi(): SeriesComponentsForView;
    o6(): void;
    xy: boolean;
    protected rk(a: Rect, b: Rect): void;
    xd: CategoryTransitionInMode;
    xt: boolean;
    protected rj(a: Rect, b: Rect): void;
    protected p5(a: any, b: string, c: any, d: any): void;
    protected xq(): boolean;
    protected xp(): boolean;
    x1(a: Point): number;
    protected get_fd(): boolean;
    as(): CategoryAxisBase;
    jl(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    j2(a: Point): any;
    jj(a: Point): number;
    h6(a: Point): number;
    private xl;
    private xm;
    c7(a: any, b: Point, c: boolean): HighlightingInfo;
    protected get_ez(): boolean;
    n5(): void;
    c6(a: any, b: Point, c: boolean): HighlightingInfo;
    protected x0(): List$1<Marker>;
    protected xk(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected xj(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected xi(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    w4: CategoryFrame;
    w6: CategoryFrame;
    w2: CategoryFrame;
    w5: CategoryFrame;
    w3(): CategoryFrame;
    xa: CategorySeriesRenderManager;
    protected yg(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean, g: number): void;
    yh(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean, g: number): void;
    gw(a: Rect, b: Rect, c: SeriesView): boolean;
    private xz;
    protected f7(): boolean;
    protected f8(): boolean;
    protected xc(): CategoryTransitionInMode;
    xe: CategoryTransitionSourceFramePreparer;
    protected n8(): void;
    qn(a: boolean): void;
    protected cu(): TransitionInSpeedType;
    protected cx(): TransitionOutSpeedType;
    protected x2(): number;
    protected xw(): boolean;
    protected hb(): List$1<SeriesLayerPropertyOverlay>;
    j7(): any;
    x6(): number;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    yf(a: CategorySeriesView, b: CategoryFrame): void;
    yl(a: CategoryFrame, b: CategorySeriesView): void;
    yi(a: CategoryFrame, b: CategorySeriesView): void;
    x3(a: SeriesView): number;
    x4(a: SeriesView): number;
    x5(a: SeriesView): number;
    ye(a: SeriesView): void;
    qo(a: Rect, b: RenderSurface): void;
    ym(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract xx(): boolean;
    w8(a: CategorySeriesView): CategoryFramePreparer;
    ao(a: Axis): Axis;
    ag(): Axis[];
    static ww(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    static $t: Type;
    cw: CategorySeries;
    cz: number;
    cy(a: CategoryFrame): boolean;
    c1(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    cu: CategoryBucketCalculator;
    cv(): CategoryBucketCalculator;
    cx: Pool$1<Marker>;
    get shouldDisplayMarkers(): boolean;
    updateMarkerCount(a: number): void;
    ci(a: (arg1: Marker) => void): void;
    c0(): void;
}
