import { Type } from "igniteui-react-core";
/**
 * An enum representing the time range presets on a financial chart range selector.
 */
export declare enum FinancialChartRangeSelectorOption {
    /**
     * Include a preset button for one month in the range selector.
     */
    OneMonth = 0,
    /**
     * Include a preset button for three months in the range selector.
     */
    ThreeMonths = 1,
    /**
     * Include a preset button for six months in the range selector.
     */
    SixMonths = 2,
    /**
     * Include a preset button for year-to-date in the range selector.
     */
    YearToDate = 3,
    /**
     * Include a preset button for one year in the range selector.
     */
    OneYear = 4,
    /**
     * Include a preset button for all data in the range selector.
     */
    All = 5
}
/**
 * @hidden
 */
export declare let FinancialChartRangeSelectorOption_$type: Type;
