import { Type } from "igniteui-react-core";
/**
 * An enum representing the available series types to display in the zoom slider pane.
 */
export declare enum FinancialChartZoomSliderType {
    /**
     * Do not display the zoom slider pane.
     */
    None = 0,
    /**
     * In the zoom slider pane, match the series type in the price pane.
     */
    Auto = 1,
    /**
     * Display financial bar series in the zoom slider pane.
     */
    Bar = 2,
    /**
     * Display candle series in the zoom slider pane.
     */
    Candle = 3,
    /**
     * Display column series in the zoom slider pane.
     */
    Column = 4,
    /**
     * Display line series in the zoom slider pane.
     */
    Line = 5,
    /**
     * Display an area series in the zoom slider pane.
     */
    Area = 6
}
/**
 * @hidden
 */
export declare let FinancialChartZoomSliderType_$type: Type;
