import { Type } from "igniteui-react-core";
/**
 * Describes the Selection mode to use for the series in the chart.
 */
export declare enum SeriesSelectionMode {
    /**
     * Selection mode is determined by the component.
     */
    Auto = 0,
    /**
     * No Selection is defined at the chart level.
     */
    None = 1,
    /**
     * Items will brighten when selected.
     */
    Brighten = 2,
    /**
     * Items other than the selected items will fade.
     */
    FadeOthers = 3,
    /**
     * Items other than the selected items will shift to grayscale.
     */
    GrayscaleOthers = 4,
    /**
     * Items selected will have the focus color as their thick outline.
     */
    FocusColorThickOutline = 5,
    /**
     * Items selected will have the focus color as their outline.
     */
    FocusColorOutline = 6,
    /**
     * Items selected will have the selection color as their thick outline.
     */
    SelectionColorThickOutline = 7,
    /**
     * Items selected will have the selection color as their outline.
     */
    SelectionColorOutline = 8,
    /**
     * Items selected will have the focus color as their fill.
     */
    FocusColorFill = 9,
    /**
     * Items selected will have the selection color as their fill.
     */
    SelectionColorFill = 10,
    /**
     * Items selected will have a thicker outline than the rest.
     */
    ThickOutline = 11
}
/**
 * @hidden
 */
export declare let SeriesSelectionMode_$type: Type;
