import { EventArgs, Base, Type, Point, IList$1, IEnumerable, IEnumerator$1, IEnumerator, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { Series } from "./Series";
import { List$1 } from "igniteui-react-core";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategorySeries } from "./CategorySeries";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { NumericAxisBase } from "./NumericAxisBase";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { Rect } from "igniteui-react-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { SeriesViewer } from "./SeriesViewer";
import { PointCollection } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { IChartLegend } from "igniteui-react-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { RenderSurface } from "./RenderSurface";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Path } from "igniteui-react-core";
import { CategoryMode } from "./CategoryMode";
import { DependencyObject } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Pool$1 } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { IScaler } from "./IScaler";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { NumericXAxis } from "./NumericXAxis";
import { CategoryYAxis } from "./CategoryYAxis";
import { AnchoredCategoryBucketCalculator } from "./AnchoredCategoryBucketCalculator";
import { SplineSeriesBase } from "./SplineSeriesBase";
import { CollisionAvoider } from "./CollisionAvoider";
import { ICategoryScaler } from "./ICategoryScaler";
import { IBucketizer } from "./IBucketizer";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { IBarSeries } from "./IBarSeries";
import { Color } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { MarkerFillMode } from "./MarkerFillMode";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { SeriesHighlightedValuesDisplayMode } from "./SeriesHighlightedValuesDisplayMode";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { DomRenderer } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ValuesHolder } from "./ValuesHolder";
import { PreparationParams } from "./PreparationParams";
import { RenderingContext } from "igniteui-react-core";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { Canvas } from "igniteui-react-core";
import { Panel } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class StackedSeriesCreatedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: StackedFragmentSeries);
    c: StackedFragmentSeries;
    get brush(): Brush;
    set brush(a: Brush);
    get legendItemTemplate(): DataTemplate;
    set legendItemTemplate(a: DataTemplate);
    get legendItemBadgeTemplate(): DataTemplate;
    set legendItemBadgeTemplate(a: DataTemplate);
    get legendItemVisibility(): Visibility;
    set legendItemVisibility(a: Visibility);
    get outline(): Brush;
    set outline(a: Brush);
    get dashArray(): DoubleCollection;
    set dashArray(a: DoubleCollection);
    get dashCap(): PenLineCap;
    set dashCap(a: PenLineCap);
    get index(): number;
    get thickness(): number;
    set thickness(a: number);
    get title(): any;
    set title(a: any);
    get transitionDuration(): number;
    set transitionDuration(a: number);
    get transitionEasingFunction(): (time: number) => number;
    set transitionEasingFunction(a: (time: number) => number);
    get markerBrush(): Brush;
    set markerBrush(a: Brush);
    get markerOutline(): Brush;
    set markerOutline(a: Brush);
    get markerStyle(): Style;
    set markerStyle(a: Style);
    get markerTemplate(): DataTemplate;
    set markerTemplate(a: DataTemplate);
    get markerType(): MarkerType;
    set markerType(a: MarkerType);
    get markerThickness(): number;
    set markerThickness(a: number);
    get lineCap(): PenLineCap;
    set lineCap(a: PenLineCap);
}
/**
 * @hidden
 */
export declare abstract class FragmentBase extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    constructor();
    aav: CategoryLineRasterizer;
    private _logicalSeriesLink;
    get logicalSeriesLink(): StackedFragmentSeries;
    set logicalSeriesLink(a: StackedFragmentSeries);
    private aax;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    protected get_eq(): boolean;
    protected get_ew(): boolean;
    mg(): string;
    ji(): number;
    protected o5(a: Series): void;
    jn(): number;
    resolveLegendIndex(): number;
    bg(): Series;
    w1(): CategoryAxisBase;
    aau(): CategoryFramePreparer;
    xh(): NumericAxisBase;
    aaz(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    yi(a: CategoryFrame, b: CategorySeriesView): void;
    uu(a: Point, b: boolean, c: boolean): Point;
    ag(): Axis[];
    private aa0;
    aa2(a: PointCollection, b: List$1<number[]>, c: CategorySeriesView): void;
    gw(a: Rect, b: Rect, c: SeriesView): boolean;
    y7(a: CategorySeriesView): number;
    aq(a: Axis): AxisRange;
    aa1(): number;
    aa3(a: IChartLegend): void;
    protected p5(a: any, b: string, c: any, d: any): void;
    qo(a: Rect, b: RenderSurface): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragment extends FragmentBase {
    static $t: Type;
    protected bb(): Series;
    constructor();
    protected ci(): SeriesView;
    aa4: AreaFragmentView;
    px(a: SeriesView): void;
    protected get_eg(): boolean;
    protected get_ef(): boolean;
    protected xc(): CategoryTransitionInMode;
    protected aa6(a: Point, b: boolean): boolean;
    gf(a: Point, b: boolean): boolean;
    private aa5;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    n7(a: boolean, b: SeriesView): void;
    yl(a: CategoryFrame, b: CategorySeriesView): void;
    q6(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class ColumnFragment extends FragmentBase {
    static $t: Type;
    protected bb(): Series;
    protected get_ek(): boolean;
    protected get_e6(): boolean;
    protected i0(): number;
    protected xc(): CategoryTransitionInMode;
    constructor();
    protected ci(): SeriesView;
    aa5: ColumnFragmentView;
    px(a: SeriesView): void;
    aa8: number;
    aa9: number;
    get fragmentXAxis(): CategoryAxisBase;
    get fragmentYAxis(): NumericAxisBase;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    w1(): CategoryAxisBase;
    xh(): NumericAxisBase;
    protected get_d1(): boolean;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    n7(a: boolean, b: SeriesView): void;
    aq(a: Axis): AxisRange;
    gw(a: Rect, b: Rect, c: SeriesView): boolean;
    gt(): boolean;
    x3(a: SeriesView): number;
    x4(a: SeriesView): number;
    x5(a: SeriesView): number;
    u5(a: Point): Rect;
    gf(a: Point, b: boolean): boolean;
    protected gi(a: Point, b: boolean): boolean;
    protected abe(a: Rect, b: number): Rect;
    j9(a: any, b: Point): any;
    j2(a: Point): any;
    jl(a: Point): number;
    jj(a: Point): number;
    aaz(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    private aa7;
    ql(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    yi(a: CategoryFrame, b: CategorySeriesView): void;
    yl(a: CategoryFrame, b: CategorySeriesView): void;
    protected p5(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BarFragment extends ColumnFragment {
    static $t: Type;
    constructor();
    protected get_ei(): boolean;
    protected get_e6(): boolean;
    protected get_ek(): boolean;
    protected xc(): CategoryTransitionInMode;
    get barFragmentXAxis(): NumericXAxis;
    get barFragmentYAxis(): CategoryYAxis;
    w1(): CategoryAxisBase;
    protected get_isVertical(): boolean;
    h6(a: Point): number;
    xh(): NumericAxisBase;
    protected abe(a: Rect, b: number): Rect;
    u5(a: Point): Rect;
    gf(a: Point, b: boolean): boolean;
    aaz(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    j2(a: Point): any;
    jl(a: Point): number;
    y7(a: CategorySeriesView): number;
    protected p5(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class LineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class SplineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class StackedBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class StackedBarBucketCalculator extends StackedBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    g(a: number): void;
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class StackedColumnBucketCalculator extends StackedBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class FragmentBaseValueList extends Base implements IList$1<number> {
    static $t: Type;
    private a;
    constructor(a: FragmentBase);
    indexOf(a: number): number;
    insert(a: number, b: number): void;
    removeAt(a: number): void;
    item(a: number, b?: number): number;
    add(a: number): void;
    clear(): void;
    contains(a: number): boolean;
    copyTo(a: number[], b: number): void;
    get count(): number;
    get isReadOnly(): boolean;
    remove(a: number): boolean;
    getEnumerator(): IEnumerator$1<number>;
    getEnumeratorObject(): IEnumerator;
}
/**
 * @hidden
 */
export declare class LineFragment extends FragmentBase {
    static $t: Type;
    protected bb(): Series;
    protected get_e5(): boolean;
    protected xw(): boolean;
    constructor();
    protected ci(): SeriesView;
    aa4: LineFragmentView;
    px(a: SeriesView): void;
    protected aa6(a: Point, b: boolean): boolean;
    protected get_eg(): boolean;
    gf(a: Point, b: boolean): boolean;
    private aa5;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    n7(a: boolean, b: SeriesView): void;
    yl(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare abstract class SplineFragmentBase extends SplineSeriesBase {
    static $t: Type;
    private _logicalSeriesLink;
    get logicalSeriesLink(): StackedFragmentSeries;
    set logicalSeriesLink(a: StackedFragmentSeries);
    abe: CategoryLineRasterizer;
    constructor();
    private abg;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    protected o5(a: Series): void;
    protected get_eq(): boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected get_ew(): boolean;
    mg(): string;
    uu(a: Point, b: boolean, c: boolean): Point;
    ag(): Axis[];
    private abi;
    ji(): number;
    resolveLegendIndex(): number;
    jn(): number;
    bg(): Series;
    aa0(a: CategoryFrame, b: number[], c: CollisionAvoider, d: number, e: number, f: CategorySeriesView, g: number): boolean;
    gw(a: Rect, b: Rect, c: SeriesView): boolean;
    aq(a: Axis): AxisRange;
    abj(a: CategoryFrame, b: Rect, c: Rect, d: CategoryAxisBase, e: NumericYAxis, f: CategorySeriesView): void;
    yi(a: CategoryFrame, b: CategorySeriesView): void;
    aau(a: CategorySeriesView): number[][];
    aav(a: CategorySeriesView): number[][];
    aa9(a: CategorySeriesView): void;
    protected p5(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineAreaFragment extends SplineFragmentBase {
    static $t: Type;
    protected bb(): Series;
    constructor();
    protected ci(): SeriesView;
    px(a: SeriesView): void;
    private abk;
    ac(): void;
    protected get_eg(): boolean;
    protected get_ef(): boolean;
    protected get_fl(): boolean;
    protected xc(): CategoryTransitionInMode;
    protected abm(a: Point, b: boolean): boolean;
    gf(a: Point, b: boolean): boolean;
    private abl;
    abo: PointCollection;
    n7(a: boolean, b: SeriesView): void;
    yl(a: CategoryFrame, b: CategorySeriesView): void;
    qo(a: Rect, b: RenderSurface): void;
    abn(a: PointCollection, b: List$1<number[]>, c: CategorySeriesView): void;
    y7(a: CategorySeriesView): number;
    q6(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineFragment extends SplineFragmentBase {
    static $t: Type;
    protected bb(): Series;
    protected get_fl(): boolean;
    protected xw(): boolean;
    constructor();
    protected ci(): SeriesView;
    abk: SplineFragmentView;
    px(a: SeriesView): void;
    protected abm(a: Point, b: boolean): boolean;
    protected get_eg(): boolean;
    gf(a: Point, b: boolean): boolean;
    private abl;
    n7(a: boolean, b: SeriesView): void;
    yl(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineFragmentBaseValueList extends Base implements IList$1<number> {
    static $t: Type;
    private a;
    constructor(a: SplineFragmentBase);
    indexOf(a: number): number;
    insert(a: number, b: number): void;
    removeAt(a: number): void;
    item(a: number, b?: number): number;
    add(a: number): void;
    clear(): void;
    contains(a: number): boolean;
    copyTo(a: number[], b: number): void;
    get count(): number;
    get isReadOnly(): boolean;
    remove(a: number): boolean;
    getEnumerator(): IEnumerator$1<number>;
    getEnumeratorObject(): IEnumerator;
}
/**
 * @hidden
 */
export declare abstract class StackedSeriesBase extends CategorySeries implements IIsCategoryBased {
    static $t: Type;
    constructor();
    pc(): void;
    protected get_ez(): boolean;
    getHostReferenceValue(): number;
    protected ci(): SeriesView;
    y2: StackedSeriesView;
    px(a: SeriesView): void;
    py(a: Rect, b: Rect): void;
    private _series;
    get series(): StackedSeriesCollection;
    set series(a: StackedSeriesCollection);
    js(): number;
    o0(a: (arg1: Series) => boolean): void;
    y3: boolean;
    y5: boolean;
    protected get_isStacked(): boolean;
    seriesCreated: (sender: any, e: StackedSeriesCreatedEventArgs) => void;
    zs: Visibility;
    zb: number;
    za: number;
    ys: number[];
    yt: number[];
    private y0;
    get y1(): StackedSeriesManager;
    set y1(a: StackedSeriesManager);
    yx: StackedSeriesCollection;
    get yw(): StackedSeriesCollection;
    private zh;
    private zn;
    private zm;
    qz(a: Point): void;
    w8(a: CategorySeriesView): CategoryFramePreparer;
    yi(a: CategoryFrame, b: CategorySeriesView): void;
    qn(a: boolean): void;
    protected get_gd(): boolean;
    n7(a: boolean, b: SeriesView): void;
    zi(): void;
    zo(): void;
    protected get_y4(): boolean;
    get y4(): boolean;
    fx(a: any): boolean;
    aq(a: Axis): AxisRange;
    vr(): boolean;
    protected oc(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    yv(): CategorySeriesView;
    y8(): number;
    y9(): number;
    zd(a: StackedFragmentSeries): number;
    zc(a: Point): number;
    y6(a: AnchoredCategorySeries, b: Rect, c: Rect, d: SeriesView): boolean;
    private y7;
    zj(): void;
    yl(a: CategoryFrame, b: CategorySeriesView): void;
    zl(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ar(a: Rect): AxisRange;
    qq(): void;
    protected zk(): void;
    protected p5(a: any, b: string, c: any, d: any): void;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    protected f7(): boolean;
    protected get_eq(): boolean;
    qo(a: Rect, b: RenderSurface): void;
    yu: CategoryFrame;
    ql(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    j1(): any;
    get mayContainUnknowns(): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalStackedSeriesBase extends StackedSeriesBase {
    static $t: Type;
    xAxis: CategoryAxisBase;
    protected get_d6(): boolean;
    protected get_fq(): boolean;
    ca(): SeriesPlotAreaMarginHorizontalMode;
    cb(): SeriesPlotAreaMarginVerticalMode;
    yAxis: NumericYAxis;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    ag(): Axis[];
    xx(): boolean;
    q6(): void;
    protected p5(a: any, b: string, c: any, d: any): void;
    zw(a: any): boolean;
    zv(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedAreaSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected bb(): Series;
    protected get_ef(): boolean;
    constructor();
    ac(): void;
    protected ci(): SeriesView;
    z1: StackedAreaSeriesView;
    px(a: SeriesView): void;
    aq(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare abstract class VerticalStackedSeriesBase extends StackedSeriesBase {
    static $t: Type;
    xAxis: NumericXAxis;
    yAxis: CategoryYAxis;
    w1(): CategoryAxisBase;
    xh(): NumericAxisBase;
    ca(): SeriesPlotAreaMarginHorizontalMode;
    cb(): SeriesPlotAreaMarginVerticalMode;
    ar(a: Rect): AxisRange;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    protected get_isVertical(): boolean;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    xx(): boolean;
    protected p5(a: any, b: string, c: any, d: any): void;
    zw(a: any): boolean;
    zv(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedBarSeries extends VerticalStackedSeriesBase implements IBarSeries {
    static $t: Type;
    protected bb(): Series;
    protected get_ei(): boolean;
    protected get_e6(): boolean;
    protected i0(): number;
    constructor();
    ac(): void;
    protected ci(): SeriesView;
    z1: StackedBarSeriesView;
    px(a: SeriesView): void;
    z2: number;
    z3: number;
    yv(): CategorySeriesView;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    x6(): number;
    y8(): number;
    y9(): number;
    aq(a: Axis): AxisRange;
    fx(a: any): boolean;
    gw(a: Rect, b: Rect, c: SeriesView): boolean;
    protected oc(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    jj(a: Point): number;
    j2(a: Point): any;
    zo(): void;
    zc(a: Point): number;
    y6(a: AnchoredCategorySeries, b: Rect, c: Rect, d: SeriesView): boolean;
    ib(): number;
    zl(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    protected p5(a: any, b: string, c: any, d: any): void;
    getPreferredCategoryMode(): CategoryMode;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedColumnSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected bb(): Series;
    protected get_ek(): boolean;
    protected get_e6(): boolean;
    protected i0(): number;
    constructor();
    protected ci(): SeriesView;
    z1: StackedColumnSeriesView;
    px(a: SeriesView): void;
    z2: number;
    z3: number;
    yv(): CategorySeriesView;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    aq(a: Axis): AxisRange;
    ib(): number;
    zl(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    protected p5(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSplineAreaSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected bb(): Series;
    z2: boolean;
    protected i0(): number;
    protected get_ef(): boolean;
    protected get_fl(): boolean;
    constructor();
    ac(): void;
    protected ci(): SeriesView;
    z1: StackedSplineAreaSeriesView;
    px(a: SeriesView): void;
    aq(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected p5(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSplineSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected bb(): Series;
    z2: boolean;
    protected get_fl(): boolean;
    protected i0(): number;
    constructor();
    ac(): void;
    protected ci(): SeriesView;
    z1: StackedSplineSeriesView;
    px(a: SeriesView): void;
    aq(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedFragmentSeries extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    itemsSource: IEnumerable;
    highlightedItemsSource: IEnumerable;
    kz: Brush;
    ku: Brush;
    k8: DoubleCollection;
    k7: DoubleCollection;
    lb: PenLineCap;
    k9: PenLineCap;
    au: boolean;
    al: boolean;
    b1: number;
    bi: number;
    k6: Color;
    k5: Color;
    a4: boolean;
    ar: boolean;
    b2: number;
    bj: number;
    b3: number;
    bk: number;
    lc: PenLineCap;
    la: PenLineCap;
    av: boolean;
    am: boolean;
    hq: DataTemplate;
    hn: DataTemplate;
    hr: DataTemplate;
    ho: DataTemplate;
    lu: Visibility;
    ls: Visibility;
    r: LegendItemBadgeShape;
    p: LegendItemBadgeMode;
    q: LegendItemBadgeShape;
    o: LegendItemBadgeMode;
    k0: Brush;
    kv: Brush;
    k1: Brush;
    kw: Brush;
    lr: Style;
    lq: Style;
    hs: DataTemplate;
    hp: DataTemplate;
    x: MarkerType;
    w: MarkerType;
    t: MarkerFillMode;
    s: MarkerFillMode;
    v: MarkerOutlineMode;
    u: MarkerOutlineMode;
    e0: string;
    by: number;
    bf: number;
    k2: Brush;
    kx: Brush;
    k3: Brush;
    ky: Brush;
    bm: number;
    bb: number;
    bw: number;
    bd: number;
    ab: SeriesOutlineMode;
    aa: SeriesOutlineMode;
    bv: number;
    bc: number;
    z: SeriesHighlightedValuesDisplayMode;
    bz: number;
    bg: number;
    an: boolean;
    aw: boolean;
    b0: number;
    bh: number;
    b4: number;
    bl: number;
    bx: number;
    be: number;
    cj: any;
    ck: any;
    cf: any;
    ai: (time: number) => number;
    cd: number;
    ce: number;
    aj: (time: number) => number;
    n: CategoryTransitionInMode;
    ax: boolean;
    ae: TransitionInSpeedType;
    ao: boolean;
    b7: number;
    m: CategoryTransitionInMode;
    ad: TransitionInSpeedType;
    ah: (time: number) => number;
    ag: (time: number) => number;
    b6: number;
    a3: boolean;
    aq: boolean;
    a2: boolean;
    ap: boolean;
    ft: string;
    fp: string;
    fr: string;
    d0: string;
    d2: string;
    cg(a: number, b: number): any;
    eb(): string;
    d9: string;
    ed: string;
    cp: string;
    cr: string;
    lv: Visibility;
    lt: Visibility;
    private _parentSeries;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    cc: number;
    af: SeriesViewer;
    ak: IFastItemColumn$1<number>;
    private _visualSeriesLink;
    get visualSeriesLink(): AnchoredCategorySeries;
    set visualSeriesLink(a: AnchoredCategorySeries);
    a7: List$1<number>;
    a8: List$1<number>;
    a6: List$1<number[]>;
    az: boolean;
    b8(a: Point): number;
    ch(a: Point): any;
    cb(a: Point, b: boolean): number;
    ca(a: Point, b: boolean): number;
    bt(a: Point, b: boolean, c: boolean): number;
    li(a: Point, b: boolean, c: boolean): Point;
    lm(a: Point): Rect;
    j(a: Point): Rect[];
    ln(a: Point): Rect;
    k(a: Point): Rect[];
    lo(a: Point): Rect;
    lp(a: Point): Rect;
    bp(a: Point, b: boolean, c: boolean): number;
    le(a: Point, b: boolean, c: boolean): Point;
    br(a: Point, b: boolean, c: boolean): number;
    lg(a: Point, b: boolean, c: boolean): Point;
    lj(a: Point, b: boolean, c: boolean): Point;
    bu(a: Point, b: boolean, c: boolean): number;
    lf(a: Point, b: boolean, c: boolean): Point;
    bq(a: Point, b: boolean, c: boolean): number;
    lh(a: Point, b: boolean, c: boolean): Point;
    bs(a: Point, b: boolean, c: boolean): number;
    b9(a: Point): number;
    bo(): number;
    bn(a: Point): number;
    ci(a: Point): any;
    as(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    lk(a: Point): Point;
    ld(a: Point): Point;
    a0(a: any): boolean;
    ll(): Rect;
    fx(): void;
    f2(a: Point): void;
    a1(a: Point, b: boolean): boolean;
    fw(a: Point): void;
    b5: DomRenderer;
    provideRenderer(a: DomRenderer): void;
    k4: Brush;
    hm(): void;
    gu(): void;
    gw(): void;
    f4(): void;
    f5(): void;
    gb(): void;
    ga(): void;
    g0(): void;
    gq(): void;
    f6(): void;
    gc(): void;
    g3(): void;
    g4(): void;
    hi(): void;
    g5(): void;
    g6(): void;
    gd(): void;
    gj(): void;
    gk(): void;
    gl(): void;
    gi(): void;
    gh(): void;
    go(): void;
    gr(): void;
    gt(): void;
    gx(): void;
    gy(): void;
    gz(): void;
    gg(): void;
    f9(): void;
    f3(): void;
    ge(): void;
    g1(): void;
    g2(): void;
    gm(): void;
    g7(): void;
    gn(): void;
    gv(): void;
    g9(): void;
    hb(): void;
    ha(): void;
    hd(): void;
    he(): void;
    hf(): void;
    gf(): void;
    hc(): void;
    hh(): void;
    g8(): void;
    gp(): void;
    gs(): void;
    hg(): void;
    hk(): void;
    hj(): void;
    f7(): void;
    f8(): void;
    hl(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected f0(a: string, b: any, c: any): void;
    private a5;
    private at;
    private ay;
    protected fy(a: any, b: string, c: any, d: any): void;
    f1(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSeriesCollection extends ObservableCollection$1<StackedFragmentSeries> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesFramePreparer extends CategoryFramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    protected j(a: PreparationParams): ValuesHolder;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    dd: AreaFragment;
    au(): void;
    constructor(a: AreaFragment);
    dj: Path;
    dl: Path;
    dk: Path;
    dm: Path;
    df: Path;
    dh: Path;
    dg: Path;
    di: Path;
    de(): void;
    cv(): CategoryBucketCalculator;
    protected bd(): void;
    protected be(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    an(a: any): void;
}
/**
 * @hidden
 */
export declare class ColumnFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    dd: ColumnFragment;
    au(): void;
    constructor(a: ColumnFragment);
    protected dh: List$1<Rectangle>;
    de: Pool$1<Rectangle>;
    df: List$1<number>;
    dg: List$1<number>;
    private dn;
    private di;
    private dk;
    private dj;
    protected bg(a: any, b: number): void;
    dl(a: Rectangle, b: number, c: number): void;
    protected bh(a: any, b: number): void;
    protected ac(a: number): any;
    private dm;
    protected ab(a: number): any;
    protected a8(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    an(a: any): void;
    getDefaultTooltipTemplate(): string;
}
/**
 * @hidden
 */
export declare class LineFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    dd: LineFragment;
    constructor(a: LineFragment);
    dj: Path;
    di: Path;
    dk: Path;
    dg: Path;
    df: Path;
    dh: Path;
    de(): void;
    cv(): CategoryBucketCalculator;
    protected bd(): void;
    protected be(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    an(a: any): void;
}
/**
 * @hidden
 */
export declare class SplineAreaFragmentView extends SplineSeriesBaseView {
    static $t: Type;
    private df;
    au(): void;
    constructor(a: SplineAreaFragment);
    dl: Path;
    dn: Path;
    dm: Path;
    dp: Path;
    dh: Path;
    dj: Path;
    di: Path;
    dk: Path;
    dg(): void;
    protected bd(): void;
    protected be(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    an(a: any): void;
}
/**
 * @hidden
 */
export declare class SplineFragmentView extends SplineSeriesBaseView {
    static $t: Type;
    df: SplineFragment;
    constructor(a: SplineFragment);
    cv(): CategoryBucketCalculator;
    dl: Path;
    dk: Path;
    dm: Path;
    di: Path;
    dh: Path;
    dj: Path;
    dg(): void;
    protected bd(): void;
    protected be(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    an(a: any): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesView extends CategorySeriesView {
    static $t: Type;
    c3: StackedSeriesBase;
    private readonly c4;
    get c5(): Canvas;
    private readonly c6;
    get c7(): Panel;
    constructor(a: StackedSeriesBase);
    cv(): CategoryBucketCalculator;
    ar(): void;
    at(a: RenderingContext, b: RenderingContext): void;
    protected af(): void;
}
/**
 * @hidden
 */
export declare class StackedBarSeriesView extends StackedSeriesView {
    static $t: Type;
    c8: StackedBarSeries;
    constructor(a: StackedBarSeries);
    cv(): CategoryBucketCalculator;
    au(): void;
}
/**
 * @hidden
 */
export declare class StackedColumnSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedColumnSeries);
    cv(): CategoryBucketCalculator;
    au(): void;
}
/**
 * @hidden
 */
export declare class StackedAreaSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedAreaSeries);
    au(): void;
}
/**
 * @hidden
 */
export declare class StackedSplineAreaSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedSplineAreaSeries);
    au(): void;
    c8(): number;
}
/**
 * @hidden
 */
export declare class StackedSplineSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedSplineSeries);
    au(): void;
    c8(): number;
}
/**
 * @hidden
 */
export declare class StackedSeriesManager extends Base {
    static $t: Type;
    constructor(a: StackedSeriesBase);
    b: StackedSeriesBase;
    f: ObservableCollection$1<AnchoredCategorySeries>;
    c: StackedSeriesCollection;
    e: ObservableCollection$1<AnchoredCategorySeries>;
    d: ObservableCollection$1<AnchoredCategorySeries>;
    k: Canvas;
    l: Panel;
    a(a: StackedFragmentSeries): AnchoredCategorySeries;
    j(): void;
    private i;
    h(a: boolean): void;
    private g;
}
