import { IgrAssigningCategoryStyleEventArgsBase } from "./igr-assigning-category-style-event-args-base";
import { AssigningCategoryMarkerStyleEventArgs as AssigningCategoryMarkerStyleEventArgs_internal } from "./AssigningCategoryMarkerStyleEventArgs";
/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*
* The `assigningCategoryMarkerStyle` event fired to allow you to override the style of markers for the items in a category or financial series. Only fires if you set isCustomCategoryMarkerStyleAllowed to true for a series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrRangeColumnSeries
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
*         highMemberPath="High"
*         lowMemberPath="Low"
* 		IsCustomCategoryMarkerStyleAllowed="true"
* 		assigningCategoryMarkerStyle= {this.onAssigningCategoryMarkerStyle} />
*  </IgrDataChart>
* ```
*
* ```ts
* series1.assigningCategoryMarkerStyle= this.onAssigningCategoryMarkerStyle ;
* public onAssigningCategoryMarkerStyle =( s:IgrCategorySeries, e: AssigningCategoryStyleEventArgs) => {
*
* }
* ```
*/
export declare class IgrAssigningCategoryMarkerStyleEventArgs extends IgrAssigningCategoryStyleEventArgsBase {
    protected createImplementation(): AssigningCategoryMarkerStyleEventArgs_internal;
    /**
                                 * @hidden
                                 */
    get i(): AssigningCategoryMarkerStyleEventArgs_internal;
    constructor();
}
