import { SeriesMatcher as SeriesMatcher_internal } from "./SeriesMatcher";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrSeriesMatcher {
    protected createImplementation(): SeriesMatcher_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): SeriesMatcher_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * If set, tries to match a series based on its name.
    */
    get name(): string;
    set name(v: string);
    /**
     * If set, tries to match a series based on its title.
    */
    get title(): string;
    set title(v: string);
    /**
     * If set, tries to match a series based on index
    */
    get index(): number;
    set index(v: number);
    /**
     * Combined with MemberPath allows you to select a series by member path.
    */
    get memberPathType(): string;
    set memberPathType(v: string);
    /**
     * If set, tries to match a series based on a member path, combined with MemberPathType.
    */
    get memberPath(): string;
    set memberPath(v: string);
    findByName(name: string): any;
}
